/////////////////////////////////////////////////////////////////////////////
// $Header: /cvsroot/mmconvert/mmconvert/MMConvert/Src/Common/Converter.cpp,v 1.6 2005/09/20 09:27:13 ping235 Exp $
//
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 ping235.  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//  This file is subject to the terms of the GNU General Public License as
//  published by the Free Software Foundation.  A copy of this license is
//  included with this software distribution in the file COPYING.  If you
//  do not have a copy, you may obtain a copy by writing to the Free
//  Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
// Change Log
//
// Date          Developer             Changes
// $Date: 2005/09/20 09:27:13 $        $Author: ping235 $              $Name:  $
//
/////////////////////////////////////////////////////////////////////////////
// CVS Log
// $Log: Converter.cpp,v $
// Revision 1.6  2005/09/20 09:27:13  ping235
// changed all IGraphBuilder::ConnectDirect into Connect&added lame mp3 codec option
//
// Revision 1.5  2005/09/08 09:43:18  ping235
// translate MMConvert into english
//
// Revision 1.4  2005/09/05 01:24:57  ping235
// improvement in interactant of UI
// fixed error:lost call OnConvertEnd when exception
// changed status info to the last pane of the status bar
// added overall progress(current count/entired count) functional
// translate unknown exception message to localize language
//
// Revision 1.3  2005/08/22 03:38:33  ping235
// modified exception:added context
//
// Revision 1.2  2005/08/06 10:25:11  ping235
// add CConvertGUI and convert progress
//
// Revision 1.1.1.1  2005/08/02 05:17:16  ping235
// initial,GUI 1.0.0.0,CMD 1.3.0.1
//
//////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Converter.h"
#include "helper.h"
#include "Sounds.h"

CConverter::CConverter()
{
	m_dwROT = 0;
	m_spMediaSeeking = NULL;
	m_bDebug = false;
	m_llFrom = 0;
	m_llTo = 0x7FFFFFFFFFFFFFFF;
	m_llDuration = 0x7FFFFFFFFFFFFFFF;
	m_uTimeStart = 0;
	m_uTimeStop = 0;
	m_hLogFile = INVALID_HANDLE_VALUE;

	//Create GraphBuilder
  HRESULT hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, 
                        IID_IGraphBuilder, (void **)&m_spGraphBuild);
//	HRESULT hr = m_spGraphBuild.CoCreateInstance(CLSID_FilterGraph);
	HANDLE_HR_EXP(hr);
	
	hr = m_spGraphBuild->QueryInterface(IID_IMediaSeeking,(void**)&m_spMediaSeeking);
	HANDLE_HR_EXP(hr);
}

CConverter::~CConverter(void)
{
	//remove from ROT
	if(m_bDebug)
	{
		AfxMessageBox(_T("Filter Graph stopped, will be removed from ROT, Press OK to continue!"));
		RemoveFromROT();
	}

	if(m_hLogFile != INVALID_HANDLE_VALUE)
	{
		::CloseHandle(m_hLogFile);
	}

	m_spGraphBuild = NULL;
	m_spMediaSeeking = NULL;
}

void CConverter::SetLogFile(LPCTSTR lpszFileName)
{
	HRESULT hr = E_FAIL;
	
	//ļ
	if(m_hLogFile==INVALID_HANDLE_VALUE)
	{
		m_hLogFile = ::CreateFile(lpszFileName,GENERIC_WRITE,FILE_SHARE_WRITE,NULL,OPEN_ALWAYS,0,NULL);
		if(m_hLogFile!=INVALID_HANDLE_VALUE)
		{
			hr = m_spGraphBuild->SetLogFile((DWORD_PTR)m_hLogFile);
		}
	}
	HANDLE_HR_EXP(hr);
}

// ȡתõʱʱ䣬λmsδɻתʧʱ0
UINT CConverter::GetTotalConvertTime()
{
	return m_uTimeStop<m_uTimeStart?0xFFFFFFFF-m_uTimeStart+m_uTimeStop:m_uTimeStop-m_uTimeStart;
}
// ȡתõʱ
UINT CConverter::GetNowConvertTime()
{
	return GetIntervalTime(m_uTimeStart);
}

LONGLONG CConverter::GetDuration()
{
	LONGLONG llLen = -1;
	HRESULT hr = m_spMediaSeeking->GetDuration(&llLen);
	HANDLE_HR_EXP(hr);
	return llLen;
}

// תĿʼͽλ
void CConverter::SetPositions(LONGLONG llStart, LONGLONG llStop)
{
	//set convert from and to
	if((llStart!=-1)||(llStop!=-1))
	{
		LONGLONG llLen = 0;
		HRESULT hr = m_spMediaSeeking->GetDuration(&llLen);
		HANDLE_HR_EXP(hr);

		m_llDuration = llLen;

		if(llStart!=-1)
			llStart = LONGLONG(llStart/10000.0*llLen);
		else
			llStart = 0;
		if(llStop!=-1)
			llStop = LONGLONG(llStop/10000.0*llLen);
		else
			llStop = llLen;

		hr = m_spMediaSeeking->SetPositions(&llStart,AM_SEEKING_AbsolutePositioning,&llStop,AM_SEEKING_AbsolutePositioning);
		HANDLE_HR_EXP(hr);
	}

	if((llStart==-1)||(llStop==-1))
	{
		llStart = 0;
		llStop = 0x7FFFFFFFFFFFFFFF;
	}

	m_llFrom = llStart;
	m_llTo = llStop;
}

void CConverter::OnPreConvert(void)
{
}

void CConverter::OnConvertBegin(void)
{
	//ȾʱõʱʽתʱͬĻܻɽʾȷ
	//б
	LONGLONG llPos = 0;
	HRESULT hr = m_spMediaSeeking->GetCurrentPosition(&llPos);
	LONGLONG llDuration = 0;
	hr = m_spMediaSeeking->GetDuration(&llDuration);
	if((llDuration!=0)&&(m_llDuration!=0x7FFFFFFFFFFFFFFF)&&(llDuration!=m_llDuration))
	{
		if(m_llTo!=0x7FFFFFFFFFFFFFFF)
			m_llTo *= llDuration/m_llDuration;
		m_llFrom *= llDuration/m_llDuration;
	}

	//ȡõĵǰλ趨Ĳͬе
	if((llPos!=m_llFrom)&&(llPos!=0))
	{
		m_llFrom = llPos;
	}
}

void CConverter::OnConvertEnd(void)
{
}

// ȥοʱ
void CConverter::DelSyncSource(void)
{
	//cancel timer clock to increase speed
	IMediaFilter* spMediaFilter = NULL;
	HRESULT hr = m_spGraphBuild->QueryInterface(IID_IMediaFilter,(void**)&spMediaFilter);
	HANDLE_HR_EXP(hr);
	hr = spMediaFilter->SetSyncSource(NULL);
	HANDLE_HR_EXP(hr);
}

void CConverter::SetMessagehWnd(HWND MessagehWnd)
{
	m_MessagehWnd=MessagehWnd;
}


bool CConverter::OnUpdateStatus(LONGLONG llPos,LONGLONG llStart,LONGLONG llStop)
{
	HRESULT hr = S_OK;
	LONGLONG llStopTime = llStop;
	
	if(llStop==0x7FFFFFFFFFFFFFFF)
	{
		hr = m_spMediaSeeking->GetDuration(&llStopTime);
		if (hr==E_NOTIMPL) 
		{
			BOOL NoNo=TRUE;
		}
		if (hr==E_POINTER) 
		{
			BOOL NoNo=TRUE;
		}
	}
//	ATLTRACE(Int64ToStr(llPos)+_T("/")+Int64ToStr(llStopTime)+_T("\n"));

	//ȥеľϢ
	const int c_nLineLen = 200;
	char szBS[c_nLineLen+1];
	char szSP[c_nLineLen+1];
	memset(szBS,'\b',sizeof(szBS));
	memset(szSP,' ',sizeof(szSP));
	szBS[c_nLineLen] = 0;
	printf(szBS);

	USES_CONVERSION;
	if(SUCCEEDED(hr)&&(llPos>=llStart))
	{
		//ʾϢ
		if(llPos==llStart)
		{
			_snprintf(szSP,c_nLineLen,"Completed %.2f%%%%, elapsed %s.",
				(llPos-llStart)*100.0/(llStopTime-llStart),
				T2A(FormatTimeSpan(GetNowConvertTime()).GetBuffer(100)));
		}
		else
		{
			UINT uRemainTime = UINT(double(GetNowConvertTime())/(llPos-llStart)*(llStopTime-llPos));
			_snprintf(szSP,c_nLineLen,"Completed %.2f%%%%, elapsed %s, estimated remaining %s.",
				(llPos-llStart)*100.0/(llStopTime-llStart),
				T2A(FormatTimeSpan(GetNowConvertTime()).GetBuffer(100)),
				T2A(FormatTimeSpan(uRemainTime).GetBuffer(100)));
		}
	}
	else
	{
		_snprintf(szSP,c_nLineLen,"Bitte haben Sie ein wenig Geduld, die Datei wird ins WAV-Format konvertiert.\nBentigt: %s.",T2A(FormatTimeSpan(GetNowConvertTime()).GetBuffer(100)));
	}

	szSP[strlen(szSP)] = ' ';
	szSP[c_nLineLen] = 0;
//	printf(szSP);
	*theApp.mp_doc->GetProgressString()=szSP;
	::SendMessage(m_MessagehWnd,WM_USER_SETPROGRESS,0,0);

	bool bRes = llPos<llStop;
	//ESC,ֹͣת
	if(kbhit())
	{
		int nKey = getch();
		if((nKey==0)||(nKey==0xE0))
		{
			nKey = getch();
		}
		if(nKey==27)
			bRes = false;
	}

	return bRes;
}

BOOL CConverter::Convert()
{
	BeginTime();

	OnPreConvert();
	if (!BuildGraph()) return FALSE;

	//this class ensure codes in destructor
	//must be called, no matter if RunGraph throw exception or not
	class _InterLock
	{
		CConverter* m_p;
	public:
		_InterLock(CConverter* p)
		{
			VERIFY(m_p = p);
			m_p->OnConvertBegin();
		};
		~_InterLock()
		{
			m_p->OnConvertEnd();

			//stop time
			m_p->EndTime();
		};
	};
	_InterLock _Lock(this);

		//run filter graph
	HRESULT hr = RunGraph();
	HANDLE_HR_EXP(hr);
	if (FAILED(hr)) return FALSE;
	else return TRUE;
}

HRESULT CConverter::RunGraph()
{
	HRESULT hr;
	//Get Media Control
	IMediaControl* spMC = NULL;
	hr = m_spGraphBuild->QueryInterface(&spMC);
	if(SUCCEEDED(hr))
	{
		if(m_bDebug)
		{
			AfxMessageBox(_T("About to Run Filter Graph, Press OK to continue!"));
		}

		//Run GraphBuilder
		hr = spMC->Run();
		if(SUCCEEDED(hr))
		{
			IMediaEvent* spEvent = NULL;
			hr = m_spGraphBuild->QueryInterface(IID_IMediaEvent, (void **) &spEvent);
			if (SUCCEEDED(hr))
			{
				HANDLE hEvent = NULL;
				hr = spEvent->GetEventHandle((OAEVENT*)&hEvent);
				if (SUCCEEDED(hr))
				{
					DWORD dwRes = WAIT_TIMEOUT;
					do
					{
						if(dwRes == WAIT_TIMEOUT)
						{
							//update progress info
							LONGLONG llPos = 0;
							m_spMediaSeeking->GetCurrentPosition(&llPos);
							if(!OnUpdateStatus(llPos,m_llFrom,m_llTo))
								break;
						}

						//wait event or msg or timeout
						dwRes = ::MsgWaitForMultipleObjectsEx(1,&hEvent,1000,QS_ALLINPUT,0);
						//wait failed
						if(dwRes==WAIT_FAILED)
						{
							hr = HRESULT_FROM_WIN32(::GetLastError());
							ASSERT(FALSE);
							break;
						}
						//event signaled
						else if(dwRes==WAIT_OBJECT_0)
						{
							long lEvCode = 0;
							long lParam1 = 0;
							long lParam2 = 0;// EC_COMPLETE
							hr = spEvent->GetEvent(&lEvCode,&lParam1,&lParam2,INFINITE);
							ASSERT(SUCCEEDED(hr));
							VERIFY(SUCCEEDED(spEvent->FreeEventParams(lEvCode,lParam1,lParam2)));
							if(FAILED(hr))
								break;
							if(SUCCEEDED(hr))
							{
								if((lEvCode==EC_COMPLETE)||(lEvCode==EC_ERRORABORT)||
									(lEvCode==EC_USERABORT))
								{
									break;
								}
							}
						}
						//msg received
						else if(dwRes==WAIT_OBJECT_0+1)
						{
							//process all pending messages
							BOOL bRes = ProcessMessage();
							//if WM_QUIT received
							if(!bRes)
								break;
						}
						//hr = spEvent->WaitForCompletion(1000, &lEvCode);
					}while(TRUE);

					//show final progress info
					LONGLONG llPos = 0;
					m_spMediaSeeking->GetCurrentPosition(&llPos);
					OnUpdateStatus(llPos,m_llFrom,m_llTo);
				}

			}
			else
			{
				TRACE("QI failed for IMediaEvent interface!\n");
			}

			hr = spMC->Stop();
		}
	}

	return hr;
}

// ʼʱ
void CConverter::BeginTime(void)
{
	// ʼʱ
	m_uTimeStop = m_uTimeStart = GetTickCount();
}

// ֹͣʱ
void CConverter::EndTime(void)
{
	m_uTimeStop = GetTickCount();
}

// register ROT,you can show graphics
void CConverter::AddToROT(void)
{
	//Register ROT,you can view graph use graphedit
	if(m_dwROT!=0)
		CDShow::AddToROT(m_spGraphBuild,false,m_dwROT);
}

// remove from ROT
void CConverter::RemoveFromROT(void)
{
	if(m_dwROT!=0)
	{
		CDShow::RemoveFromROT(m_dwROT);
		m_dwROT = 0;
	}
}

// õģʽģʽ£ĵϢ
void CConverter::SetDebugMode(bool bDebug)
{
	m_bDebug = bDebug;
	if(m_bDebug&&(m_spGraphBuild!=NULL))
	{
		CDShow::AddToROT(m_spGraphBuild,false,m_dwROT);
		SetLogFile(GetAppPath()+_T("gb.log"));
	}
}
