/////////////////////////////////////////////////////////////////////////////
// $Header: /cvsroot/mmconvert/mmconvert/MMConvert/Src/Common/DShow.h,v 1.1.1.1 2005/08/02 05:17:18 ping235 Exp $
//
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 ping235.  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//  This file is subject to the terms of the GNU General Public License as
//  published by the Free Software Foundation.  A copy of this license is
//  included with this software distribution in the file COPYING.  If you
//  do not have a copy, you may obtain a copy by writing to the Free
//  Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
// Change Log
//
// Date          Developer             Changes
// $Date: 2005/08/02 05:17:18 $        $Author: ping235 $              $Name:  $
//
/////////////////////////////////////////////////////////////////////////////
// CVS Log
// $Log: DShow.h,v $
// Revision 1.1.1.1  2005/08/02 05:17:18  ping235
// initial,GUI 1.0.0.0,CMD 1.3.0.1
//
//////////////////////////////////////////////////////////////////////////////

#pragma once

extern "C" const GUID __declspec(selectany) CLSID_NullRenderer =
    {0xc1f400a4,0x3f08,0x11d3,{0x9f,0x0b,0x00,0x60,0x08,0x03,0x9e,0x37}};
extern "C" const GUID __declspec(selectany) CLSID_FileWriter =
    {0x8596E5F0,0x0DA5,0x11D0,{0xBD,0x21,0x00,0xA0,0xC9,0x11,0xce,0x86}};

//һЩDirectShowĸ
class CDShow
{
public:
	typedef class std::list< IBaseFilter* > CBaseFilterList;
	typedef struct _DX_OBJ
	{
		CString strDispName;//CLSID
		CString strFriendName;
	}DX_OBJ;
	typedef std::map<UINT,DX_OBJ> CDX_ObjList;
	typedef bool PENUMDXSYSDEVICE(IMoniker* pMoniker,void* pData);

public:
	CDShow(void);
	~CDShow(void);

public:
	//עᵽROT
	static void AddToROT(IGraphBuilder* spGraphBuild,bool bPause,DWORD& dwROTToken);
	//ROTɾ
	static void RemoveFromROT(DWORD dwROTToken);
	//GraphBuildвʵ˸ӿڵFilter
	static HRESULT FindFilter(IGraphBuilder* pGraph,REFGUID iid,void** ppUnk);
	//FilterƵPinӣ򷵻false򷵻true
	static bool IsVideoPinUnconnected(IBaseFilter* pBF);
	//Filterӣ򷵻FilterVideoInPinӵPin
	static HRESULT FindVideoOutPin(IBaseFilter* pBF,IPin** ppPin);
	//inFilterʼλ˷ɾֻ֮һPinFilterصһ
	//1PinFilterPinppPinǸ
	//inFilterɾ
	static HRESULT NukeUpstream(IGraphBuilder * inGraph, IBaseFilter * inFilter);
	//pBFDirPinĿ
	static int GetPinCount(IBaseFilter *pBF, PIN_DIRECTION Dir);
	//Null Renderer뵽GraphBuild
	static IPin* CreateNullRender(IGraphBuilder * pGB);
	//GraphBuildеVideoAudio Renderer Filter
	static HRESULT GetAVRenderer(IGraphBuilder* pGB,CBaseFilterList& lstAudio,CBaseFilterList& lstVideo);
	//pBFӣһӵPinӵPin򷵻NULL
	static HRESULT FindConnectedPin(IBaseFilter* pBF,IPin** ppPin);
	//ϿinFilterֱPinȻGraphBuildɾɾinFilter
	static HRESULT RemoveFilter(IGraphBuilder * inGraph, IBaseFilter * inFilter);
	//This function frees a task-allocated AM_MEDIA_TYPE structure from memory. 
	static void WINAPI FreeMediaType(AM_MEDIA_TYPE& mt);
	//This function deletes a task-allocated AM_MEDIA_TYPE structure. 
	static void WINAPI DeleteMediaType(AM_MEDIA_TYPE *pmt);
	//pBFĵһPin
	static IPin* GetPin(IBaseFilter *pBF,PIN_DIRECTION eDir);
	static HRESULT GetPin(IBaseFilter *pBF,PIN_DIRECTION eDir,IPin** ppPin);
	static HRESULT GetPin(IBaseFilter *pBF,PIN_DIRECTION eDir,IPin** ppPin,bool bConnected);
	//pPinӣ򷵻true
	static bool IsPinConnected(IPin* pPin);
	//pBFδӵPinӵNull Renderer
	static HRESULT ConnectAllPinToNullRender(IGraphBuilder * pGB,IBaseFilter *pBF);
	// ͨclsidʵFilter뵽GraphBuilder
	static HRESULT AddFilterByClsid(IGraphBuilder* pGB, REFCLSID clsid,LPCWSTR lpszName,IBaseFilter** ppFilter = NULL);
	// ͨclsidʵFilter뵽GraphBuilder
	static HRESULT AddFilterByName(IGraphBuilder* pGB, LPCTSTR lpszDispName,LPCTSTR lpszName,IBaseFilter** ppFilter);
	//öϵͳеDX豸磺Ƶ׽ѹ豸˾
//	static void EnumDXSystemDevice(CLSID clsidType,PENUMDXSYSDEVICE pFn,void* pData=NULL);
	//EnumDXSystemDeviceĻصGetDXObjListʹ
	static bool OnEnumDXObjList(IMoniker* pMoniker,void* pData);
	static void GetDXObjList(CLSID clsidType,CDX_ObjList& list);
	//EnumDXSystemDeviceĻصFindSysDevʹ
	static bool OnEnumFindSysDev(IMoniker* pMoniker,void* pData);
	static HRESULT FindSysDev(CLSID clsidType,LPCTSTR lpszName,IMoniker** ppmk);
	// ɸIndexضӦƵƵѹDispName
	static CString GetDispNameByIndex(bool bAudio,int nIndex);
	static bool OnEnumGetDispNameByIndex(IMoniker* pMoniker,void* pData);
	// гϵͳаװƵѹ
	static HRESULT ListCompressors(bool bAudio);
	static bool OnEnumListCompressors(IMoniker* pMoniker,void* pData);
	static HRESULT CreateFilterByName(LPCTSTR lpszName,IBaseFilter** ppFilter);
};
