// FFTView.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "FFTView.h"
#include <wingdi.h>
#include <windowsx.h>
#include <assert.h>
#include <math.h>
#include "spline.h"
//#include "matrix.h"
//#include "Generator.h"
#include "Splines.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define HEIGHT_FREQ_RULER 20
#define HEIGHT_KLAVIER 25
/////////////////////////////////////////////////////////////////////////////
// CFFTView

IMPLEMENT_DYNCREATE(CFFTView, CView)

CFFTView::CFFTView()
{
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->AppendMenu(MF_STRING|MF_ENABLED,ID_FENSTER_FFT,"FFT");
	AfxGetMainWnd()->DrawMenuBar();
}

void CFFTView::IniFileRead()
{
	//IniDateiwerte bernehmen
	m_BottomCutHz=*theApp.GetIniFFTBottomCutHz();
	m_TopCutkHz=*theApp.GetIniFFTTopCutkHz();
	m_BottomCutAmp=*theApp.GetIniFFTBottomCutAmp();
	m_TopCutAmp=*theApp.GetIniFFTTopCutAmp();
	m_Delay=*theApp.GetIniFFTDelay();
	m_bIsDelay=*theApp.GetIniFFTbIsDelay();
	m_bGrid=*theApp.GetIniFFTbGrid();
	m_MinAbstandMaxima=*theApp.GetIniFFTMinAbstandMaxima();
	m_MinAbstandNachbarMin=*theApp.GetIniFFTMinAbstandNachbarMin();
	m_bIsAmpLinear=*theApp.GetIniFFTbIsAmpLinear();
	m_bIsFreqLinear=*theApp.GetIniFFTbIsFreqLinear();
	m_bDarstellung=*theApp.GetIniFFTbDarstellung();
	m_bIsCrossVisible=*theApp.GetIniFFTbIsCrossVisible();
	m_bIsSpline=*theApp.GetIniFFTbIsSpline();
	m_SplineTyp=*theApp.GetIniFFTSplineTyp();
	m_bIsSumme=*theApp.GetIniFFTbIsSumme();
}

void	CFFTView::IniFileWrite()
{
	//IniDateiwerte schreiben
	*theApp.GetIniFFTBottomCutHz()=m_BottomCutHz;
	*theApp.GetIniFFTTopCutkHz()=m_TopCutkHz;
	*theApp.GetIniFFTBottomCutAmp()=m_BottomCutAmp;
	*theApp.GetIniFFTTopCutAmp()=m_TopCutAmp;
	*theApp.GetIniFFTDelay()=m_Delay;
	*theApp.GetIniFFTbIsDelay()=m_bIsDelay;
	*theApp.GetIniFFTbGrid()=m_bGrid;
	*theApp.GetIniFFTMinAbstandMaxima()=m_MinAbstandMaxima;
	*theApp.GetIniFFTMinAbstandNachbarMin()=m_MinAbstandNachbarMin;
	*theApp.GetIniFFTbIsAmpLinear()=m_bIsAmpLinear;
	*theApp.GetIniFFTbIsFreqLinear()=m_bIsFreqLinear;
	*theApp.GetIniFFTbDarstellung()=m_bDarstellung;
	*theApp.GetIniFFTbIsCrossVisible()=m_bIsCrossVisible;
	*theApp.GetIniFFTbIsSpline()=m_bIsSpline;
	*theApp.GetIniFFTSplineTyp()=m_SplineTyp;
	*theApp.GetIniFFTbIsSumme()=m_bIsSumme;
}

CFFTView::~CFFTView()
{
	IniFileWrite();
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->RemoveMenu(ID_FENSTER_FFT,MF_BYCOMMAND);
	AfxGetMainWnd()->DrawMenuBar();
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->m_pViewFFT=NULL;
}


BEGIN_MESSAGE_MAP(CFFTView, CView)
	//{{AFX_MSG_MAP(CFFTView)
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_EN_CHANGE(IDC_BOTTOMCUT_FELD, OnChangeBottomcutFeld)
	ON_EN_CHANGE(IDC_TOPCUT_FELD, OnChangeTopcutFeld)
	ON_BN_CLICKED(IDC_SCALE_AMP_LIN, OnScaleAmpLin)
	ON_BN_CLICKED(IDC_SCALE_AMP_LOG, OnScaleAmpLog)
	ON_BN_CLICKED(IDC_SCALE_FREQ_LIN, OnScaleFreqLin)
	ON_BN_CLICKED(IDC_SCALE_FREQ_LOG, OnScaleFreqLog)
	ON_BN_CLICKED(IDC_BALKEN, OnBalken)
	ON_BN_CLICKED(IDC_LINIEN, OnLinien)
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_CHECK_SPLINE_B, OnCheckSplineB)
	ON_BN_CLICKED(IDC_CHECK_SPLINE_D, OnCheckSplineC)
	ON_BN_CLICKED(IDC_CHECK_SPLINE_BETA, OnCheckSplineBeta)
	ON_COMMAND(ID_SAVE, OnSave)
	ON_COMMAND(ID_EDIT_CLEARALL, OnEditClearall)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_EN_CHANGE(IDC_TOPCUTAMP_FELD, OnChangeTopcutampFeld)
	ON_EN_CHANGE(IDC_BOTTOMCUTAMP_FELD, OnChangeBottomcutampFeld)
	ON_EN_CHANGE(IDC_DELAY_FELD2, OnChangeDelayFeld)
	ON_BN_CLICKED(IDC_CHECK_DELAY, OnCheckDelay)
	ON_BN_CLICKED(IDC_CHECK_SUMME, OnCheckSumme)
	ON_WM_SIZE()
	ON_EN_CHANGE(IDC_ABSTAND_FELD, OnChangeAbstandFeld)
	ON_BN_CLICKED(IDC_CHECK_PEAKKREUZ, OnCheckPeakkreuz)
	ON_BN_CLICKED(IDC_SAULEN, OnSaulen)
	ON_EN_CHANGE(IDC_ABSTAND_FELD2, OnChangeAbstandFeld2)
	ON_BN_CLICKED(IDC_CHECK_GRID, OnCheckGrid)
	ON_COMMAND(ID_EXPORTDATA, OnExportdata)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Zeichnung CFFTView 

void CFFTView::OnInitialUpdate()
{
//	CView::OnInitialUpdate();
	CSize sizeTotal;
	CRect rect;
	GetClientRect(rect);
	sizeTotal.cx = rect.right;
	sizeTotal.cy = rect.left;

	CPoint Nullpunkt;
	Nullpunkt.x=0;
	Nullpunkt.y=0;
	m_ViewPtFreqArray.Add(Nullpunkt);
	m_LastViewPtFreqArray.Add(Nullpunkt);

	m_clrBkg=RGB(0,0,0);
	m_clrText=RGB(255,255,255);
	m_clrSpline=RGB(255,255,0);

	
	m_FrequenzbereichFFT=0;		
	m_Redraw=TRUE;
	m_ZoomV=32;

	IniFileRead();
	
	//Dialogparameter initialisieren
	m_pParentFFTFrame=(CFFTFrame*)GetParentFrame();
	m_pBottumCutCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BOTTOMCUT_SPIN);
 	m_pBottumCutCtrl->SetRange(1,999);
	m_pBottumCutCtrl->SetBuddy(m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BOTTOMCUT_FELD));
	m_pBottumCutCtrl->SetPos(m_BottomCutHz);

	m_pTopCutCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_TOPCUT_SPIN);
	m_pTopCutCtrl->SetRange(1,100);
	m_pTopCutCtrl->SetBuddy(m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_TOPCUT_FELD));
	m_pTopCutCtrl->SetPos(m_TopCutkHz);

	m_pBottumCutAmpCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BOTTOMCUTAMP_SPIN);
 	m_pBottumCutAmpCtrl->SetRange(0,-99);
	m_pBottumCutAmpCtrl->SetBuddy(m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BOTTOMCUTAMP_FELD));
	m_pBottumCutAmpCtrl->SetPos(m_BottomCutAmp);

	m_pTopCutAmpCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_TOPCUTAMP_SPIN);
	m_pTopCutAmpCtrl->SetRange(0,-99);
	m_pTopCutAmpCtrl->SetBuddy(m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_TOPCUTAMP_FELD));
	m_pTopCutAmpCtrl->SetPos(m_TopCutAmp);

	CSpinButtonCtrl* m_pDelaySpinCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_DELAY_SPIN2);
	m_pDelaySpinCtrl->SetRange(0,15);
	m_pDelaySpinCtrl->SetBuddy(m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_DELAY_FELD2));
	m_pDelaySpinCtrl->SetPos(m_Delay);

	CSpinButtonCtrl* m_pMaxAbstandSpinCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_ABSTAND_SPIN);
	m_pMaxAbstandSpinCtrl->SetRange(0,50);
	m_pMaxAbstandSpinCtrl->SetBuddy(m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_ABSTAND_FELD));
	m_pMaxAbstandSpinCtrl->SetPos(m_MinAbstandMaxima);

	CSpinButtonCtrl* m_pMinAbstandSpinCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_ABSTAND_SPIN2);
	m_pMinAbstandSpinCtrl->SetRange(1,50);
	m_pMinAbstandSpinCtrl->SetBuddy(m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_ABSTAND_FELD2));
	m_pMinAbstandSpinCtrl->SetPos(m_MinAbstandNachbarMin);

	m_pRadioAmpLin=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SCALE_AMP_LIN);
	m_pRadioAmpLog=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SCALE_AMP_LOG);
	if (m_bIsAmpLinear) 
	{
		m_pRadioAmpLog->SetCheck(0);
		m_pRadioAmpLin->SetCheck(1);
	}
	else
	{
		m_pRadioAmpLog->SetCheck(1);
		m_pRadioAmpLin->SetCheck(0);
	}

	m_pRadioFreqLin=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SCALE_FREQ_LIN);
	m_pRadioFreqLog=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SCALE_FREQ_LOG);
	if (m_bIsFreqLinear) 
	{
		m_pRadioFreqLin->SetCheck(1);
		m_pRadioFreqLog->SetCheck(0);
	}
	else
	{
		m_pRadioFreqLin->SetCheck(0);
		m_pRadioFreqLog->SetCheck(1);
	}


	m_pRadioBalken=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BALKEN);
	m_pRadioLinien=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_LINIEN);
	m_pRadioSaulen=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SAULEN);

	switch(m_bDarstellung) {
	case 0:
		m_pRadioBalken->SetCheck(1);
		m_pRadioLinien->SetCheck(0);
		m_pRadioSaulen->SetCheck(0);
		break;
	case 1:
		m_pRadioBalken->SetCheck(0);
		m_pRadioLinien->SetCheck(1);
		m_pRadioSaulen->SetCheck(0);
		break;
	case 2:
		m_pRadioBalken->SetCheck(0);
		m_pRadioLinien->SetCheck(0);
		m_pRadioSaulen->SetCheck(1);
		break;
	default:
		m_pRadioBalken->SetCheck(0);
		m_pRadioLinien->SetCheck(1);
		m_pRadioSaulen->SetCheck(0);
	}	
	
	CButton* m_pCheckGrid=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_GRID);
	if (m_bGrid) 
		m_pCheckGrid->SetCheck(1);
	else
		m_pCheckGrid->SetCheck(0);

	CButton* m_pCheckDelay=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_DELAY);
	if (m_bIsDelay) 
		m_pCheckDelay->SetCheck(1);
	else
		m_pCheckDelay->SetCheck(0);


	CButton* m_pCheckCross=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_PEAKKREUZ);
	if (m_bIsCrossVisible)
		m_pCheckCross->SetCheck(1);
	else
		m_pCheckCross->SetCheck(0);

	CButton* m_pCheckSplineD=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_D);
	CButton* m_pCheckSplineB=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_B);
	CButton* m_pCheckSplineBeta=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_BETA);
	if (m_bIsSpline) 
	{
		switch(m_SplineTyp) {
		case 0:
			m_pCheckSplineD->SetCheck(1);
			m_pCheckSplineB->SetCheck(0);
			m_pCheckSplineBeta->SetCheck(0);
			break;
		case 1:
			m_pCheckSplineD->SetCheck(0);
			m_pCheckSplineB->SetCheck(1);
			m_pCheckSplineBeta->SetCheck(0);
			break;
		case 2:
			m_pCheckSplineD->SetCheck(0);
			m_pCheckSplineB->SetCheck(0);
			m_pCheckSplineBeta->SetCheck(1);
			break;
		default:
			m_pCheckSplineD->SetCheck(0);
			m_pCheckSplineB->SetCheck(0);
			m_pCheckSplineBeta->SetCheck(0);
			break;
		}
	}
	else
	{
			m_pCheckSplineD->SetCheck(0);
			m_pCheckSplineB->SetCheck(0);
			m_pCheckSplineBeta->SetCheck(0);
	}
	
	CButton* pCheckSumme=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SUMME);
	if (m_bIsSumme) 
		pCheckSumme->SetCheck(1);
	else
		pCheckSumme->SetCheck(0);

	m_pFFTPointsFeld=(CEdit*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_FFTPOINTS_FELD);
	m_pFFTPointsFeld->EnableWindow(FALSE);
	char buffer[20];
	CString TextFFTSize;
	TextFFTSize=itoa( *theApp.GetIniDokumentFFTPoints(), buffer, 10 );
	m_pFFTPointsFeld->SetWindowText(TextFFTSize);

}

void CFFTView::OnDraw(CDC* dc)
{
	CMemDC pDC(dc);

	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CRect rect;
	GetClientRect(rect);
	m_Redraw=TRUE;
	pDC->SelectPalette(pDoc->GetPalette(), FALSE);
	pDC->RealizePalette();
	pDC->SetBkMode(TRANSPARENT);
	pDC->FillSolidRect(HEIGHT_FREQ_RULER+1,HEIGHT_KLAVIER+3,rect.right-HEIGHT_FREQ_RULER-1,\
											rect.bottom-HEIGHT_FREQ_RULER-HEIGHT_KLAVIER-3,m_clrBkg);
	if (m_clrBkg!=RGB(255,255,255))
		ZeichneTasten(pDC);

	CArray<DOUBLE,DOUBLE>* pFrequenzenArray=pDoc->GetFrequenzenArray();
	INT MaxZeit=pFrequenzenArray->GetSize();
	DOUBLE MaxAmplitude=ldexp(1,*pDoc->GetBitRate());
	DOUBLE BitRateFFT=floor(log10(MaxZeit)/log10(2));

	if (pFrequenzenArray->GetSize()==1||m_FrequenzenArrayLaenge!=MaxZeit) 
	{
		m_ViewPtFreqArray.RemoveAll();
		m_LastViewPtFreqArray.RemoveAll();
		POINT Nullpunkt;
		Nullpunkt.x=0;
		Nullpunkt.y=0;
		if (m_bIsSpline||m_bIsCrossVisible) 
		{
			m_ControlPoints.RemoveAll();
			m_CurvePoints.RemoveAll();
			m_CtrlControlPoints.RemoveAll();
		}
		m_ViewPtFreqArray.Add(Nullpunkt);
//		m_LastViewPtFreqArray.Add(Nullpunkt);
	}

	m_FrequenzenArrayLaenge=MaxZeit;

	DOUBLE FaktorX=0,HoeheY=0;
	INT Sprung=1;

//	FILE* file=fopen("d:\\AdrianBauernhaus\\Testfiles\\ViewPtArray.txt","w");
		INT EndCounterSichtbar=0;
		INT StartCounterSichtbar=0;
		//Frequenzarray auf Fenster skalieren
		if (MaxZeit>2)
		{
			m_ViewPtFreqArray.RemoveAll();
//			m_ViewPtFreqArray.SetSize(MaxZeit);
			POINT Messpunkt;
			FaktorX=(rect.right-HEIGHT_FREQ_RULER)/(double)MaxZeit;
			HoeheY=rect.bottom-HEIGHT_KLAVIER-HEIGHT_FREQ_RULER;
			
			int i=0;
			LONG LastX=HEIGHT_FREQ_RULER;
			LONG LastY=rect.bottom;
			POINT CtrlPt;

			DOUBLE BottomCutAmpInBits=pow(10,(DOUBLE)m_BottomCutAmp/20)*MaxAmplitude;
			DOUBLE TopCutAmpInBits=pow(10,(DOUBLE)m_TopCutAmp/20)*MaxAmplitude;

			INT* pSampleRate=pDoc->GetSampleRate();
//			DOUBLE MaxdB=-20*log10(1/MaxAmplitude);
			INT FrequenzbreiteFFTAnsicht=m_TopCutkHz*1000;//*pSampleRate/2;
			DOUBLE BildProzentVonBottomCutHz = m_bIsFreqLinear?\
																				 m_BottomCutHz/(DOUBLE)FrequenzbreiteFFTAnsicht:\
																				 log(m_BottomCutHz)/log(FrequenzbreiteFFTAnsicht);
			LONG Biggest=rect.bottom;

	 		while (i<MaxZeit-2)
			  {
					INT FrequenzLinear=(INT)((i+1)*(*pSampleRate/2/(DOUBLE)MaxZeit));
					INT TestFrequenzLinear=(INT)((i+1)*(*pSampleRate/2/(DOUBLE)MaxZeit));
					//Frequenzen unter m_BottomCutHz ausschneiden wegen Darstellungsverlust
					//die ersten 10 Hz entsprechen ca. 1/5 des Bildraums in der Oktavdarstellung
					if (TestFrequenzLinear>m_BottomCutHz) 
					{
						//Frequenzen von m_BottomCutHz bis Frequenzbreite (22khz, 44kHz usw) auf ClientRect skalieren
						DOUBLE ProzentwertKlein=m_bIsFreqLinear?\
											FrequenzLinear/(DOUBLE)FrequenzbreiteFFTAnsicht-BildProzentVonBottomCutHz:\
											log(FrequenzLinear)/log(FrequenzbreiteFFTAnsicht)-BildProzentVonBottomCutHz;
						DOUBLE ProzentwertSkaliertAuf100=ProzentwertKlein/(1-BildProzentVonBottomCutHz);
 						DOUBLE xWert=HEIGHT_FREQ_RULER+ProzentwertSkaliertAuf100*(rect.right-HEIGHT_FREQ_RULER);
 						Messpunkt.x=(LONG)xWert;

						if (ProzentwertSkaliertAuf100<=1)
						{
							DOUBLE Wert=0;
							int Down=0;
							Wert=pFrequenzenArray->GetAt(i+1)+1;

							if (m_bIsAmpLinear)
								Messpunkt.y=(LONG)(MIN(rect.bottom-HEIGHT_FREQ_RULER\
														-HoeheY*(Wert-TopCutAmpInBits)/(BottomCutAmpInBits-TopCutAmpInBits)
														+Down,rect.bottom-HEIGHT_FREQ_RULER));
							else
								if (Wert>1) 
								{
									DOUBLE Abzug=HoeheY*(log(Wert)/log(MaxAmplitude)-log(TopCutAmpInBits)/log(MaxAmplitude))\
															/(log(BottomCutAmpInBits)/log(MaxAmplitude)-log(TopCutAmpInBits)/log(MaxAmplitude));
									Messpunkt.y=(LONG)(MIN(rect.bottom-HEIGHT_FREQ_RULER-Abzug+Down,
																				 rect.bottom-HEIGHT_FREQ_RULER));
								}
								else
									Messpunkt.y=(LONG)(MIN(rect.bottom-HEIGHT_FREQ_RULER+Down,rect.bottom-HEIGHT_FREQ_RULER));
							if (Messpunkt.y>rect.bottom-HEIGHT_FREQ_RULER) 
								Messpunkt.y=rect.bottom-HEIGHT_FREQ_RULER;

							//Messpunkte in ViewArray aufnehmen
							//Anzahl der Punkte reduzieren, aber Maxima erhalten
							if (Messpunkt.x!=LastX)
							{
								if (Biggest!=rect.bottom) 
								{
									if (Messpunkt.y<Biggest) Biggest=Messpunkt.y;
									Messpunkt.y=Biggest;
									Biggest=rect.bottom;
								}
								if (m_bIsSumme&&m_LastViewPtFreqArray.GetSize()>m_ViewPtFreqArray.GetSize()) 
								{
									if (Messpunkt.y<m_LastViewPtFreqArray.GetAt(m_ViewPtFreqArray.GetSize()).y) 
										m_ViewPtFreqArray.Add(Messpunkt);
									else
										m_ViewPtFreqArray.Add(m_LastViewPtFreqArray.GetAt(m_ViewPtFreqArray.GetSize()));
								}	
								else
									m_ViewPtFreqArray.Add(Messpunkt);
							}
							else
								if (Messpunkt.y<Biggest) Biggest=Messpunkt.y;
							LastX=Messpunkt.x;
							LastY=Messpunkt.y;
						}
					}
					else
						StartCounterSichtbar++;

					EndCounterSichtbar=i;
				  i+=1;//Sprung;
			  }

				//Peaks ermitteln
				if (m_bIsSpline||m_bIsCrossVisible) 
				{
					//Alte Splines lschen
					if (m_ControlPoints.GetSize()>0) 
					{
						m_ControlPoints.RemoveAll();
						m_CurvePoints.RemoveAll();
					}
					//Startpunkt einfgen
					CtrlPt.x=HEIGHT_FREQ_RULER;
					CtrlPt.y=rect.bottom-HEIGHT_FREQ_RULER;
					m_ControlPoints.Add(CtrlPt);

					//Peaks suchen
					DOUBLE LastWert=0;
					INT Count=StartCounterSichtbar;
					INT ZaehlerRauf=0;
					INT ZaehlerRunter=0;
					INT ZaehlerGleich=0;
					INT MaxFrequenzen=pFrequenzenArray->GetSize();
					while(Count<MaxFrequenzen)
					{
						while (pFrequenzenArray->GetAt(Count)>LastWert) 
						{
							LastWert=pFrequenzenArray->GetAt(Count);
							ZaehlerRauf++;
							if (Count==MaxFrequenzen-1) break;
							Count++;
						}
						while (pFrequenzenArray->GetAt(Count)==LastWert)
						{
							LastWert=pFrequenzenArray->GetAt(Count);
							ZaehlerGleich++;
							if (Count==MaxFrequenzen-1) break;
							Count++;
						}
						while (pFrequenzenArray->GetAt(Count)<LastWert) 
						{
							LastWert=pFrequenzenArray->GetAt(Count);
							ZaehlerRunter++;
							Count++;
							if (Count==MaxFrequenzen) break;
						}
						ZaehlerRauf+=ZaehlerGleich;
//						ZaehlerRunter+=ZaehlerGleich;
//						if ((ZaehlerRauf>m_MinAbstandMaxima&&ZaehlerRunter>0)||(ZaehlerRunter>m_MinAbstandMaxima&&ZaehlerRauf>0)) 
//						if (ZaehlerRauf>m_MinAbstandMaxima&&ZaehlerRunter>m_MinAbstandMaxima) 
						if (ZaehlerRauf>0&&ZaehlerRunter>0) 
						{
							DOUBLE Peak=pFrequenzenArray->GetAt(Count-ZaehlerRunter-1);
							DOUBLE RechtsvonPeak=pFrequenzenArray->GetAt(Count-ZaehlerRunter-1+m_MinAbstandNachbarMin<MaxFrequenzen?Count-ZaehlerRunter-1+m_MinAbstandNachbarMin:MaxFrequenzen-1); ///3: Abstand rechts links
							DOUBLE LinksvonPeak=pFrequenzenArray->GetAt(Count-ZaehlerRunter-1-m_MinAbstandNachbarMin>0?Count-ZaehlerRunter-1-m_MinAbstandNachbarMin:0);
							if ((Peak*0.2>RechtsvonPeak||Peak*0.2>LinksvonPeak)&&Peak>MaxAmplitude*0.0001) 
							{
								//Koordinaten berechnen fr Darstellung
								//X-Wert
								INT FrequenzLinear=(INT)((Count-ZaehlerRunter-1)*(*pSampleRate/2/(DOUBLE)MaxZeit));
								//Frequenzen von m_BottomCutHz bis Frequenzbreite (22khz, 44kHz usw) auf ClientRect skalieren
								DOUBLE ProzentwertKlein=m_bIsFreqLinear?\
												FrequenzLinear/(DOUBLE)FrequenzbreiteFFTAnsicht-BildProzentVonBottomCutHz:\
												log(FrequenzLinear)/log(FrequenzbreiteFFTAnsicht)-BildProzentVonBottomCutHz;
								DOUBLE ProzentwertSkaliertAuf100=ProzentwertKlein/(1-BildProzentVonBottomCutHz);
 								DOUBLE xWert=HEIGHT_FREQ_RULER+ProzentwertSkaliertAuf100*(rect.right-HEIGHT_FREQ_RULER);
	 							Messpunkt.x=(LONG)xWert+1;
								//Y-Wert
								DOUBLE Wert=0;
								int Down=0;
								Wert=pFrequenzenArray->GetAt(Count-ZaehlerRunter-1)+1;
								if (m_bIsAmpLinear)
									Messpunkt.y=(LONG)(MIN(rect.bottom-HEIGHT_FREQ_RULER\
															-HoeheY*(Wert-TopCutAmpInBits)/(BottomCutAmpInBits-TopCutAmpInBits)
															+Down,rect.bottom-HEIGHT_FREQ_RULER));
								else
									if (Wert>1) 
									{
										DOUBLE Abzug=HoeheY*(log(Wert)/log(MaxAmplitude)-log(TopCutAmpInBits)/log(MaxAmplitude))\
																/(log(BottomCutAmpInBits)/log(MaxAmplitude)-log(TopCutAmpInBits)/log(MaxAmplitude));
										Messpunkt.y=(LONG)(MIN(rect.bottom-HEIGHT_FREQ_RULER-Abzug+Down,
																					 rect.bottom-HEIGHT_FREQ_RULER));
									}
									else
										Messpunkt.y=(LONG)(MIN(rect.bottom-HEIGHT_FREQ_RULER+Down,rect.bottom-HEIGHT_FREQ_RULER));
								if (Messpunkt.y>rect.bottom-HEIGHT_FREQ_RULER) 
									Messpunkt.y=rect.bottom-HEIGHT_FREQ_RULER;
								//In Splinekontrollarray eintragen
								m_ControlPoints.Add(Messpunkt);
							}
						}
						if (Count==MaxFrequenzen-1) Count++;
						ZaehlerRauf=0;
						ZaehlerRunter=0;
						ZaehlerGleich=0;
					}
					//weitere Modifikationen
						//den kleineren zweier dicht liegender Punkte entfernen
					for(i=0; i<m_ControlPoints.GetSize()-1;i++)
					{
						POINT Links,Rechts;
						Links=m_ControlPoints.GetAt(i);
						Rechts=m_ControlPoints.GetAt(i+1);
						if (Links.x>=Rechts.x-m_MinAbstandMaxima) 
						{
							m_ControlPoints.RemoveAt(Links.y<Rechts.y?i+1:i);
							i--;
						}
					}
					int Laenge=m_CtrlControlPoints.GetSize();
					if (Laenge>0) 
					{
						//Mit Maus vorgenomme nderungen bercksichtigen
						for(i=0; i<Laenge;i++)
						{
							int Stelle=m_CtrlControlPoints.GetAt(i).x;
							if (m_CtrlControlPoints.GetAt(i).y==0&&Stelle-2>0&&m_ControlPoints.GetSize()>Stelle) 
							{
								m_ControlPoints.RemoveAt(m_bIsSpline?m_CtrlControlPoints.GetAt(i).x-2:m_CtrlControlPoints.GetAt(i).x);
							}
							else
							{
								int j=0;
								while (m_ControlPoints.GetAt(j).x<Stelle)
								{
									j++;
									if (j==m_ControlPoints.GetSize()) break;
								}
								m_ControlPoints.InsertAt(j,m_CtrlControlPoints.GetAt(i));
							}
						}
					}

					//Endpunkt einfgen
					CtrlPt.x=rect.right;
					CtrlPt.y=rect.bottom-HEIGHT_FREQ_RULER;
					m_ControlPoints.Add(CtrlPt);
//					PutObertonPeaksInDoc(&m_ControlPoints);

					if (m_bIsSpline) 
					{
						//create a spline object
						Spline spline(m_ControlPoints.GetData(), m_ControlPoints.GetSize());
						//generate a curve
						spline.Generate();
						//get the curve points number
						m_CurvePoints.SetSize(spline.GetCurveCount());
						//get the points number
						int PointCount = 0;
						spline.GetCurve(m_CurvePoints.GetData(), PointCount);
					}
				}
					

		}
//		fclose(file);
		//Frequenzen zeichnen
		POINT Anfangspunkt;
		CPen KurvenStift;
	  KurvenStift.CreatePen(PS_SOLID,1,RGB(255,0,0));
	  pDC->SelectObject(&KurvenStift);
		if (m_ViewPtFreqArray.GetSize()>1) 
		{
			INT i=StartCounterSichtbar;
			//Wenn Delay eingestellt ganzes Array durchsehen uns erst dann zeichnen
			if (m_LastViewPtFreqArray.GetSize()>i&&m_bIsDelay) 
			{
				while (i < (m_ViewPtFreqArray.GetSize()-1))
			  {
					if(m_ViewPtFreqArray.GetAt(i).y>m_LastViewPtFreqArray.GetAt(i).y)
					{
						POINT DownPoint;
						DownPoint.x=m_LastViewPtFreqArray.GetAt(i).x;
						DownPoint.y=m_LastViewPtFreqArray.GetAt(i).y+m_Delay;
						m_ViewPtFreqArray.SetAt(i,DownPoint);
					}
					i++;
				}
			}
			i=0;//StartCounterSichtbar;
			INT Size=m_ViewPtFreqArray.GetSize();
			switch(m_bDarstellung) 
			{
			case 0:   //senkrechte Balken
				while (i < (Size-1))
			  {
					CPen Stift;
					COLORREF Farbe=PALETTEINDEX((INT)(m_bIsFreqLinear?i*1536/Size:sqrt(i)*1536/sqrt(Size)));
					Stift.CreatePen(PS_SOLID,1,Farbe);
					pDC->SelectObject(&Stift);
					Anfangspunkt.x=m_ViewPtFreqArray.GetAt(i).x;
					Anfangspunkt.y=rect.bottom-HEIGHT_FREQ_RULER;
					pDC->MoveTo(Anfangspunkt);

					POINT NextPunkt=m_ViewPtFreqArray.GetAt(i);
					if (NextPunkt.x!=0) pDC->LineTo(NextPunkt);
					Stift.DeleteObject();
					i++;
		    }
				break;
			case 1:		//Liniendarstellung von Punkt zu Punkt
				Anfangspunkt.x=HEIGHT_FREQ_RULER;
				Anfangspunkt.y=m_ViewPtFreqArray.GetAt(i).y;
			  pDC->MoveTo(Anfangspunkt);
				while (i < (Size-1))
			  {
					POINT NextPunkt=m_ViewPtFreqArray.GetAt(i+1);
					if (NextPunkt.x!=0)	pDC->LineTo(NextPunkt);
					i++;
		    }
				break;
			case 2:		//Liniendarstellung mit Sulen
				Anfangspunkt.x=HEIGHT_FREQ_RULER;
				Anfangspunkt.y=m_ViewPtFreqArray.GetAt(i).y;
			  pDC->MoveTo(Anfangspunkt);
				while (i < (Size-1))
			  {
					POINT NextPunkt=m_ViewPtFreqArray.GetAt(i+1);
					if (NextPunkt.x!=0)
					{
						POINT Punkt;
						Punkt.x=NextPunkt.x;
						Punkt.y=m_ViewPtFreqArray.GetAt(i).y;
						pDC->LineTo(Punkt);
						pDC->LineTo(NextPunkt);
					}
					i++;
		    }
				break;
			}	//END SWITCH
			m_LastViewPtFreqArray.RemoveAll();
			m_LastViewPtFreqArray.SetSize(m_ViewPtFreqArray.GetSize());//MaxZeit
			m_LastViewPtFreqArray.Copy(m_ViewPtFreqArray);
		}

		if (m_bIsCrossVisible) 
		{
			//draw the control points
			for(int i=0; i<m_ControlPoints.GetSize(); i++)
				DrawCross(m_ControlPoints[i], RGB(0,255,0), 3,pDC);
		}

		if (m_bIsSpline) 
		{
			//draw the curve
			if(m_CurvePoints.GetSize()>1)
			{
				CPen Stift;
				Stift.CreatePen(PS_SOLID,1,m_clrSpline);
				pDC->SelectObject(&Stift);
				if (m_SplineTyp==1) 
				{
					while (m_ControlPoints.GetSize()%3!=0) 
						m_ControlPoints.RemoveAt(m_ControlPoints.GetSize()-1);
					Anfangspunkt.x=HEIGHT_FREQ_RULER;
					Anfangspunkt.y=rect.bottom-HEIGHT_FREQ_RULER;
					pDC->MoveTo(Anfangspunkt);
					pDC->PolyBezierTo(m_ControlPoints.GetData(), m_ControlPoints.GetSize());
				}
				if (m_SplineTyp==2) 
					pDC->Polyline(m_CurvePoints.GetData(), m_CurvePoints.GetSize());
				if (m_SplineTyp==3) 
				{
					Anfangspunkt.x=HEIGHT_FREQ_RULER+1;
					Anfangspunkt.y=rect.bottom-1-HEIGHT_FREQ_RULER;
					m_ControlPoints.InsertAt(0,Anfangspunkt);
					Anfangspunkt.x=HEIGHT_FREQ_RULER+2;
					Anfangspunkt.y=rect.bottom-2-HEIGHT_FREQ_RULER;
					m_ControlPoints.InsertAt(1,Anfangspunkt);
					Anfangspunkt.x=rect.right;
					Anfangspunkt.y=rect.bottom-HEIGHT_FREQ_RULER;
					m_ControlPoints.Add(Anfangspunkt);
					m_ControlPoints.Add(Anfangspunkt);
					CSplines SplineHelper;
					SplineHelper.ZeichneBSpline(pDC,m_ControlPoints.GetData(),m_ControlPoints.GetSize(),m_clrSpline);
				}
			}
		}

		if (m_Redraw) 
		{
			//Frequenzkala zeichnen
			ZeichneFrequenzen(pDC);
			ZeichneDBSkala(pDC);
			m_Redraw=FALSE;
		}
}



void CFFTView::ZeichneTasten(CDC* pDC) 
{
	CSoundsDoc* pDoc = GetDocument();
	INT* pSampleRate=pDoc->GetSampleRate();

//	if (*pSampleRate!=0) 
//	{
		CRect rect;
		GetClientRect(rect);
		CAutoFont font("Century Gothic");
		font.SetDC(pDC->GetSafeHdc());
		font.SetHeight(16);
		font.SetFontColor(m_clrText);
		CFont *oldFont=pDC->SelectObject(&font);
		pDC->SetBkMode(TRANSPARENT);
		pDC->SetTextColor(font.GetFontColor());
		CPen WeissStift;
	  WeissStift.CreatePen(PS_SOLID,8,RGB(255,255,255));
		CPen SchwarzStift;
	  SchwarzStift.CreatePen(PS_SOLID,1,RGB(0,0,0));
		CPen GrauStift;
	  GrauStift.CreatePen(PS_SOLID,8,RGB(100,100,100));
	  pDC->SelectObject(&WeissStift);
		CBrush BrushWhite;
		BrushWhite.CreateSolidBrush(RGB(255,255,255));
		pDC->SelectObject(&BrushWhite);
		CBrush BrushBlack;
		BrushBlack.CreateSolidBrush(RGB(0,0,0));
		pDC->Rectangle (0,0,rect.right,HEIGHT_KLAVIER);
		LONG LastxWert,Abstand;

		INT FrequenzbreiteFFTAnsicht=m_TopCutkHz*1000;//*pSampleRate/2;
		DOUBLE BildProzentVonBottomCutHz = m_bIsFreqLinear?\
																			 m_BottomCutHz/(DOUBLE)FrequenzbreiteFFTAnsicht:\
																			 log(m_BottomCutHz)/log(FrequenzbreiteFFTAnsicht);
		for (UINT i=0; i<=88; i++)
		{
			DOUBLE Cent=1.00057778951;//ldexp(1,(DOUBLE)1/(DOUBLE)1200);
			DOUBLE FrequenzLinear=pow(Cent,(i*100))*27.5;
			DOUBLE ProzentwertKlein=m_bIsFreqLinear?\
															FrequenzLinear/(DOUBLE)FrequenzbreiteFFTAnsicht-BildProzentVonBottomCutHz:\
															log(FrequenzLinear)/log(FrequenzbreiteFFTAnsicht)-BildProzentVonBottomCutHz;
			DOUBLE ProzentwertSkaliertAuf100=ProzentwertKlein/(1-BildProzentVonBottomCutHz);
			m_FrequenzbereichFFT=FrequenzbreiteFFTAnsicht-m_BottomCutHz;
			LONG xWert=(LONG)(HEIGHT_FREQ_RULER+ProzentwertSkaliertAuf100*(rect.right-HEIGHT_FREQ_RULER));
			if (i>0) Abstand=xWert-LastxWert;
			else Abstand=8;
			pDC->SelectObject(&SchwarzStift);
			if ((i==2)||(i==5)||(i==7)||(i==10)||(i==12)||(i==14)||(i==17)||(i==19)||(i==22)||(i==24)\
					||(i==26)||(i==29)||(i==31)||(i==34)||(i==36)||(i==38)||(i==41)||(i==43)||(i==46)||(i==48)\
					||(i==50)||(i==53)||(i==55)||(i==58)||(i==60)||(i==62)||(i==65)||(i==67)||(i==70)\
					||(i==72)||(i==74)||(i==77)||(i==79)||(i==82)||(i==84)||(i==86))
			{
				pDC->SelectObject(&BrushBlack);
				pDC->SelectObject(&SchwarzStift);
				pDC->MoveTo(LastxWert+Abstand/2-Abstand/2,HEIGHT_KLAVIER-8);
				pDC->LineTo(LastxWert+Abstand/2-Abstand/2,HEIGHT_KLAVIER+3);
/*				pDC->LineTo(xWert,HEIGHT_KLAVIER-5);
				pDC->LineTo(xWert,0);
*/
				pDC->Rectangle (LastxWert-Abstand/2,0,xWert-Abstand/2,HEIGHT_KLAVIER-8);
			}
			if ((i==0)||(i==3)||(i==8)||(i==15)||(i==20)||(i==27)||(i==32)||(i==39)||(i==44)||(i==51)\
					||(i==56)||(i==63)||(i==68)||(i==75)||(i==80)||(i==87))
			{
				pDC->MoveTo(xWert-Abstand/2,0);
				pDC->LineTo(xWert-Abstand/2,HEIGHT_KLAVIER+3);
			}
			if (i==88)
			{
				pDC->MoveTo(xWert,0);
				pDC->LineTo(xWert,HEIGHT_KLAVIER+3);
				CString Text;
				Text.LoadString(IDS_ZEICHNETASTEN);
				pDC->TextOut(xWert+20,HEIGHT_KLAVIER-18,Text);
			}
			if (i==39)
				pDC->TextOut(xWert,HEIGHT_KLAVIER-10,"c");
			LastxWert=xWert;			
		}
		pDC->MoveTo(0,HEIGHT_KLAVIER+3);
		pDC->LineTo(rect.right,HEIGHT_KLAVIER+3);
/*
		char buffer[20];
		CString AddOn;
		AddOn=" Hz";
		CString strFrequenz=gcvt( Frequenz, 5, buffer);

		pDC->TextOut(point.x+5,point.y-15,strFrequenz+AddOn);
*/
		pDC->SelectObject(oldFont);
//	}
}

void CFFTView::ZeichneFrequenzen(CDC* pDC)
{
	CSoundsDoc* pDoc = GetDocument();
	CRect rect;
	GetClientRect(rect);

	CPen KurvenStift;
	KurvenStift.CreatePen(PS_SOLID,1,m_clrText);
	CPen RasterStift;
	RasterStift.CreatePen(PS_DOT,1,RGB(130,130,130));
	pDC->SelectObject(&KurvenStift);

	CAutoFont font("Century Gothic");
	font.SetDC(pDC->GetSafeHdc());
	font.SetHeight(16);
	font.SetFontColor(m_clrText);
	pDC->FillSolidRect(0,rect.bottom-HEIGHT_FREQ_RULER,rect.right,HEIGHT_FREQ_RULER,m_clrBkg);
	CFont *oldFont=pDC->SelectObject(&font);
	pDC->SetBkMode(TRANSPARENT);
	pDC->SetTextColor(font.GetFontColor());

	INT SampleRate=*pDoc->GetSampleRate();
//	if (SampleRate>0) 
//	{

		DWORD StricheProClientRect=m_bIsFreqLinear?(DWORD)((DOUBLE)SampleRate/2000):18;
		INT FrequenzbreiteFFTAnsicht=m_TopCutkHz*1000;

		//Frequenzen unter m_BottomCutHz ausschneiden wegen Darstellungsverlust
		//die ersten 10 Hz entsprechen ca. 1/5 des Bildraums in der Oktavdarstellung
		DOUBLE BildProzentVonBottomCutHz = m_bIsFreqLinear?\
																			 m_BottomCutHz/(DOUBLE)FrequenzbreiteFFTAnsicht:\
																			 log(m_BottomCutHz)/log(FrequenzbreiteFFTAnsicht);
		LONG LastTextxWert=0;
		for (UINT i=0; i<=StricheProClientRect; i++)
		{
			m_FrequenzbereichFFT=FrequenzbreiteFFTAnsicht-m_BottomCutHz;
			INT FrequenzLinear;
			INT Faktor=(INT)(MAX((INT)floor((((DOUBLE)SampleRate/88200+(DOUBLE)m_FrequenzbereichFFT/11000))),1));
			if (m_bIsFreqLinear)
				FrequenzLinear=(INT)(Faktor*1000*i);
			else
				FrequenzLinear=(INT)(ldexp(1.71875,i));
			//Frequenzen von m_BottomCutHz bis m_TopCutkHz auf ClientRect skalieren
			DOUBLE ProzentwertKlein=m_bIsFreqLinear?\
															FrequenzLinear/(DOUBLE)FrequenzbreiteFFTAnsicht-BildProzentVonBottomCutHz:\
															log(FrequenzLinear)/log(FrequenzbreiteFFTAnsicht)-BildProzentVonBottomCutHz;
			DOUBLE ProzentwertSkaliertAuf100=ProzentwertKlein/(1-BildProzentVonBottomCutHz);
			LONG xWert=(LONG)(HEIGHT_FREQ_RULER+ProzentwertSkaliertAuf100*(rect.right-HEIGHT_FREQ_RULER));
			if (xWert>=0&&xWert<=rect.right) 
			{
				pDC->MoveTo(xWert,rect.bottom-HEIGHT_FREQ_RULER);
				pDC->LineTo(xWert,rect.bottom-HEIGHT_FREQ_RULER+6);
				if (m_bGrid) 
				{
					pDC->SelectObject(&RasterStift);
					pDC->MoveTo(xWert,rect.bottom-HEIGHT_FREQ_RULER);
					pDC->LineTo(xWert,HEIGHT_KLAVIER);
					pDC->SelectObject(&KurvenStift);
				}
			}
			char buffer[20];
			CString AddOn;
			AddOn=" Hz";
			CString Zeit;
			Zeit=itoa( FrequenzLinear, buffer, 10 );
			if (FrequenzLinear>1000) 
			{
				INT FrequenzTausend=FrequenzLinear/1000;
				if (FrequenzTausend>10) 
					Zeit=itoa( FrequenzTausend, buffer, 10 );
				else
				{
					INT Zweite=(FrequenzLinear%1000)/100;
					CString strErste=itoa( FrequenzTausend, buffer, 10 );
					CString strZweite=itoa( Zweite, buffer, 10 );
					Zeit=strErste+","+strZweite;
				}
				AddOn=" kHz";
			}
			if ((xWert-15)>=0&&(xWert-15)<=rect.right&&xWert>LastTextxWert+40) 
			{
				pDC->TextOut(xWert-15,rect.bottom-HEIGHT_FREQ_RULER+4,Zeit+AddOn);
				LastTextxWert=xWert;
			}
//			DWORD Rasterklein=(DWORD)(Raster);
			LONG Marker1Pos,Marker2Pos,LastxWert;
			Marker2Pos=xWert;
			if (i>0) 
			 Marker1Pos=LastxWert;

			if (i>0) 
			{
				DOUBLE PixelbreiteMarkerabstandKlein=(DOUBLE)(Marker2Pos-Marker1Pos)/12;
				for (INT j=1; j<12; j++ )
				{
					if ((xWert-(LONG)(j*PixelbreiteMarkerabstandKlein))>=0&&(xWert-(LONG)(j*PixelbreiteMarkerabstandKlein))<=rect.right) 
					{
						pDC->MoveTo(xWert-(LONG)(j*PixelbreiteMarkerabstandKlein),rect.bottom-HEIGHT_FREQ_RULER);
						pDC->LineTo(xWert-(LONG)(j*PixelbreiteMarkerabstandKlein),rect.bottom-HEIGHT_FREQ_RULER+3);
					}
				}
			}
			LastxWert=xWert;
		}
	pDC->MoveTo(0,rect.bottom-HEIGHT_FREQ_RULER);
	pDC->LineTo(rect.right,rect.bottom-HEIGHT_FREQ_RULER);
	pDC->SelectObject(oldFont);
}

void CFFTView::ZeichneDBSkala(CDC* pDC)
{
	CSoundsDoc* pDoc = GetDocument();
	CRect rect;
	GetClientRect(rect);

	CPen KurvenStift;
	KurvenStift.CreatePen(PS_SOLID,1,m_clrText);
	pDC->SelectObject(&KurvenStift);
	CPen RasterStift;
	RasterStift.CreatePen(PS_DOT,1,RGB(130,130,130));
	pDC->FillSolidRect(0,HEIGHT_KLAVIER+3,HEIGHT_FREQ_RULER,rect.bottom-HEIGHT_FREQ_RULER-HEIGHT_KLAVIER-3,m_clrBkg);

	CPen RotStift;
	RotStift.CreatePen(PS_SOLID,1,RGB(255,0,0));

	CAutoFont font("Century Gothic");
	font.SetDC(pDC->GetSafeHdc());
	font.SetHeight(14);
	font.SetFontColor(m_clrText);
	font.SetOrientation(900);
	font.SetEscapement(900);

	CFont *oldFont=pDC->SelectObject(&font);
	pDC->SetBkMode(TRANSPARENT);
	pDC->SetTextColor(font.GetFontColor());

	INT SampleRate=*pDoc->GetSampleRate();
	INT BitRate=*pDoc->GetBitRate();

	CArray<DOUBLE,DOUBLE>* pFrequenzenArray=pDoc->GetFrequenzenArray();
	DOUBLE BitRateFFT=floor(log10(pFrequenzenArray->GetSize())/log10(2));
	if (BitRateFFT==0) 
		BitRateFFT=log10(*pDoc->GetFFTPoints())/log10(2);
	DWORD StricheProClientRect=m_bIsAmpLinear?120:25;
	DOUBLE AmplitudeFFTAnsicht=ldexp(1,BitRate);//BitRateFFT;
	INT MindB=(INT)(20*log10(1/ldexp(1,BitRate)));
	INT HoeheY=rect.bottom-HEIGHT_KLAVIER-HEIGHT_FREQ_RULER;
	DOUBLE MaxAmplitude=AmplitudeFFTAnsicht;
	DOUBLE BottomCutAmpInBits=pow(10,(DOUBLE)m_BottomCutAmp/20)*MaxAmplitude;
	DOUBLE TopCutAmpInBits=pow(10,(DOUBLE)m_TopCutAmp/20)*MaxAmplitude;

		LONG LastY=0;
		for (UINT i=1; i<=StricheProClientRect; i++)
		{
			INT Pegel;
			LONG yWert;
			DOUBLE Intensitaet;

			if (m_bIsAmpLinear)
			{
				Pegel=-(INT)(i);
				Intensitaet=pow(10,(DOUBLE)Pegel/20)*MaxAmplitude;
				if (Intensitaet>=TopCutAmpInBits&&Intensitaet<=BottomCutAmpInBits) 
					yWert=(LONG)(rect.bottom-HEIGHT_FREQ_RULER-HoeheY*(Intensitaet-TopCutAmpInBits)/(BottomCutAmpInBits-TopCutAmpInBits));
			}
			else
			{
				Pegel=-(INT)(i*5);
				Intensitaet=pow(10,(DOUBLE)Pegel/20)*MaxAmplitude;
				if (Intensitaet>=TopCutAmpInBits&&Intensitaet<=BottomCutAmpInBits) 
				{
 					if (Intensitaet>1) 
						yWert=(LONG)(rect.bottom-HEIGHT_FREQ_RULER\
													-HoeheY*(log(Intensitaet)/log(MaxAmplitude)-log(TopCutAmpInBits)/log(MaxAmplitude))\
													/(log(BottomCutAmpInBits)/log(MaxAmplitude)-log(TopCutAmpInBits)/log(MaxAmplitude)));
					else
						yWert=-1;
				}
			}
			
			if (yWert>=0&&yWert<=rect.bottom) 
			{
				pDC->SelectObject(&KurvenStift);
				if (yWert>LastY+40&&yWert<=rect.bottom-HEIGHT_FREQ_RULER-15)
				{
					char buffer[20];
					CString AddOn;
					AddOn="dB";
					CString Amp;	
					Amp=itoa( Pegel, buffer, 10 );
					pDC->TextOut(0,yWert+15,Amp+AddOn);
 					LastY=yWert;
					pDC->SelectObject(&RotStift);
				}
				pDC->MoveTo(HEIGHT_FREQ_RULER-4,yWert);
				pDC->LineTo(HEIGHT_FREQ_RULER,yWert);
				if (m_bGrid) 
				{
					pDC->SelectObject(&RasterStift);
					pDC->MoveTo(HEIGHT_FREQ_RULER,yWert);
					pDC->LineTo(rect.right,yWert);
				}
			}
		}	
//		CPen AchsenStift;
//		AchsenStift.CreatePen(PS_SOLID,1,RGB(255,255,255));
		pDC->SelectObject(&KurvenStift);
		pDC->MoveTo(HEIGHT_FREQ_RULER,rect.bottom);
		pDC->LineTo(HEIGHT_FREQ_RULER,HEIGHT_KLAVIER);
		pDC->SelectObject(oldFont);
}


BOOL CFFTView::OnCreateClient(LPCREATESTRUCT,CCreateContext* pContext)
{

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Diagnose CFFTView

#ifdef _DEBUG
void CFFTView::AssertValid() const
{
	CView::AssertValid();
}

void CFFTView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CFFTView 

BOOL CFFTView::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
}

void CFFTView::OnRButtonDown(UINT nFlags, CPoint point) 
{
if (m_bIsSpline||m_bIsCrossVisible) 
{
	//check if the mouse left clicking into one of the control points
	int index = IsInsideControlPoint(point);
	
	if(index >= 0)
	{
		//we are removing a control point
		m_MoveIndex = index;
		POINT Punkt;
		Punkt.x=index;								//bedeutet: welcher Punkt
		Punkt.y=0;										//bedeutet: REMOVE
		m_CtrlControlPoints.Add(Punkt);
	}
	else //we are adding control points
	{
		m_CtrlControlPoints.Add(point); //bedeutet: ADD diesen Punkt weil Punkt.y!=0
	}
	Invalidate(TRUE);
	CView::OnRButtonDown(nFlags, point);
}
}

void CFFTView::OnMouseMove(UINT nFlags, CPoint point) 
{
if (nFlags==MK_RBUTTON&&(m_bIsSpline||m_bIsCrossVisible))
{
/*
	if(m_MoveIndex >= 0)
	{
		m_ControlPoints[m_MoveIndex] = point;

		if(m_ControlPoints.GetSize()>1)
		{
			Spline spline(m_ControlPoints.GetData(), m_ControlPoints.GetSize());
			spline.Generate();
	
			m_CurvePoints.SetSize(spline.GetCurveCount());
			int PointCount = 0;
			spline.GetCurve(m_CurvePoints.GetData(), PointCount);
		}
		Invalidate(TRUE);
	}
*/
}	
if (nFlags==MK_LBUTTON&&point.y<HEIGHT_FREQ_RULER) 
{
//  m_Gen.StopGen();
	CSoundsDoc* pDoc = GetDocument();
	CRect rect;
	GetClientRect(rect);
	INT FrequenzbreiteFFTAnsicht=m_TopCutkHz*1000;//*pSampleRate/2;
	DOUBLE BildProzentVonBottomCutHz = m_bIsFreqLinear?\
																		 m_BottomCutHz/(DOUBLE)FrequenzbreiteFFTAnsicht:\
																		 log(m_BottomCutHz)/log(FrequenzbreiteFFTAnsicht);

	DOUBLE ProzentwertSkaliertAuf100=(DOUBLE)(point.x-HEIGHT_FREQ_RULER)/(rect.right-HEIGHT_FREQ_RULER);
	DOUBLE ProzentwertKlein=ProzentwertSkaliertAuf100*(1-BildProzentVonBottomCutHz);

	DOUBLE Frequenz=m_bIsFreqLinear?
									(ProzentwertKlein+BildProzentVonBottomCutHz)*FrequenzbreiteFFTAnsicht:
									exp((ProzentwertKlein+BildProzentVonBottomCutHz)*log(FrequenzbreiteFFTAnsicht));

	Beep((INT)Frequenz,50);									
//	pDoc->m_Gen.FillBuf((INT)Frequenz,1,0,1);
//	pDoc->m_Gen.GenFreq();
}

	CView::OnMouseMove(nFlags, point);
}

void CFFTView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	m_MoveIndex = -1;
	CSoundsDoc* pDoc=GetDocument();
	if (pDoc->m_pViewNotenbild!=NULL)
		pDoc->UpdateAllViews(NULL,50);
	CView::OnRButtonUp(nFlags, point);
}

int CFFTView::IsInsideControlPoint(POINT& point)
{
	int count = m_ControlPoints.GetSize();

	if(count>0)	
	{
		for(int i=0; i<count; i++)
		{
			if(Distance(m_ControlPoints[i], point)<5)
				return i;
		}
	}

	return -1;

}

double CFFTView::Distance(const POINT& p1, const POINT& p2)
{
	int dx = abs(p1.x - p2.x);
	int dy = abs(p1.y - p2.y);

	return sqrt(dx*dx + dy*dy);

}

void CFFTView::DrawCross(POINT point, COLORREF rgbColor, int extent,CDC* pDC)
{
//	CDC* pDC=GetDC();
	CPen Pen;
	Pen.CreatePen(PS_SOLID,1,rgbColor);
	pDC->SelectObject(&Pen);
	
	pDC->MoveTo(point.x - extent, point.y);
	pDC->LineTo(point.x + extent, point.y);
    
	pDC->MoveTo(point.x, point.y - extent);
  pDC->LineTo(point.x, point.y + extent);
}

void CFFTView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//Spline entfernen
	if (m_ControlPoints.GetSize()>0) 
	{
		m_ControlPoints.RemoveAll();
		m_CurvePoints.RemoveAll();
//		m_CtrlControlPoints.RemoveAll();
	}

	CSoundsDoc* pDoc = GetDocument();
	INT* pSampleRate=pDoc->GetSampleRate();

	if (*pSampleRate!=0) 
	{
		CDC* pDC=GetDC();
		CRect rect;
		GetClientRect(rect);
				
		CAutoFont font("Century Gothic");
		font.SetDC(pDC->GetSafeHdc());
		font.SetHeight(16);
		font.SetFontColor(RGB(255,255,255));
		CFont *oldFont=pDC->SelectObject(&font);
		pDC->SetBkMode(TRANSPARENT);
		pDC->SetTextColor(font.GetFontColor());
		CPen Stift;
	  Stift.CreatePen(PS_SOLID,1,RGB(255,255,255));
	  pDC->SelectObject(&Stift);

		
		//Berechne Frequenz
		INT FrequenzbreiteFFTAnsicht=m_TopCutkHz*1000;//*pSampleRate/2;
		DOUBLE BildProzentVonBottomCutHz = m_bIsFreqLinear?\
																			 m_BottomCutHz/(DOUBLE)FrequenzbreiteFFTAnsicht:\
																			 log(m_BottomCutHz)/log(FrequenzbreiteFFTAnsicht);

		DOUBLE ProzentwertSkaliertAuf100=(DOUBLE)(point.x-HEIGHT_FREQ_RULER)/(rect.right-HEIGHT_FREQ_RULER);
		DOUBLE ProzentwertKlein=ProzentwertSkaliertAuf100*(1-BildProzentVonBottomCutHz);

		DOUBLE Frequenz=m_bIsFreqLinear?
										(ProzentwertKlein+BildProzentVonBottomCutHz)*FrequenzbreiteFFTAnsicht:
										exp((ProzentwertKlein+BildProzentVonBottomCutHz)*log(FrequenzbreiteFFTAnsicht));
		char buffer[20];
		CString AddOn;
		AddOn=" Hz";
		CString strFrequenz=gcvt( Frequenz, 5, buffer);
		strFrequenz=strFrequenz.Left(strFrequenz.Find(".")+2); 

		//Berechne Pegel
		DOUBLE Intensitaet,Pegel;
		INT SampleRate=*pDoc->GetSampleRate();
		INT BitRate=*pDoc->GetBitRate();
		DOUBLE AmplitudeFFTAnsicht=ldexp(1,BitRate);//BitRateFFT;
		INT HoeheY=rect.bottom-HEIGHT_KLAVIER-HEIGHT_FREQ_RULER;
		DOUBLE MaxAmplitude=AmplitudeFFTAnsicht;
		DOUBLE BottomCutAmpInBits=pow(10,(DOUBLE)m_BottomCutAmp/20)*MaxAmplitude;
		DOUBLE TopCutAmpInBits=pow(10,(DOUBLE)m_TopCutAmp/20)*MaxAmplitude;

		if (m_bIsAmpLinear)
		{
		  Intensitaet=(-point.y+rect.bottom-HEIGHT_FREQ_RULER)*(BottomCutAmpInBits-TopCutAmpInBits)/HoeheY+TopCutAmpInBits;
			Pegel=log10(Intensitaet/MaxAmplitude)*20;
		}
		else
		{
		  Intensitaet=exp((-point.y+rect.bottom-HEIGHT_FREQ_RULER)*\
									(log(BottomCutAmpInBits)-log(TopCutAmpInBits))/HoeheY+log(TopCutAmpInBits));
			Pegel=log10(Intensitaet/MaxAmplitude)*20;
		}

		CString AddOn2;
		AddOn2=" dB";
		CString Amp;	
		Amp=gcvt( Pegel, 5, buffer);
		Amp=Amp.Left(Amp.Find(".")+2); 


		//Werte ausgeben
//		pDC->MoveTo(point.x,0);
//		pDC->LineTo(point.x,rect.bottom);
//		pDC->TextOut(point.x+5,point.y-15,strFrequenz+AddOn);
		pDC->MoveTo(point.x-5,point.y-5);
		pDC->LineTo(point.x+5,point.y+5);
		pDC->MoveTo(point.x-5,point.y+5);
		pDC->LineTo(point.x+5,point.y-5);
		pDC->TextOut(rect.right-HEIGHT_FREQ_RULER-35,HEIGHT_KLAVIER+5,strFrequenz+AddOn);
		pDC->TextOut(rect.right-HEIGHT_FREQ_RULER-40,HEIGHT_KLAVIER+20,Amp+AddOn2);
		pDC->SelectObject(oldFont);

		//Ton ausgeben, wenn auf Klaviertaste gedrckt
		if (point.y<HEIGHT_KLAVIER+3) 
		{
//			if (g_bIsPlayingWave) 
				Beep((INT)Frequenz,400);
/*
//			else
			{
				pDoc->m_Gen.FillBuf((INT)Frequenz,1,0,1);
				pDoc->m_Gen.GenFreq();
			}
*/
		}
	}
	
	CView::OnLButtonDown(nFlags, point);
}

void CFFTView::OnLButtonUp(UINT nFlags, CPoint point) 
{
/*
	CSoundsDoc* pDoc = GetDocument();
 	if (!g_bIsPlayingWave)//||!g_bIsCapturing) 
	  pDoc->m_Gen.StopGen();
*/
	Invalidate(TRUE);	
	CView::OnLButtonUp(nFlags, point);
}


void CFFTView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (lHint==50)
	{
		CSoundsDoc* pDoc=GetDocument();
		INT NumFFTPoints=*pDoc->GetFFTPoints();
		char buffer[20];
		CString Pts=itoa( NumFFTPoints, buffer, 10 );
		CEdit* pEditNumFFTPoints=(CEdit*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_FFTPOINTS_FELD);
		pEditNumFFTPoints->SetWindowText(Pts);
		m_Redraw=TRUE;
		Invalidate(TRUE);
	}
	if (g_bIsCapturing||g_bIsPlayingWave)
	{
		Invalidate(TRUE);
		CRect rect;
		GetClientRect(rect);
		rect.bottom=HEIGHT_KLAVIER;
		ValidateRect(rect);
		GetClientRect(rect);
		rect.right=HEIGHT_FREQ_RULER;
		ValidateRect(rect);
		GetClientRect(rect);
		rect.top=rect.bottom-HEIGHT_FREQ_RULER;
		ValidateRect(rect);
	}

	if (g_bIsPutPoints)
	{
		CSoundsDoc* pDoc=GetDocument();
		INT NumBigFFTPoints=*pDoc->GetBigFFTPoints();
		char buffer[20];
		CString Pts=itoa( NumBigFFTPoints, buffer, 10 );
		CEdit* pEditNumFFTPoints=(CEdit*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_FFTPOINTS_FELD);
		pEditNumFFTPoints->SetWindowText(Pts);
		m_Redraw=TRUE;
		Invalidate(TRUE);
	}
	if (lHint==0)
	{
		m_Redraw=TRUE;
		Invalidate(TRUE);
	}
}


void CFFTView::OnChangeTopcutampFeld() 
{
	m_TopCutAmp=m_pParentFFTFrame->m_wndDlgBar.GetDlgItemInt(IDC_TOPCUTAMP_FELD);
	if (m_BottomCutAmp<m_TopCutAmp) 
	{
		m_BottomCutAmp=m_BottomCutAmp+5;
		m_pBottumCutAmpCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BOTTOMCUTAMP_SPIN);
		m_pBottumCutAmpCtrl->SetPos(m_BottomCutAmp);
	}
	m_LastViewPtFreqArray.RemoveAll();
	m_CtrlControlPoints.RemoveAll();
	Invalidate(TRUE);
}

void CFFTView::OnChangeBottomcutampFeld() 
{
	m_BottomCutAmp=m_pParentFFTFrame->m_wndDlgBar.GetDlgItemInt(IDC_BOTTOMCUTAMP_FELD);
	if (m_BottomCutAmp<m_TopCutAmp) 
	{
		m_TopCutAmp=m_BottomCutAmp-5;
		m_pTopCutAmpCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_TOPCUTAMP_SPIN);
		m_pTopCutAmpCtrl->SetPos(m_TopCutAmp);
	}
	m_LastViewPtFreqArray.RemoveAll();
		m_CtrlControlPoints.RemoveAll();
	Invalidate(TRUE);
}

void CFFTView::OnChangeBottomcutFeld() 
{
	m_BottomCutHz=m_pParentFFTFrame->m_wndDlgBar.GetDlgItemInt(IDC_BOTTOMCUT_FELD);
	m_LastViewPtFreqArray.RemoveAll();
	Invalidate(TRUE);
}

void CFFTView::OnChangeTopcutFeld() 
{
	m_TopCutkHz=m_pParentFFTFrame->m_wndDlgBar.GetDlgItemInt(IDC_TOPCUT_FELD);
	m_LastViewPtFreqArray.RemoveAll();
		m_CtrlControlPoints.RemoveAll();
	Invalidate(TRUE);
}

void CFFTView::OnScaleAmpLin() 
{
	m_bIsAmpLinear=TRUE;
	m_pTopCutAmpCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BOTTOMCUTAMP_SPIN);
	m_pTopCutAmpCtrl->SetPos(-15);
	Invalidate(TRUE);
}

void CFFTView::OnScaleAmpLog() 
{
	m_bIsAmpLinear=FALSE;
	m_pTopCutAmpCtrl=(CSpinButtonCtrl*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BOTTOMCUTAMP_SPIN);
	m_pTopCutAmpCtrl->SetPos(0);
	Invalidate(TRUE);
}

void CFFTView::OnScaleFreqLin() 
{
	m_LastViewPtFreqArray.RemoveAll();
	m_bIsFreqLinear=TRUE;
	Invalidate(TRUE);
}

void CFFTView::OnScaleFreqLog() 
{
	m_LastViewPtFreqArray.RemoveAll();
	m_bIsFreqLinear=FALSE;
	Invalidate(TRUE);
}

void CFFTView::OnBalken() 
{
	CButton* pRadioBalken=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BALKEN);
	pRadioBalken->SetCheck(1);
	CButton* pRadioLinien=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_LINIEN);
	pRadioLinien->SetCheck(0);
	CButton* pRadioSaulen=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SAULEN);
	pRadioSaulen->SetCheck(0);
	m_bDarstellung=0;
	Invalidate(TRUE);
}

void CFFTView::OnLinien() 
{
	CButton* pRadioBalken=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BALKEN);
	pRadioBalken->SetCheck(0);
	CButton* pRadioLinien=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_LINIEN);
	pRadioLinien->SetCheck(1);
	CButton* pRadioSaulen=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SAULEN);
	pRadioSaulen->SetCheck(0);
	m_bDarstellung=1;
	Invalidate(TRUE);
}

void CFFTView::OnSaulen() 
{
	CButton* pRadioBalken=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_BALKEN);
	pRadioBalken->SetCheck(0);
	CButton* pRadioLinien=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_LINIEN);
	pRadioLinien->SetCheck(0);
	CButton* pRadioSaulen=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_SAULEN);
	pRadioSaulen->SetCheck(1);
	m_bDarstellung=2;
	Invalidate(TRUE);
}

void CFFTView::OnCheckSumme() 
{
	CButton* pCheckSumme=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SUMME);
	if (pCheckSumme->GetCheck())
		m_bIsSumme=TRUE;
	else
	{
		m_bIsSumme=FALSE;
		m_LastViewPtFreqArray.RemoveAll();
	}
	Invalidate(TRUE);
}

void CFFTView::OnCheckGrid() 
{
	CButton* pCheckGrid=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_GRID);
	if (m_bGrid)
		m_bGrid=FALSE;
	else
		m_bGrid=TRUE;
	Invalidate(TRUE);
}


void CFFTView::OnChangeDelayFeld() 
{
	m_Delay=m_pParentFFTFrame->m_wndDlgBar.GetDlgItemInt(IDC_DELAY_FELD2);
	Invalidate(TRUE);
}

void CFFTView::OnChangeAbstandFeld() 
{
	m_MinAbstandMaxima=m_pParentFFTFrame->m_wndDlgBar.GetDlgItemInt(IDC_ABSTAND_FELD);
	m_CtrlControlPoints.RemoveAll();
	Invalidate(TRUE);
}
void CFFTView::OnChangeAbstandFeld2() 
{
	m_MinAbstandNachbarMin=m_pParentFFTFrame->m_wndDlgBar.GetDlgItemInt(IDC_ABSTAND_FELD2);
	m_CtrlControlPoints.RemoveAll();
	Invalidate(TRUE);
}

void CFFTView::OnCheckPeakkreuz() 
{
	CButton* pCheckPeak=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_PEAKKREUZ);
	CButton* pCheckDelay=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_DELAY);
	CEdit* pEdit=(CEdit*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_DELAY_FELD2);
	if (pCheckPeak->GetCheck())
	{
		m_bIsCrossVisible=TRUE;
		pCheckDelay->SetCheck(0);
		pEdit->EnableWindow(FALSE);
		m_bIsDelay=FALSE;
	}
	else
		m_bIsCrossVisible=FALSE;

	Invalidate(TRUE);
}

void CFFTView::OnCheckDelay() 
{
	CButton* pCheckDelay=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_DELAY);
	CButton* pCheckPeak=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_PEAKKREUZ);
	CEdit* pEdit=(CEdit*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_DELAY_FELD2);
	if (pCheckDelay->GetCheck())
	{
		m_bIsDelay=TRUE;
		pCheckPeak->SetCheck(0);
		pEdit->EnableWindow(TRUE);
		m_bIsCrossVisible=FALSE;
	}
	else
	{
		m_bIsDelay=FALSE;
		pEdit->EnableWindow(FALSE);
	}
	Invalidate(TRUE);
}


void CFFTView::OnCheckSplineB() 
{
	CButton* pCheckSplineB=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_B);
	CButton* pCheckSplineC=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_D);
	CButton* pCheckSplineBeta=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_BETA);
	CButton* m_pCheckCross=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_PEAKKREUZ);
	if (pCheckSplineB->GetCheck()||pCheckSplineC->GetCheck()||pCheckSplineBeta->GetCheck()) 
		m_bIsSpline=TRUE;
	else
		m_bIsSpline=FALSE;
	if (m_bIsSpline)
		m_SplineTyp=1;
	else
		m_SplineTyp=0;
	pCheckSplineC->SetCheck(0);
	pCheckSplineBeta->SetCheck(0);
	Invalidate(TRUE);
}

void CFFTView::OnCheckSplineC() 
{
	CButton* pCheckSplineB=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_B);
	CButton* pCheckSplineC=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_D);
	CButton* pCheckSplineBeta=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_BETA);
	CButton* m_pCheckCross=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_PEAKKREUZ);
	if (pCheckSplineB->GetCheck()||pCheckSplineC->GetCheck()||pCheckSplineBeta->GetCheck()) 
		m_bIsSpline=TRUE;
	else
		m_bIsSpline=FALSE;

	if (m_bIsSpline)
		m_SplineTyp=2;
	else
		m_SplineTyp=0;
	pCheckSplineB->SetCheck(0);
	pCheckSplineBeta->SetCheck(0);
	Invalidate(TRUE);
}

void CFFTView::OnCheckSplineBeta() 
{
	CButton* pCheckSplineB=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_B);
	CButton* pCheckSplineC=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_D);
	CButton* pCheckSplineBeta=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPLINE_BETA);
	CButton* m_pCheckCross=(CButton*)m_pParentFFTFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_PEAKKREUZ);
	if (pCheckSplineB->GetCheck()||pCheckSplineC->GetCheck()||pCheckSplineBeta->GetCheck()) 
		m_bIsSpline=TRUE;
	else
		m_bIsSpline=FALSE;
	if (m_bIsSpline)
		m_SplineTyp=3;
	else
		m_SplineTyp=0;
	pCheckSplineC->SetCheck(0);
	pCheckSplineB->SetCheck(0);
	Invalidate(TRUE);
}

void CFFTView::OnEditClearall() 
{
	CPoint Nullpunkt;
	Nullpunkt.x=0;
	Nullpunkt.y=0;
  m_ViewPtFreqArray.RemoveAll();
	m_ViewPtFreqArray.Add(Nullpunkt);
  m_LastViewPtFreqArray.RemoveAll();
	m_LastViewPtFreqArray.Add(Nullpunkt);
	m_ControlPoints.RemoveAll();
	m_CtrlControlPoints.RemoveAll();
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->DeleteContents();
	Invalidate(TRUE);
	pDoc->UpdateAllViews(NULL,50);
}

void CFFTView::OnSave() 
{
	// Obtain a handle to a reference device context. 
	CDC* RefDC = GetDC(); 
 
	// Determine the picture frame dimensions. 
	// iWidthMM is the display width in millimeters. 
	// iHeightMM is the display height in millimeters. 
	// iWidthPels is the display width in pixels. 
	// iHeightPels is the display height in pixels 
 
	INT iWidthMM = GetDeviceCaps(RefDC->GetSafeHdc(), HORZSIZE); 
	INT iHeightMM = GetDeviceCaps(RefDC->GetSafeHdc(), VERTSIZE); 
	INT iWidthPels = GetDeviceCaps(RefDC->GetSafeHdc(), HORZRES); 
	INT iHeightPels = GetDeviceCaps(RefDC->GetSafeHdc(), VERTRES); 
 
	// Retrieve the coordinates of the client rectangle, in pixels. 
	CRect rect;
	GetClientRect(rect); 
 
	// Convert client coordinates to .01-mm units. 
	// Use iWidthMM, iWidthPels, iHeightMM, and 
	// iHeightPels to determine the number of 
	// .01-millimeter units per pixel in the x- 
	//  and y-directions. 
 
	rect.left = (rect.left * iWidthMM * 100)/iWidthPels; 
	rect.top = (rect.top * iHeightMM * 100)/iHeightPels; 
	rect.right = (rect.right * iWidthMM * 100)/iWidthPels; 
	rect.bottom = (rect.bottom * iHeightMM * 100)/iHeightPels; 
 
	// Load the filename Dialog
	CFileDialog FotoFFTFileDlg(FALSE,NULL,NULL,OFN_OVERWRITEPROMPT|OFN_NOREADONLYRETURN|OFN_ENABLESIZING,\
              "WMF - Enhanced Metafile|*.wmf|");
  FotoFFTFileDlg.m_ofn.nFilterIndex=1;
	FotoFFTFileDlg.m_ofn.lpstrDefExt=".wmf";
	CString Text;
	Text.LoadString(IDS_SAVE_FFT);
	FotoFFTFileDlg.m_ofn.lpstrTitle=Text.GetBuffer(Text.GetLength());
  if (FotoFFTFileDlg.DoModal()==IDOK) 
	{
		// Create the metafile device context. 
		CString Pfad=FotoFFTFileDlg.GetPathName();
		LPTSTR strFileName=Pfad.GetBuffer(MAX_PATH);
		CMetaFileDC MetaFileDC;
		MetaFileDC.CreateEnhanced(RefDC,strFileName,rect,"SOUNDS Soundanalyse\0FFT Abbild\0\0");
		OnDraw(&MetaFileDC);
		HENHMETAFILE pMetaFile=MetaFileDC.CloseEnhanced();
		DeleteEnhMetaFile(pMetaFile);
	}
	// Release the reference device context. 
	ReleaseDC(RefDC); 
}

void CFFTView::OnEditCopy() 
{
	CMetaFileDC * pMetaDC = new CMetaFileDC();
	pMetaDC->CreateEnhanced(GetDC(),NULL,NULL,"SOUNDS Soundanalyse\0FFT Abbild\0\0");
	//draw meta file
	m_clrBkg=RGB(255,255,255);
	m_clrText=RGB(0,0,0);
	m_clrSpline=RGB(0,255,0);
	OnDraw(pMetaDC);

	//Achsenbeschriftung hinzufgen
	CRect rect;
	GetClientRect(rect);
	CAutoFont font("Tahoma");
	font.SetDC(pMetaDC->GetSafeHdc());
	font.SetHeight(16);
	font.SetWidth(8);
	font.SetBold(TRUE);
	font.SetFontColor(RGB(0,0,0));
	pMetaDC->SelectObject(&font);
	CString Text;
	Text.LoadString(IDS_FREQUENZ);
	pMetaDC->TextOut((INT)(rect.right/(FLOAT)2)-10,rect.bottom+5,Text);

	font.SetEscapement(900);
//	font.SetOrientation(900);
	pMetaDC->SelectObject(&font);
	Text.LoadString(IDS_AMPLITUDE);
	pMetaDC->TextOut(-25,(INT)(rect.bottom/(FLOAT)2+45),Text);
	
	//Farbwerte zurcksetzen
	m_clrBkg=RGB(0,0,0);
	m_clrText=RGB(255,255,255);
	m_clrSpline=RGB(255,255,0);
	//close meta file dc and prepare for clipboard;
	HENHMETAFILE hMF = pMetaDC->CloseEnhanced();

	//copy to clipboard
	// Open the clipboard...
	if(!OpenClipboard()) 
	{
    AfxMessageBox(IDS_OPEN_CLIPBOARD_FAIL);
    return;
	}
	EmptyClipboard();
	::SetClipboardData(CF_ENHMETAFILE,hMF);
	CloseClipboard();
	//DeleteMetaFile(hMF);
	delete pMetaDC;
}


void CFFTView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	m_LastViewPtFreqArray.RemoveAll();
	m_CtrlControlPoints.RemoveAll();
}

void CFFTView::OnExportdata() 
{
	if (!g_bIsPlayingWave||g_bIsCapturing) 
	{
	BeginWaitCursor();
	//Daten berechnen aus Frequenzarray und als Tabulator getrennte Werte in CString schreiben
	CString Ausgabe;
	char buffer[30];
	CString strFrequenz;
	CString strAmplitude;

	//1.Zeile schreiben
	Ausgabe.LoadString(IDS_EXPORT_FFT);

	CSoundsDoc* pDoc=GetDocument();
	CArray<DOUBLE,DOUBLE>* pFrequenzenArray=pDoc->GetFrequenzenArray();
	INT SamplingRate=*pDoc->GetSampleRate();
	INT MaxFrequenzen=pFrequenzenArray->GetSize();
	INT MaxAmplitude=*pDoc->GetMaxAmplitude();

	for	(INT i=0; i<MaxFrequenzen;i++)
	{
		DOUBLE Peak=pFrequenzenArray->GetAt(i);
		DOUBLE Frequenz=i*(SamplingRate/2/(DOUBLE)MaxFrequenzen);
		DOUBLE Pegel=20*log10(Peak/MaxAmplitude);
		strFrequenz=gcvt( Frequenz, 10, buffer);
//		strFrequenz=strFrequenz.Left(strFrequenz.Find(".")+5); 
    strFrequenz.Replace(".",",");
		strAmplitude=gcvt( Pegel, 10, buffer);
//		strAmplitude=strAmplitude.Left(strAmplitude.Find(".")+5); 
    strAmplitude.Replace(".",",");
		Ausgabe+=strFrequenz+_T("\t")+strAmplitude+_T("\r\n");
	}
	
	// Open the clipboard...
	if(!OpenClipboard()) 
	{
    AfxMessageBox(IDS_OPEN_CLIPBOARD_FAIL);
    return;
	}

	// Empty anything already there...
	EmptyClipboard();


	// Allocate global memory for transfer...
	HGLOBAL hText = GlobalAlloc(GMEM_MOVEABLE |GMEM_DDESHARE, strlen(Ausgabe)+4);

	// Put our string in the global memory...
	char* ptr = (char *)GlobalLock(hText);
	strcpy(ptr, Ausgabe);
	GlobalUnlock(hText);

	// Put data on the clipboard as CF_TEXT
	::SetClipboardData(CF_TEXT, hText);

	// Free memory...
	GlobalFree(hText);

	// Close clipboard...
	CloseClipboard();

	//Besttigung ausgeben
	AfxMessageBox(IDS_FFTVIEW_ONEXPORTDATA,MB_ICONEXCLAMATION);
	EndWaitCursor();
	}
}

