/////////////////////////////////////////////////////////////////////////////
// $Header: /cvsroot/mmconvert/mmconvert/MMConvert/Src/Common/Mp3Converter.cpp,v 1.8 2005/09/20 09:27:13 ping235 Exp $
//
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 ping235.  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//  This file is subject to the terms of the GNU General Public License as
//  published by the Free Software Foundation.  A copy of this license is
//  included with this software distribution in the file COPYING.  If you
//  do not have a copy, you may obtain a copy by writing to the Free
//  Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
// Change Log
//
// Date          Developer             Changes
// $Date: 2005/09/20 09:27:13 $        $Author: ping235 $              $Name:  $
//
/////////////////////////////////////////////////////////////////////////////
// CVS Log
// $Log: Mp3Converter.cpp,v $
// Revision 1.8  2005/09/20 09:27:13  ping235
// changed all IGraphBuilder::ConnectDirect into Connect&added lame mp3 codec option
//
// Revision 1.7  2005/09/20 08:01:23  ping235
// added /lame argument to using lame mp3 encoder instead of built-in mp3 encoder
//
// Revision 1.6  2005/09/20 06:19:14  ping235
// added lame mp3 codec support
//
// Revision 1.5  2005/09/08 09:43:18  ping235
// translate MMConvert into english
//
// Revision 1.4  2005/09/05 03:18:40  ping235
// modified TVException::ErrorCode
//
// Revision 1.3  2005/08/22 03:38:33  ping235
// modified exception:added context
//
// Revision 1.2  2005/08/18 00:42:45  ping235
// fixed some error,issue argument error if input file extension length less than output file extension
//
// Revision 1.1.1.1  2005/08/02 05:17:23  ping235
// initial,GUI 1.0.0.0,CMD 1.3.0.1
//
//////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include ".\mp3converter.h"
#include "helper.h"

CMp3Converter::CMp3Converter()
{
	m_bEnableMp3Compress = true;
	m_strMp3Codec = c_tszMp3CodecDispName;
}

CMp3Converter::~CMp3Converter(void)
{
}

// תԴļ,ȵô˺ܿʼAsf Writer
void CMp3Converter::SetInputFileName(LPCTSTR lpszFileName)
{
	if(!PathFileExists(lpszFileName))
	{
//		AfxMessageBox(E_SETINPUTFILENAME_FILENOTFOUND);
		HANDLE_TV_EXP(CTVException::E_FILE_NOT_FOUND);
	}

	//Render File,create play link
	WCHAR Name[MAX_PATH];
	wsprintfW(Name, L"%hs", lpszFileName);

	HRESULT hr = m_spGraphBuild->RenderFile((LPCWSTR)Name,NULL);
  if (FAILED(hr))
  {
 //   AfxMessageBox(E_SETINPUTFILENAME_RENDERFILE);
    return;
  }
	HANDLE_HR_EXP(hr);
}

void CMp3Converter::SetOutputFileName(LPCTSTR lpszFileName)
{
	m_strOutputFileName = lpszFileName;
}

BOOL CMp3Converter::BuildGraph(void)
{
	//get video and audio renderer
	CDShow::CBaseFilterList lstBV;
	CDShow::CBaseFilterList lstBA;
	HRESULT hr = CDShow::GetAVRenderer(m_spGraphBuild,lstBA,lstBV);
	HANDLE_HR_EXP(hr);
	if (FAILED(hr)) return FALSE;

	//ƵڣȾʧ
	if(lstBA.empty())
	{
		HANDLE_TV_EXP(CTVException::E_RENDER_FILE_FAILED);
		if (FAILED(hr)) return FALSE;
	}

	//ƵRenderer,Ƶ·ӵnull renderer 
	for(CDShow::CBaseFilterList::iterator spBV=lstBV.begin();spBV!=lstBV.end();spBV++)
	{
		//delete invalid filter
		hr = CDShow::NukeUpstream(m_spGraphBuild,*spBV);
		HANDLE_HR_EXP(hr);
		if (FAILED(hr)) return FALSE;

		//ɾVideo Renderer
		hr = CDShow::RemoveFilter(m_spGraphBuild,*spBV);
		HANDLE_HR_EXP(hr);
		if (FAILED(hr)) return FALSE;
	}

	//ΪÿһƵڽת·
	//ĿǰΪMp3Compressorֶ֧ͨͬʱУûδѡͨѡһͨ
	if(m_lstAudioChan.size()==0)
		m_lstAudioChan.push_back(1);
	int nIndex = 0;
	for(CDShow::CBaseFilterList::iterator spBA=lstBA.begin();spBA!=lstBA.end();spBA++)
	{
		nIndex++;
		//ǰͨûҪתģת
		//бʾתͨ
//		if((std::find(m_lstAudioChan.begin(),m_lstAudioChan.end(),nIndex)!=m_lstAudioChan.end())||
		if((std::find<std::list<int>::iterator,int>(m_lstAudioChan.begin(),m_lstAudioChan.end(),nIndex)!=m_lstAudioChan.end())||
			m_lstAudioChan.empty())
		{
			HRESULT hr = S_OK;

			//Create Wave Dest and insert into graph
			IBaseFilter* spWaveDest = NULL;
			hr = CDShow::AddFilterByClsid(m_spGraphBuild,CLSID_WaveDest,NULL/*_T("Wave Dest")*/,&spWaveDest);
			HANDLE_HR_EXP_V(hr,_T("WAVDest Filter nicht registriert.\nBitte rufen sie von der Kommandozeile 'regsvr32 wavdest.ax' auf um den Filter zu aktivieren.\nDie Datei ist im Paket mitgeliefert."));
			if (FAILED(hr)) return FALSE;

			//Create File Writer and insert into graph
			IBaseFilter* spFileWriter = NULL;
			hr = CDShow::AddFilterByClsid(m_spGraphBuild,CLSID_FileWriter,NULL/*_T("File Writer")*/,&spFileWriter);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;

			//set out file name
			IFileSinkFilter2* spFS = NULL;
			hr = spFileWriter->QueryInterface(IID_IFileSinkFilter2,(void**)&spFS);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;
			
			WCHAR Name[MAX_PATH];
			wsprintfW(Name, L"%hs", m_strOutputFileName.GetBuffer(MAX_PATH)	);

			hr = spFS->SetFileName((LPCOLESTR)(Name),NULL);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;
	    hr = spFS->SetMode(AM_FILE_OVERWRITE);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;

			//create Mp3 Codec and insert into graph
			IBaseFilter* spMp3Codec = NULL;
			if(m_bEnableMp3Compress)
			{
				hr = CDShow::AddFilterByName(m_spGraphBuild,m_strMp3Codec,NULL/*_T("Mp3 Codec")*/,&spMp3Codec);
				HANDLE_HR_EXP(hr);
				if (FAILED(hr)) return FALSE;
			}

			//Audio RendererӵPinӵMp3 CodecWav DestInput Pin
			IPin* spOutPin = NULL;
			hr = CDShow::FindConnectedPin(*spBA,&spOutPin);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;
			//ɾAudio Renderer
			hr = CDShow::RemoveFilter(m_spGraphBuild,*spBA);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;

			//Mp3 Codecmp3ʽļwavʽ
			IPin* spInPin = NULL;
			if(spMp3Codec!=NULL)
			{
				//ȡMp3 CompressorPin
				hr = CDShow::GetPin(spMp3Codec,PINDIR_INPUT,&spInPin);
				HANDLE_HR_EXP(hr);
				if (FAILED(hr)) return FALSE;

				//Mp3 Codec
				hr = m_spGraphBuild->Connect(spOutPin,spInPin);
				HANDLE_HR_EXP(hr);
				if (FAILED(hr)) return FALSE;

				//ȡMp3 CompressorPin
				spOutPin = NULL;
				hr = CDShow::GetPin(spMp3Codec,PINDIR_OUTPUT,&spOutPin);
				HANDLE_HR_EXP(hr);
				if (FAILED(hr)) return FALSE;
			}

			//ȡWave DestPin
			spInPin = NULL;
			hr = CDShow::GetPin(spWaveDest,PINDIR_INPUT,&spInPin);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;

			//Mp3 CodecWave Dest
			hr = m_spGraphBuild->Connect(spOutPin,spInPin);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;

			//ȡWave DestPin
			spOutPin = NULL;
			hr = CDShow::GetPin(spWaveDest,PINDIR_OUTPUT,&spOutPin);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;

			//ȡFile WriterPin
			spInPin = NULL;
			hr = CDShow::GetPin(spFileWriter,PINDIR_INPUT,&spInPin);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;

			//Wave DestFile Writer
			hr = m_spGraphBuild->Connect(spOutPin,spInPin);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;
		}
		//ת·ӵnull renderer
		else
		{
			//delete invalid filter
			hr = CDShow::NukeUpstream(m_spGraphBuild,*spBA);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;

			//ɾVideo Renderer
			hr = CDShow::RemoveFilter(m_spGraphBuild,*spBA);
			HANDLE_HR_EXP(hr);
			if (FAILED(hr)) return FALSE;
		}
	}
	return TRUE;
}


// ǷMp3ѹMp3ѹĸʽΪWav
void CMp3Converter::EnableMp3Compress(bool bEnable, CString strMp3Codec)
{
	if(bEnable&&strMp3Codec.IsEmpty())
		strMp3Codec = c_tszMp3CodecDispName;
	m_bEnableMp3Compress = bEnable;
	m_strMp3Codec = strMp3Codec;
}

CString CMp3Converter::GetOutputFileName(int nIndex)
{
	ASSERT(nIndex>0);
	CString str = m_strOutputFileName;
	if(nIndex!=1)
	{
		CString strExt = PathFindExtension(str);
		PathRemoveExtension(str.GetBuffer(str.GetLength()));
		str.ReleaseBuffer();
		str+=_T("(")+IntToStr(nIndex)+_T(")");
		if(!strExt.IsEmpty())
			str = str+_T(".")+strExt;
	}
	return str;
}

bool CMp3Converter::ParseCmdLine(CStringList& strlSpecParam)
{
	bool bRes = true;

	POSITION Pos = strlSpecParam.GetHeadPosition();
	while(Pos!=NULL)
	{
		CString strArg = strlSpecParam.GetNext(Pos);
		strArg.MakeLower();

		//ѡҪתƵͨڶƵļ
		if((strArg.Find(_T("/c:"))==0)||(strArg.Find(_T("-c:"))==0))
		{
			int nChan = 0;
			int nIndex = 0;
			//ĿǰΪMp3Compressorֶ֧ͨͬʱУԣʱ
			//ֻܵһѡͨ
			while((nChan = atoi(ParseString(LPCTSTR(strArg)+3,',',nIndex++)))!=0)
			//if((nChan = _tstoi(ParseString(LPCTSTR(strArg)+3,',',nIndex++)))!=0)
			{
				m_lstAudioChan.push_back(nChan);
			}
		}
		//set mp3 encoder
		else if((strArg==_T("/lame"))||(strArg==_T("-lame")))
		{
			m_strMp3Codec = c_tszLameMp3CodecDispName;
		}
		else
		{
			USES_CONVERSION;
//			printf(T2A(_T("Invalid argument: ")+strArg+_T("\n")));
			bRes = false;
			break;
		}
	}

	return bRes;
}

