#if !defined(AFX_REKOVIEW_H__426ECAF5_0136_4768_B799_54518DB97A06__INCLUDED_)
#define AFX_REKOVIEW_H__426ECAF5_0136_4768_B799_54518DB97A06__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RekoView.h : Header-Datei
//

// Meine Rekopunkte als Flexibles Vertex Format wie weiter unten definiert
typedef struct REKOVERTEX
{
public:
    FLOAT x, y, z;
//		FLOAT ptsize;
		DWORD color;
} REKOVERTEX, *LPREKOVERTEX;


// Our custom FVF, which describes our custom vertex structure
#define D3DFVF_REKOVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE)//|D3DFVF_PSIZE)

/////////////////////////////////////////////////////////////////////////////
// Ansicht CRekoView 
class CRekoView : public CView, public CD3DApplication
{
protected:
	CRekoView();           // Dynamische Erstellung verwendet geschtzten Konstruktor
	DECLARE_DYNCREATE(CRekoView)

    // Font for drawing text
    CD3DFont* m_pFont;
    CD3DFont* m_pFontSmall;

    // Scene
    LPDIRECT3DVERTEXBUFFER8 m_pVB;
    LPDIRECT3DVERTEXBUFFER8 m_pVBKoord;
    LPDIRECT3DVERTEXBUFFER8 m_pVBZeitreihe;
    DWORD        m_dwNumVertices;

    // Transforms
    D3DXMATRIXA16		m_matPosition;
    D3DXMATRIXA16		m_matView;
    D3DXMATRIXA16		m_matProj;

    // Navigation
    BYTE        m_bKey[256];
    FLOAT       m_fSpeed;
    FLOAT       m_fAngularSpeed;
    BOOL        m_bShowHelp;

    D3DXVECTOR3 m_vVelocity;
    D3DXVECTOR3 m_vAngularVelocity;

		FLOAT				x,y,z;
		POINT				m_ptPrev;

protected:
    HWND       m_hwndRenderWindow;
		CD3DRekoFrame* m_pParentRekoFrame;
		CClrButton				m_FarbButton;
		CClrButton				m_FarbButtonBkg;
		COLORREF					m_clrRekoREF;
		COLORREF					m_clrText;
		COLORREF					m_clrBkg;
		DWORD							m_clrBackBuffer;
		CSpinButtonCtrl*	m_pTauCtrl;
		CSpinButtonCtrl*	m_pPunkteCtrl;
		CEdit*						m_pTauWertCtrl;
		CEdit*						m_pPunkteWertCtrl;
		CButton*					m_pRadioFesteFarbe;
		CButton*					m_pRadioBunt;
		CButton*					m_pRadioLinien;
		CButton*					m_pRadioPunkte;


public:
  	CArray<FLOAT,FLOAT> m_RekoPtArray;   
		INT					m_NumRekoPoints;

public:	//Fr Zugriff von Steuerleiste aus.
		INT					m_Tau;	
		BOOL				m_Recalc;
		DWORD				m_clrReko;
		BOOL				m_bIsBunt;
		BOOL				m_bIsPunkte;
		FLOAT				m_SizePts;

public:
		HRESULT OneTimeSceneInit();
		void		IniFileWrite();
		void		IniFileRead();

protected:
    HRESULT InitDeviceObjects();
    HRESULT RestoreDeviceObjects();
    HRESULT InvalidateDeviceObjects();
    HRESULT DeleteDeviceObjects();
    HRESULT FinalCleanup();
    HRESULT ConfirmDevice( D3DCAPS8* pCaps, DWORD dwBehavior, D3DFORMAT Format );
    HRESULT Render();
    HRESULT FrameMove();
		void		DoFrameMove(char Buchstabe);

		
protected:
		HRESULT NeueRekoPunkte();
		inline CSoundsDoc* GetDocument() { return (CSoundsDoc*)m_pDocument; }
		DWORD		Farbwahl(INT counter);
		void		SwitchDlgItems(BOOL bVisible);

// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CRekoView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // berschrieben zum Zeichnen dieser Ansicht
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	virtual void CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType = adjustBorder);
	//}}AFX_VIRTUAL

// Implementierung
protected:
	virtual ~CRekoView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generierte Nachrichtenzuordnungsfunktionen
protected:
	//{{AFX_MSG(CRekoView)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnTogglehelp();
	afx_msg void OnTogglestart();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSinglestep();
	afx_msg void OnChangedevice();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnChangePunkteFeld();
	afx_msg void OnChangeTau();
	afx_msg void OnPunkte();
	afx_msg void OnLinien();
	afx_msg void OnFestefarbe();
	afx_msg void OnFarbwahl();
	afx_msg void OnButtonDrehzr();
	afx_msg void OnButtonDrehzl();
	afx_msg void OnButtonDrehyr();
	afx_msg void OnButtonDrehyl();
	afx_msg void OnButtonDrehxr();
	afx_msg void OnButtonDrehxl();
	afx_msg void OnBunt();
	afx_msg void OnRenderbtn();
	afx_msg void OnResetview();
	afx_msg void OnSave();
	afx_msg void OnEditClearall();
	afx_msg void OnEditCopy();
	afx_msg void OnBkgclr();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnChangeNumpunkteFeld();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnExportdata();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_REKOVIEW_H__426ECAF5_0136_4768_B799_54518DB97A06__INCLUDED_
