// SoundkarteDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "SoundkarteDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CSoundkarteDlg 


CSoundkarteDlg::CSoundkarteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSoundkarteDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSoundkarteDlg)
	m_Soundkarte_Ausgang_int = -1;
	m_Soundkarte_Eingang_int = -1;
	//}}AFX_DATA_INIT
}


void CSoundkarteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSoundkarteDlg)
	DDX_Control(pDX, IDC_SOUNDKARTE_EINGANG, m_Soundkarte_Eingang);
	DDX_Control(pDX, IDC_SOUNDKARTE_AUSGANG, m_Soundkarte_Ausgang);
	DDX_CBIndex(pDX, IDC_SOUNDKARTE_AUSGANG, m_Soundkarte_Ausgang_int);
	DDX_CBIndex(pDX, IDC_SOUNDKARTE_EINGANG, m_Soundkarte_Eingang_int);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSoundkarteDlg, CDialog)
	//{{AFX_MSG_MAP(CSoundkarteDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CSoundkarteDlg 

BOOL CSoundkarteDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
  HRESULT hr;
  if( FAILED( hr = OnInitDevicesDialog() ) )
  {
    DXTRACE_ERR( TEXT("OnInitDevicesDialog"), hr );
    MessageBox( "Error scanning DirectSoundCapture devices.", "DirectSound Sample", 
                MB_OK | MB_ICONERROR );
    EndDialog(hr);
  }
	
  TRACE("INIT");
  
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

//-----------------------------------------------------------------------------
// Name: OnInitDevicesDialog()
// Desc: Initializes the devices dialog
//-----------------------------------------------------------------------------
HRESULT CSoundkarteDlg::OnInitDevicesDialog()
{
    // Enumerate the capture devices and place them in the combo box
    DirectSoundCaptureEnumerate( (LPDSENUMCALLBACK)DSoundEnumCallback,(VOID*)m_Soundkarte_Eingang);
    DirectSoundEnumerate( (LPDSENUMCALLBACK)DSoundEnumCallback,(VOID*)m_Soundkarte_Ausgang);
    // Select the first device in the combo box
    m_Soundkarte_Eingang.SetCurSel(0);
    m_Soundkarte_Ausgang.SetCurSel(0);
    return S_OK;
}

//-----------------------------------------------------------------------------
// Name: DSoundEnumCallback()
// Desc: Enumeration callback called by DirectSoundEnumerate
//-----------------------------------------------------------------------------
INT_PTR CALLBACK CSoundkarteDlg::DSoundEnumCallback( GUID* pGUID, LPSTR strDesc, LPSTR strDrvName,
                                  VOID* pContext )
{
    // Set aside static storage space for 20 audio drivers
    static GUID  AudioDriverGUIDs[20];
    static DWORD dwAudioDriverIndex = 0;

    GUID* pTemp  = NULL;

    if( pGUID )
    {
        if( dwAudioDriverIndex >= 20 )
            return TRUE;

        pTemp = &AudioDriverGUIDs[dwAudioDriverIndex++];
        memcpy( pTemp, pGUID, sizeof(GUID) );
    }
		HWND hSoundDeviceCombo = (HWND)pContext;    

		// Add the string to the combo box
    ::SendMessage( hSoundDeviceCombo, CB_ADDSTRING, 0, (LPARAM) (LPCTSTR) strDesc );

	  // Get the index of the string in the combo box
    INT nIndex = (INT)::SendMessage( hSoundDeviceCombo, CB_FINDSTRING, 0, (LPARAM) (LPCTSTR) strDesc );

    // Set the item data to a pointer to the static guid stored in AudioDriverGUIDs
    ::SendMessage( hSoundDeviceCombo, CB_SETITEMDATA, nIndex, (LPARAM) pTemp );

    return TRUE;
}


void CSoundkarteDlg::OnOK() 
{
	UpdateData(TRUE);
	pSoundGUID=(GUID*)m_Soundkarte_Ausgang.GetItemData(m_Soundkarte_Ausgang_int);
	pCaptureGUID=(GUID*)m_Soundkarte_Eingang.GetItemData(m_Soundkarte_Eingang_int);
	m_Soundkarte_Ausgang.GetLBText(m_Soundkarte_Ausgang_int,strSoundAusgang);
	m_Soundkarte_Eingang.GetLBText(m_Soundkarte_Eingang_int,strSoundEingang);
	CDialog::OnOK();
}
