// SoundsDoc.cpp : Implementierung der Klasse CSoundsDoc
//

#include "stdafx.h"
#include <dsound.h>
#include "Sounds.h"
#include "InfoView.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "SplitterFrame.h"
#include "SoundsOverView.h"
#include "SoundsDoc.h"
#include "WaveformatDlg.h"
#include "FFTEinstellungeDlg.h"
#include "FFTFrame.h"
#include "RekoView.h"
#include "D3DRekoFrame.h"
#include "ZeitreiheFrame.h"
#include "SoundsDoc.h"
#include "SoundsView.h"
#include "FFTView.h"
#include "FFT3DView.h"
#include "AnalyseView.h"
#include "NotenbildView.h"
#include "WaveletView.h"
#include "SonoView.h"
#include "ZeitreiheView1.h"
#include "SoundkarteDlg.h"
#include "SampleRateDlg.h"
#include "FFTReal.h"
#include "CaptureThread.h"
#include "UpdateFkt.h"
#include "FensterInit.h"
#include "fft.h"
#include "ReadZeitreihe.h"
#include "ConvertWave.h"
#include "StereoDlg.h"
#include "Wavelet.h"
#include "filtercoeffs.h"
#include "Mp3Converter.h"
#include "ProgressDLG.h"

//#include "Generator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CSoundsDoc


IMPLEMENT_DYNCREATE(CSoundsDoc, CDocument)

BEGIN_MESSAGE_MAP(CSoundsDoc, CDocument)
	ON_COMMAND(ID_FENSTER_ANALYSE, OnFensterAnalyse)
	ON_COMMAND(ID_FENSTER_FFT3D, OnFensterFFT3D)
	ON_COMMAND(ID_FENSTER_FFT, OnFensterFFT)
	ON_COMMAND(ID_FENSTER_NOTENBILD, OnFensterNotenbild)
	ON_COMMAND(ID_FENSTER_REKO, OnFensterReko)
	ON_COMMAND(ID_FENSTER_SONO, OnFensterSono)
	ON_COMMAND(ID_FENSTER_MAIN, OnFensterMain)
	ON_COMMAND(ID_FENSTER_WAVELET, OnFensterWavelet)
	ON_COMMAND(ID_FENSTER_ZEITREIHE, OnFensterZeitreihe)
	//{{AFX_MSG_MAP(CSoundsDoc)
	ON_COMMAND(ID_EINSTELLUNGEN_WAVEFORMAT, OnEinstellungenWaveformat)
	ON_COMMAND(ID_DATEN_ZEITREIHEEINLESEN, OnDatenZeitreiheeinlesen)
	ON_COMMAND(ID_DATEN_AUDIOEINGANG, OnDatenAudioeingang)
	ON_UPDATE_COMMAND_UI(ID_DATEN_AUDIOEINGANG, OnUpdateDatenAudioeingang)
	ON_UPDATE_COMMAND_UI(ID_RECORD_START, OnUpdateRecordStart)
	ON_UPDATE_COMMAND_UI(ID_RECORD_STOP, OnUpdateRecordStop)
	ON_COMMAND(ID_RECORD_START, OnRecordStart)
	ON_COMMAND(ID_RECORD_STOP, OnRecordStop)
	ON_COMMAND(ID_DATEN_WAVEFILEEINLESEN, OnDatenWavefileeinlesen)
	ON_COMMAND(ID_PLAYWAVE, OnPlaywave)
	ON_UPDATE_COMMAND_UI(ID_PLAYWAVE, OnUpdatePlaywave)
	ON_COMMAND(ID_STOPWAVE, OnStopwave)
	ON_UPDATE_COMMAND_UI(ID_STOPWAVE, OnUpdateStopwave)
	ON_COMMAND(ID_RESETWAVE, OnResetwave)
	ON_COMMAND(ID_PLAYLOOP, OnPlayloop)
	ON_UPDATE_COMMAND_UI(ID_PLAYLOOP, OnUpdatePlayloop)
	ON_UPDATE_COMMAND_UI(ID_RESETWAVE, OnUpdateResetwave)
	ON_COMMAND(ID_EINSTELLUNGEN_FFT, OnEinstellungenFft)
	ON_COMMAND(ID_ANSICHT_3DREKONSTRUKTION, OnAnsicht3drekonstruktion)
	ON_COMMAND(ID_ANSICHT_FFT, OnAnsichtFFT)
	ON_COMMAND(ID_ANSICHT_ZEITREIHE, OnAnsichtZeitreihe)
	ON_COMMAND(ID_ANSICHT_INFO, OnAnsichtInfo)
	ON_UPDATE_COMMAND_UI(ID_ANSICHT_INFO, OnUpdateAnsichtInfo)
	ON_UPDATE_COMMAND_UI(ID_ANSICHT_3DREKONSTRUKTION, OnUpdateAnsichtD3DReko)
	ON_UPDATE_COMMAND_UI(ID_ANSICHT_FFT, OnUpdateAnsichtFFT)
	ON_UPDATE_COMMAND_UI(ID_ANSICHT_ZEITREIHE, OnUpdateAnsichtZeitreihe)
	ON_COMMAND(ID_AUDIOEINGANG, OnAudioeingang)
	ON_UPDATE_COMMAND_UI(ID_AUDIOEINGANG, OnUpdateAudioeingang)
	ON_COMMAND(ID_ANSICHT_SONO, OnAnsichtSono)
	ON_COMMAND(ID_ANSICHT_3DFFT, OnAnsicht3dfft)
	ON_UPDATE_COMMAND_UI(ID_ANSICHT_3DFFT, OnUpdateAnsicht3dfft)
	ON_UPDATE_COMMAND_UI(ID_ANSICHT_SONO, OnUpdateAnsichtSono)
	ON_COMMAND(ID_READ_WAVE, OnReadWave)
	ON_COMMAND(ID_FILE_MRU_FILE1, OnFileMruFile1)
	ON_COMMAND(ID_ANSICHT_ANALYSE, OnAnsichtAnalyse)
	ON_UPDATE_COMMAND_UI(ID_ANSICHT_ANALYSE, OnUpdateAnsichtAnalyse)
	ON_COMMAND(ID_ANSICHT_NOTENBILD, OnAnsichtNotenbild)
	ON_UPDATE_COMMAND_UI(ID_ANSICHT_NOTENBILD, OnUpdateAnsichtNotenbild)
	ON_COMMAND(ID_HELP_FINDER, OnHelpFinder)
	ON_COMMAND(ID_HELP_INDEX, OnHelpIndex)
	ON_UPDATE_COMMAND_UI(ID_ANSICHT_WAVELET, OnUpdateAnsichtWavelet)
	ON_COMMAND(ID_ANSICHT_WAVELET, OnAnsichtWavelet)
	ON_COMMAND(ID_VIEW_STATUS_BAR, OnViewStatusBar)
	ON_COMMAND(ID_VIEW_TOOLBARNORMAL, OnViewToolbarnormal)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBARNORMAL, OnUpdateViewToolbarnormal)
	ON_COMMAND(ID_VIEW_TOOLBARSCHULE, OnViewToolbarschule)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBARSCHULE, OnUpdateViewToolbarschule)
	ON_COMMAND(ID_REWIND, OnRewind)
	ON_UPDATE_COMMAND_UI(ID_REWIND, OnUpdateRewind)
	ON_COMMAND(ID_SAVE_WAVE, OnSaveWave)
	ON_UPDATE_COMMAND_UI(ID_SAVE_WAVE, OnUpdateSaveWave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSoundsDoc Konstruktion/Destruktion

CSoundsDoc::CSoundsDoc()
{
 theApp.mp_doc=this;
//	_CrtSetBreakAlloc(1532 );
// Deklarieren der erforderlichen Variablen

	// Set the path to the help file.
	CString File="SoundsHelp.chm";
	CString Path=theApp.GetModulPath();

	m_strHelpFile = Path+File;
}

void CSoundsDoc::IniFileWrite()
{
	//Inifile Werte schreiben
	*theApp.GetIniDokumentFFTPoints()=m_NumFFTPoints;
	*theApp.GetIniDokumentPlayFile()=m_strPlayFile;
}

void CSoundsDoc::IniFileRead()
{
	//Inifile Werte einlesen
	m_NumFFTPoints								= *theApp.GetIniDokumentFFTPoints();
	m_strPlayFile									= *theApp.GetIniDokumentPlayFile();
}

CSoundsDoc::~CSoundsDoc()
{
	IniFileWrite();
	if (g_bIsWaveLoaded) 
		OnResetwave();

	if (g_bIsCapturing) 
		OnDatenAudioeingang();


	CloseHandle(m_hEventCaptureStart);
	CloseHandle(m_hEventCaptureDone);
	CloseHandle(m_hEventKillCaptureThread);
	CloseHandle(m_hEventCaptureThreadKilled);

	CloseHandle(m_hEventNotifyDone);
	CloseHandle(m_hEventKillPlayThread);
	CloseHandle(m_hEventPlayThreadKilled);

	free (m_pwfxInput);
	free (m_pWaveletCoeffs);
	free (m_pWaveletTransformObjekt);

//	free (m_pWaveletTrafo);
	delete m_pWaveletTrafo;
	DeleteContents();
}

BOOL CSoundsDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	InitDocument(); 

	return TRUE;
}

void CSoundsDoc::InitDocument()
{
	m_dwBufferRegionStart=0;
	m_dwBufferRegionEnd=0;

	m_bIsNot3D=FALSE;
	//Farbpalette erstellen
	if (!CreatePalette(&m_Pal)) 
		AfxMessageBox(E_SOUNDSDOC_CREATEPALETTE);

	//Variablen einrichten;

//	m_dwCaptureBufferSize = 0;
//	m_dwNotifySize        = 0;
	m_SoundBufferSize				=	0;

// 	m_pCaptureWaveFile					=	NULL;
	m_pStreamingSound			= NULL;
	m_pSound							= NULL;


	m_WAVKomplettArray.RemoveAll();
	m_PGMKomplettArray.RemoveAll();
	m_ZeitreiheArray.RemoveAll();
	m_FrequenzenArray.RemoveAll();
	m_WaveletPacketArray.RemoveAll();
	m_ZeitreiheArray.Add(0);
	m_FrequenzenArray.Add(0);
	m_WAVKomplettArray.Add(0);
	m_PGMKomplettArray.Add(0);
	m_WaveletPacketArray.Add(0);

	m_AutoKorrArray.Add(&m_AutoKorrArray0);
	m_AutoKorrArray.Add(&m_AutoKorrArray1);
	m_AutoKorrArray.Add(&m_AutoKorrArray2);
	m_AutoKorrArray.Add(&m_AutoKorrArray3);
	m_AutoKorrArray.Add(&m_AutoKorrArray4);
	m_AutoKorrArray.Add(&m_AutoKorrArray5);
	m_AutoKorrArray.Add(&m_AutoKorrArray6);
	m_AutoKorrArray.Add(&m_AutoKorrArray7);
	m_AutoKorrArray.Add(&m_AutoKorrArray8);
	m_AutoKorrArray.Add(&m_AutoKorrArray9);
	m_AutoKorrArray.Add(&m_AutoKorrArray10);

	m_MaxAmplitude								=	0;

	IniFileRead();	
	m_BitRate											=	16;
	m_counter											=	0;
	m_wfxWave.cbSize							= 0;
	m_wfxWave.nAvgBytesPerSec			= 0;
	m_wfxWave.nBlockAlign					= 0;
	m_wfxWave.nChannels						= 5;
	m_wfxWave.nSamplesPerSec			= 0;
	m_wfxWave.wBitsPerSample			= 0;
	m_wfxWave.wFormatTag					= WAVE_FORMAT_PCM;
	m_pwfxInput = new WAVEFORMATEX;
	m_pwfxInput->cbSize							= 0;
	m_pwfxInput->nAvgBytesPerSec			= 0;
	m_pwfxInput->nBlockAlign					= 0;
	m_pwfxInput->nChannels						= 6;
	m_pwfxInput->nSamplesPerSec			= 0;
	m_pwfxInput->wBitsPerSample			= 0;
	m_pwfxInput->wFormatTag					= WAVE_FORMAT_PCM;
//	m_dwNumPlayNotifications			= 0;

	m_hEventCaptureStart = CreateEvent(NULL, TRUE, FALSE, NULL); // manual reset, initially reset
	m_hEventCaptureDone = CreateEvent(NULL, TRUE, FALSE, NULL); // manual reset, initially reset
	m_hEventKillCaptureThread = CreateEvent(NULL, TRUE, FALSE, NULL); // manual reset, initially reset
	m_hEventCaptureThreadKilled = CreateEvent(NULL, TRUE, FALSE, NULL); // manual reset, initially reset
	m_hEventCaptureBufferNotify  = CreateEvent( NULL, FALSE, FALSE, NULL ); // auto reset, initially reset
	m_hEventIsLooped = CreateEvent(NULL, TRUE, FALSE, NULL); // manual reset, initially reset
	m_hEventNotifyDone = CreateEvent(NULL, TRUE, TRUE, NULL); // manual reset, initially set
	m_hEventPlayBufferNotify  = CreateEvent( NULL, FALSE, FALSE, NULL ); // auto reset, initially reset
	m_hEventKillPlayThread = CreateEvent(NULL, FALSE, FALSE, NULL); // auto reset, initially reset
	m_hEventPlayThreadKilled = CreateEvent(NULL, FALSE, FALSE, NULL); // auto reset, initially reset
	
	m_pViewInfo=NULL;
	m_pViewZeitreihe=NULL;
	m_pViewD3DReko=NULL;
	m_pViewFFT=NULL;
	m_pViewSono=NULL;
	m_pViewFFT3D=NULL;
	m_pViewAnalyse=NULL;
	m_pViewNotenbild=NULL;
	m_pViewWavelet=NULL;

	m_intBits = 0;
	m_strChannels = _T("");
	m_strFormat = _T("");
	m_intSamples = 0;
	m_strRecordFile.LoadString(IDS_NO_FILE_CHOOSEN);
	
	m_pTempWaveConverted=NULL;
	m_BitRateConverted=0;
	m_SampleRateConverted=0;
	m_NumBigFFTPoints=0;
	UpdateStatusBar();
	m_bStereo			= FALSE;
	m_bReadLinkerKanal = 1;

	m_FirstNullstelleAutokorr=0;	

	//Initialisierung der Wavelet Objekte
	m_pWaveletCoeffs= new WaveletCoeffs;
	m_pWaveletTransformObjekt = new WaveletTransform;
	m_pWaveletTransformObjekt->setAlgorithm(4); //0: zero padding generic, 1: zero padding optimized, 4: numerical recipes
	m_pWaveletTransformObjekt->setWavelet(30); //13: Biorthogonal 3/9,   0:Haar 30:Spline

  initWaveletFilterCoeffs();

	//Init CWT Wavelettrafo
	m_pWaveletTrafo=new CWaveletTrafo;

	m_pSoundBuffer=NULL;
//	AfxBeginThread(RUNTIME_CLASS(CBreakerThread));
}

void CSoundsDoc::UpdateStatusBar() 
{
	if (*theApp.GetIniAllgemeinStatusbar()) 
	{
		::SendMessage(AfxGetMainWnd()->GetSafeHwnd(),WM_USER_SETFFTBAR,m_NumFFTPoints,0);
		::SendMessage(AfxGetMainWnd()->GetSafeHwnd(),WM_USER_SETWAVEFILEBAR,0,0);
		::SendMessage(AfxGetMainWnd()->GetSafeHwnd(),WM_USER_SETWAVEBITBAR,m_intBits,0);
		::SendMessage(AfxGetMainWnd()->GetSafeHwnd(),WM_USER_SETWAVEKHZBAR,m_intSamples,0);
		::SendMessage(AfxGetMainWnd()->GetSafeHwnd(),WM_USER_SETCAPTUREBAR,0,0);
	 	::SendMessage(AfxGetMainWnd()->GetSafeHwnd(),WM_USER_SETRECORDBAR,0,0);
	}
}

void CSoundsDoc::DeleteContents() 
{
	m_PGMKomplettArray.RemoveAll();
	m_PGMKomplettArray.Add(0);
	m_WAVKomplettArray.RemoveAll();
	m_WAVKomplettArray.Add(0);
  m_ZeitreiheArray.RemoveAll();
	m_ZeitreiheArray.Add(0);
  m_FrequenzenArray.RemoveAll();
	m_FrequenzenArray.Add(0);
/*	m_AutoKorrArray.RemoveAll();
	m_AutoKorrArray.Add(0);
	m_AutoAutoKorrArray.RemoveAll();
	m_AutoAutoKorrArray.Add(0);
	m_AutoAutoAutoKorrArray.RemoveAll();
	m_AutoAutoAutoKorrArray.Add(0);
*/
	CDocument::DeleteContents();
}

void CSoundsDoc::CreateCaptureThread()
{
	m_CaptureThreadInfo.m_hEventCaptureBufferNotify = m_hEventCaptureBufferNotify;
	m_CaptureThreadInfo.m_hEventCaptureStart = m_hEventCaptureStart;
	m_CaptureThreadInfo.m_hEventCaptureDone = m_hEventCaptureDone;
	m_CaptureThreadInfo.m_hEventKillCaptureThread = m_hEventKillCaptureThread;
	m_CaptureThreadInfo.m_hEventCaptureThreadKilled = m_hEventCaptureThreadKilled;
	m_CaptureThreadInfo.m_hwndNotifyCaptureDone=AfxGetMainWnd()->GetSafeHwnd();
	m_CaptureThreadInfo.m_hwndNotifyCaptureInProgress=AfxGetMainWnd()->GetSafeHwnd();
// 	m_CaptureThreadInfo.m_pCaptureWaveFile=m_pCaptureWaveFile;
	m_CaptureThreadInfo.m_strRecordFile=m_strRecordFile;
	m_CaptureThreadInfo.m_pwfxInput=m_pwfxInput;
	m_CaptureThreadInfo.m_NumFFTPoints=m_NumFFTPoints;

	m_pCaptureWorkerThread =	AfxBeginThread(CaptureThreadProc, &m_CaptureThreadInfo);

}

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Dialog FFT einstellen aufgerufen																						 !
//                                                                             !
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
void CSoundsDoc::OnEinstellungenFft() 
{
	if (g_bIsCapturing) 
		OnDatenAudioeingang();

	BOOL Stopped=FALSE;
	if (g_bIsPlayingWave) 
	{
		Stopped=TRUE;
		m_pSound->Stop();
		g_bIsPlayingWave=FALSE;
	}
	
	CFFTEinstellungeDlg FFTDlg;
	if (FFTDlg.DoModal()==IDOK) 
	{
		INT oldFFTPoints=m_NumFFTPoints;
		switch(FFTDlg.m_FFTPointsInt) 
		{
		case 0:
			m_NumFFTPoints=256;
			break;
		case 1:
			m_NumFFTPoints=512;
			break;
		case 2:
			m_NumFFTPoints=1024;
			break;
		case 3:
			m_NumFFTPoints=2048;
			break;
		case 4:
			m_NumFFTPoints=4096;
			break;
		case 5:
			m_NumFFTPoints=8192;
			break;
		case 6:
			m_NumFFTPoints=16384;
			break;
		case 7:
			m_NumFFTPoints=32768;
			break;
		case 8:
			m_NumFFTPoints=65536;
			break;
		case 9:
			m_NumFFTPoints=131072;
			break;
		case 10:
			m_NumFFTPoints=262144;
			break;
		case 11:
			m_NumFFTPoints=524288;
			break;
		default:
			m_NumFFTPoints=*theApp.GetIniDokumentFFTPoints();
		}
		if (m_pViewNotenbild!=NULL&&*theApp.GetIniAllgemeinGrundschulprofil()) m_NumFFTPoints=32768;

		::SendMessage(AfxGetMainWnd()->GetSafeHwnd(),WM_USER_SETFFTBAR,m_NumFFTPoints,0);

	}
	DeleteContents();
	if (Stopped) 
	{
		m_pSound->Play();
		g_bIsPlayingWave=TRUE;
	}
	UpdateStatusBar();
	UpdateAllViews(NULL,50);
}

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Dialog Waveformat einstellen aufgerufen                                     !
//                                                                             !
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
HRESULT CSoundsDoc::OnEinstellungenWaveformat() 
{
	if (g_bIsCapturing) 
		OnDatenAudioeingang();

	CWaveformatDlg WaveDlg;
	if (WaveDlg.DoModal() == IDOK)
	{
    INT dwInputWavIndex=WaveDlg.InputWavIndex;
    ZeroMemory( m_pwfxInput, sizeof(m_pwfxInput));
    m_pwfxInput->wFormatTag = WAVE_FORMAT_PCM;

    GetWaveFormatFromIndex( dwInputWavIndex, m_pwfxInput );
	
//		WriteWaveParametersInVariables(m_pwfxInput);

//		UpdateAllViews(NULL,50);
//		UpdateStatusBar();

		return S_OK;
	} //WaveDlg DoModal if
	else //User drckt im WaveDialog IDCANCEL
		return S_FALSE;
}

//-----------------------------------------------------------------------------
// Desc: Returns 20 different wave formats based on nIndex
//-----------------------------------------------------------------------------
VOID CSoundsDoc::GetWaveFormatFromIndex( INT nIndex, WAVEFORMATEX* pwfx )
{
    INT iSampleRate = nIndex / 2;
    INT iType = nIndex % 2;

    switch( iSampleRate )
    {
        case 0: pwfx->nSamplesPerSec =  8000; break;
        case 1: pwfx->nSamplesPerSec = 11025; break;
        case 2: pwfx->nSamplesPerSec = 22050; break;
        case 3: pwfx->nSamplesPerSec = 32000; break;
        case 4: pwfx->nSamplesPerSec = 44100; break;
        case 5: pwfx->nSamplesPerSec = 48000; break;
        case 6: pwfx->nSamplesPerSec = 64000; break;
        case 7: pwfx->nSamplesPerSec = 88200; break;
        case 8: pwfx->nSamplesPerSec = 96000; break;
        case 9: pwfx->nSamplesPerSec = 192000; break;
    }

    switch( iType )
    {
        case 0: pwfx->wBitsPerSample =  8; pwfx->nChannels = 1; break;
        case 1: pwfx->wBitsPerSample = 16; pwfx->nChannels = 1; break;
    }

    pwfx->nBlockAlign = pwfx->nChannels * ( pwfx->wBitsPerSample / 8 );
    pwfx->nAvgBytesPerSec = pwfx->nBlockAlign * pwfx->nSamplesPerSec;
}


/////////////////////////////////////////////////////////////////////////////
// CSoundsDoc Serialisierung

void CSoundsDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// ZU ERLEDIGEN: Hier Code zum Speichern einfgen
	}
	else
	{
		// ZU ERLEDIGEN: Hier Code zum Laden einfgen
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSoundsDoc Diagnose

#ifdef _DEBUG
void CSoundsDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSoundsDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Menpunkt Audioeingang abhren aufgerufen                                   !
//                                                                             !
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
HRESULT CSoundsDoc::OnDatenAudioeingang() 
{
	if (g_bIsWaveLoaded) 
	{
		OnResetwave();
	}
	if (!g_bIsCapturing) // Wenn noch nicht im Capturezustand,  dann starten
	{
		m_NumBigFFTPoints=0;
		// Wenn noch kein EingangsWaveformat definiert wurde
		if (*theApp.GetIniAllgemeinGrundschulprofil()) 
		{
	    ZeroMemory( m_pwfxInput, sizeof(m_pwfxInput));
			m_pwfxInput->wFormatTag = WAVE_FORMAT_PCM;

	    GetWaveFormatFromIndex( 9, m_pwfxInput );
	
			//Waveparameter in Variablen schreiben
			m_Signed=TRUE;
			m_BitRate=16;
			m_MaxAmplitude=32767;
			//InfoFensterParameter schreiben
			m_strChannels=_T("Mono");
			m_strFormat=_T("PCM");
			m_intSamples=m_pwfxInput->nSamplesPerSec;
			m_intBits=m_pwfxInput->wBitsPerSample;
			UpdateAllViews(NULL,50);
			m_WAVKomplettArray.RemoveAll();
			UpdateStatusBar();
		}
		OnRecordStart();
		
		if (m_pwfxInput->nChannels>5)
			if (OnEinstellungenWaveformat()==S_FALSE)
				return S_FALSE;
		WriteWaveParametersInVariables(m_pwfxInput);
		g_bIsCapturing=TRUE;	

		//WorkerThread fr Notifybearbeitung starten
		ResetEvent(m_hEventKillCaptureThread);
		ResetEvent(m_hEventCaptureThreadKilled);
		CreateCaptureThread();
		if (m_pViewFFT!=NULL) 
		{
//			m_pViewFFT->m_wndDlgBar.SetDlgItemInt(IDC_TOPCUT_FELD,(INT)(m_intSamples/2/1000),FALSE);
			CSpinButtonCtrl* m_pTopCutCtrl=(CSpinButtonCtrl*)m_pViewFFT->m_wndDlgBar.GetDlgItem(IDC_TOPCUTAMP_SPIN);
			m_pTopCutCtrl->SetPos(-m_BitRate*6);
		}
//		if (m_pViewFFT3D!=NULL) 
//			m_pViewFFT3D->m_wndDlgBar.SetDlgItemInt(IDC_TOPCUT_FELD,(INT)(m_intSamples/2/1000),FALSE);
//		if (m_pViewSono!=NULL) 
//			m_pViewSono->m_wndDlgBar.SetDlgItemInt(IDC_TOPCUT_FELD,(INT)(m_intSamples/2/1000),FALSE);

		UpdateStatusBar();
		UpdateAllViews(NULL,50);


		//Start des Capturings
//		SetEvent(m_hEventCaptureStart);
	}
	else //Wenn im Capturezustand, dann beenden
	{
//		if (g_bIsRecording) //evtl. Aufzeichnung in Wavefile beenden
			OnRecordStop();

		g_bIsCapturing=FALSE;	

		//WorkerThread fr Notifybearbeitung beenden
		SetEvent(m_hEventCaptureBufferNotify);
		SetEvent(m_hEventKillCaptureThread);
		WaitForSingleObject(m_hEventCaptureThreadKilled, INFINITE);

//		if (*theApp.GetIsGrundschulprofil()) 
		{
			CString WaveName;
			WaveName = theApp.GetModulPath()+"Aufnahme.wav";
			WaveFileEinlesen(WaveName);
		}

		UpdateStatusBar();
		m_counter=0;
		UpdateAllViews(NULL,50);
	}
	return S_OK;
}

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Name: OnRecordStart()                                                       !
// Desc: Symbolleiste Aufnahmebutton wurde gedrckt                            !
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

void CSoundsDoc::OnRecordStart() 
{
	if (m_pViewFFT3D!=NULL) 
	{
		CFFT3DView* pView=(CFFT3DView*)m_pViewFFT3D->GetActiveView();
		pView->m_bNetzNeu=TRUE;
		pView->m_counter=0;
	}

	g_bIsRecording=TRUE;
	g_bIsPutPoints=FALSE;
	UpdateStatusBar();
}

void CSoundsDoc::OnRecordStop() 
{
		g_bIsRecording=FALSE;
		Sleep(100);
		UpdateStatusBar();
//		SAFE_DELETE(m_CaptureThreadInfo.m_pCaptureWaveFile);
//		m_CaptureThreadInfo.m_pCaptureWaveFile=NULL;
}



//-----------------------------------------------------------------------------
// 
// Desc: Menpunkt WaveFile Einlesen ausgewhlt
//       
//-----------------------------------------------------------------------------
void CSoundsDoc::OnDatenWavefileeinlesen() 
{

	//Wiedergabe stoppen, wenn noch am laufen und alle Objekte und Thread dess letzten Files killen
	DeleteContents();
	if (g_bIsWaveLoaded) 
	{
		if( g_bIsPlayingWave)
		{
			m_pSound->Stop();
			m_pSound->Reset();
			g_bIsPlayingWave=FALSE;
		}
		OnResetwave();
	}
	// Lade WavefileDialog
	CFileDialog WaveFileDlg(TRUE,NULL,NULL,OFN_OVERWRITEPROMPT|OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_ENABLESIZING,\
              "WAV - Standardwavefiles|*.wav|MP3 - MPEG Layer 3 Files|*.mp3|");
  WaveFileDlg.m_ofn.nFilterIndex=1;
	CString Text;
	Text.LoadString(IDS_FILE_READ_WAVE);
	WaveFileDlg.m_ofn.lpstrTitle=Text.GetBuffer(Text.GetLength());
  if (WaveFileDlg.DoModal()==IDOK) 
	{
		BeginWaitCursor();
		m_strPlayFile=WaveFileDlg.GetPathName();
		CProgressDLG Dlg;
		Dlg.Create(IDD_DIALOG_PROGRESS);
		CRect rect;
		AfxGetMainWnd()->GetClientRect(rect);
		rect.left=rect.right/2-200;
		rect.right=rect.right/2;
		rect.top=rect.bottom/2-50;
		rect.bottom=rect.bottom/2+50;
		Dlg.MoveWindow(rect);
		if (!*theApp.GetIniAllgemeinGrundschulprofil()) Dlg.ShowWindow(SW_SHOW);
		HWND MessagehWnd=Dlg.m_hWnd;
		BOOL Success=TRUE;
		m_strPlayFile.MakeLower();
		if (m_strPlayFile.Find(".mp3")!=-1||m_strPlayFile.Find(".wav")!=-1) Success=TRUE;
		if (m_strPlayFile.Find(".mp3")!=-1) 
		{
			CString ConvertedFileName=theApp.GetModulPath()+"converted.wav";
			Success=ConvertMP3toWAV(m_strPlayFile,ConvertedFileName,MessagehWnd);
			m_strPlayFile=ConvertedFileName;
		}
		m_strProgress.LoadString(IDS_WAITFORFULLLOAD);
	 	::SendMessage(MessagehWnd,WM_USER_SETPROGRESS,0,0);
		if (Success) WaveFileEinlesen(m_strPlayFile);
		else AfxMessageBox(E_READWAVEFILE);
		CString AppTitle=WaveFileDlg.GetFileName();
		SetTitle(AppTitle);
		Dlg.DestroyWindow();
		EndWaitCursor();
	}
}

//-----------------------------------------------------------------------------
// Name: WaveFileEinlesen()
// Desc: Gegebenes Wavefile ffnen und in den Speicher kopieren
//       DirectSoundObjekte erstellen
//       
//-----------------------------------------------------------------------------
void CSoundsDoc::WaveFileEinlesen( CString strPlayFile )
{
    LPTSTR strFileName = strPlayFile.GetBuffer(MAX_PATH);

		BeginWaitCursor();

		if (CreateAbbild(strFileName)==S_OK) 
		{
			if (LoadWaveAndCreateBuffer(strFileName)==S_OK) 
			{
				g_bIsWaveLoaded=TRUE;
				if (m_pViewFFT!=NULL) 
				{
					CSpinButtonCtrl* m_pTopCutCtrl=(CSpinButtonCtrl*)m_pViewFFT->m_wndDlgBar.GetDlgItem(IDC_TOPCUTAMP_SPIN);
					m_pTopCutCtrl->SetPos(-m_BitRate*6);
				}
				m_strPlayFile	= strPlayFile;
			}
			else
			{
				m_strPlayFile.LoadString(IDS_NO_FILE_CHOOSEN);
				free(m_pSoundBuffer);
				m_SoundBufferSize=0;
				m_WAVKomplettArray.Add(0);
			}
		}
		else
			m_strPlayFile.LoadString(IDS_NO_FILE_CHOOSEN);
	UpdateStatusBar();
	UpdateAllViews(NULL,50);

	//Alten Cursor zurcksetzen
	EndWaitCursor();
}
//-----------------------------------------------------------------------------
// Name: LoadWaveAndCreateBuffer()
// Desc: Loads the wave file, and create a DirectSound buffer.  Since we are
//       streaming data into the buffer, the buffer will be filled with data 
//       when the sound is played, and as notification events are signaled
//-----------------------------------------------------------------------------
HRESULT CSoundsDoc::LoadWaveAndCreateBuffer( TCHAR* strFileName )
{
    HRESULT   hr;
    CWaveFile waveFile;
    DWORD     dwNotifySize;

    // Load the wave file
    if( FAILED( hr = waveFile.Open( strFileName, NULL, WAVEFILE_READ ) ) )
    {
				m_SoundBufferSize=0;
        DXTRACE_ERR( TEXT("Open"), hr );
        waveFile.Close();
        return S_FALSE;
    }
		waveFile.ResetFile();
    if( waveFile.GetSize() == 0 )
    {
				m_SoundBufferSize=0;
        waveFile.Close();
        AfxMessageBox(E_LOADWAVEFILE_NULLBYTE);
        return S_FALSE;
    }

		WriteWaveParametersInVariables(waveFile.m_pwfx);

		CStereoDlg StereoDlg;
		if (m_bStereo==TRUE) 
		{
			if (!*theApp.GetIniAllgemeinGrundschulprofil()) 
			{
				if (StereoDlg.DoModal()==IDOK) 
				{
					m_bReadLinkerKanal=StereoDlg.m_bIsLinkerKanal;
					UpdateAllViews(NULL);
				}
				else
					return S_FALSE;
			}
			else //if Grundschulprofil
			{
				m_bReadLinkerKanal=TRUE;
			}
		}
    // The wave file is valid, and waveFile.m_pwfx is the wave's format
    // so we are done with the reader.
    waveFile.Close();

    // Wenn das Format komplexer als 16 Bit 48 kHz ist (was jede Karte abspielen kann),
		// dann erstelle temporres Wavefile das auf diese Parameter konvertiert ist, damit
		// die Soundplayengine von DirectSound keine Probleme bekommt.
		// Fr die Analyse wird weiterhin die Orginaldatei verwendet.
		if (m_bStereo) 
		{
			ConvertAsIsToMono();
		  // Load the wave file
			//InfoFensterParameter schreiben
			m_strChannels=_T("Mono");
		}

		if ((m_BitRate>16)||(m_intSamples>48000)) 
		{
			if (CreateConvertedTempWaveForSoundPlay(strFileName)==S_OK) 
			{
//				m_AktualPlaySoundBuffer=m_pSoundBufferConverted;
				return S_OK;
			}
			else
				return S_FALSE;
		}
		else
		{
			DWORD FileSize;
	    DWORD nBlockAlign;
	    INT nSamplesPerSec = waveFile.m_pwfx->nSamplesPerSec;
			if (m_bStereo) 
			{
				FileSize=waveFile.GetSize()/2;
		    nBlockAlign = (DWORD)(waveFile.m_pwfx->nBlockAlign/2);
			}
			else
			{
				FileSize=waveFile.GetSize();
		    nBlockAlign = (DWORD)waveFile.m_pwfx->nBlockAlign;
			}

//			m_AktualPlaySoundBuffer=m_pSoundBuffer;

			//Konstante Bildrate durch regelmige Notifys herstellen
	    dwNotifySize = nSamplesPerSec/5; //m_NumFFTPoints*8;
			m_dwNumPlayNotifications = 16;//(FileSize/nBlockAlign)/dwNotifySize+1;
		  dwNotifySize -= dwNotifySize % nBlockAlign;   

	    // Create a new sound
//		  SAFE_DELETE( m_pStreamingSound );
		  SAFE_DELETE( m_pSound );
			CString FileNameStandard;
			LPTSTR FileName;
			if (m_bStereo) 
			{
				TCHAR TempFolder[MAX_PATH];
				GetTempPath(MAX_PATH,TempFolder);
				FileNameStandard=(CString)TempFolder+"~TempWaveMono.wav";
			  FileName = FileNameStandard.GetBuffer(MAX_PATH);
			}

	    // Load the wave file into a DirectSound buffer
			if( FAILED( hr = theApp.m_pSoundManager->Create( &m_pSound, m_bStereo?FileName:strFileName, 0, GUID_NULL ) ) )
			{
        // Not a critical failure, so just update the status
        DXTRACE_ERR_NOMSGBOX( TEXT("Create"), hr );
        return S_FALSE; 
			}
			m_bStereo=FALSE;
	    // Set up the direct sound buffer.  Request the NOTIFY flag, so
		  // that we are notified as the sound buffer plays.  Note, that using this flag
			// may limit the amount of hardware acceleration that can occur. 

//			if( FAILED( hr = theApp.m_pSoundManager->CreateStreaming( &m_pStreamingSound, strFileName, 
//		     DSBCAPS_CTRLPOSITIONNOTIFY|DSBCAPS_GETCURRENTPOSITION2, 
//			   GUID_NULL, m_dwNumPlayNotifications, dwNotifySize, m_hEventPlayBufferNotify ) ) )
//	    {
//	      if( hr != DSERR_BADFORMAT && hr != E_INVALIDARG )
//            DXTRACE_ERR( TEXT("CreateStreaming"), hr );
//        return S_FALSE;
//		  }
			return S_OK;
		}
}

void CSoundsDoc::WriteWaveParametersInVariables(WAVEFORMATEX* pwfx)
{
		//InfoFensterParameter schreiben
		CString* pFilename=GetWaveFilename();
		m_strPlayFile=*pFilename;
		switch(pwfx->nChannels) 
			{
		case 1:
			m_strChannels=_T("Mono");
			break;
		case 2:
			m_strChannels=_T("Stereo");
			break;
		default:
			m_strChannels=_T("?");
		}
		if (pwfx->wFormatTag==1) 
			m_strFormat=_T("PCM");
		else
			m_strFormat=_T("?");

		if (m_strChannels=="Stereo")
			m_bStereo=TRUE;
		else
			m_bStereo=FALSE;

		m_intSamples=pwfx->nSamplesPerSec;
		m_intBits=pwfx->wBitsPerSample;

		//Waveparameter in Variablen schreiben
		if (pwfx->wBitsPerSample==8) 
			m_Signed=FALSE;
		 else
			m_Signed=TRUE;

		switch(pwfx->wBitsPerSample) 
			{
			case 8:
				m_BitRate=8;
				m_MaxAmplitude=255;
				break;
			case 16:
				m_BitRate=16;
				m_MaxAmplitude=32767;
				break;
			case 24:
				m_BitRate=24;
				m_MaxAmplitude=8388607;
				break;
			case 32:
				m_BitRate=32;
				m_MaxAmplitude=2147483647;
				break;
			default:
				AfxMessageBox(E_WRITEPARAMETERS);
				break;
			}
}
////////////////////////////////////////////////////////////////////////////////////
//	HauptSoundarray der ganzen Wavedatei ersetllen                                                           //
////////////////////////////////////////////////////////////////////////////////////
HRESULT CSoundsDoc::CreateAbbild(TCHAR* strFileName) 
{
	HRESULT hr;
	CWaveFile* pWaveFile					 = NULL;
  DWORD   dwFileSize					 = 0;		 // Size of the locked DirectSound buffer
  DWORD   dwWavDataRead        = 0;    // Amount of data read from the wav file 

  pWaveFile = new CWaveFile();
  hr=pWaveFile->Open( strFileName, NULL, WAVEFILE_READ );
	if (FAILED(hr))
	{
		free(pWaveFile);
		return hr;
	}
	hr=pWaveFile->ResetFile();
	if (FAILED(hr))
	{
		free(pWaveFile);
		return hr;
	}

	m_BitRate=pWaveFile->m_pwfx->wBitsPerSample;
	dwFileSize=pWaveFile->GetSize();

	//StereoFilePuffer entfernen, da jetzt MonoSound zur Verfgung steht
	if (m_bStereo) 
		free(m_pSoundBuffer);

	m_pSoundBuffer=(BYTE*)malloc (sizeof(BYTE)*dwFileSize);
	
  if( FAILED( pWaveFile->Read( m_pSoundBuffer, dwFileSize, &dwWavDataRead ) ) )           
	{
		AfxMessageBox(E_CREATEABBILD_READ);
		pWaveFile->Close();
		delete pWaveFile;
		free(m_pSoundBuffer);

		return S_FALSE;
	}
	m_SoundBufferSize=dwFileSize;
 	m_AktualPlaySoundBufferSize=m_SoundBufferSize;
	//Zeitreihenarray fllen
	m_WAVKomplettArray.RemoveAll();
	DWORD i=0;


	pWaveFile->ResetFile();
	pWaveFile->Close();
	delete pWaveFile;
//	UpdateAllViews(NULL,50);

	return S_OK;
}

void CSoundsDoc::SetSelectedRegion(DWORD Start, DWORD End)
{
	if (Start!=-1) m_dwBufferRegionStart=Start;
	if (End!=-1) m_dwBufferRegionEnd=End;
}

VOID CSoundsDoc::PutNewWaveCutPointsInArrays(DWORD Start, DWORD End)
{
	if (!g_bIsPlayingWave) 
	{
		BeginWaitCursor();

		DeleteContents();
//	UpdateAllViews(NULL,18);

//	m_ZeitreiheArray.RemoveAll();
//	m_FrequenzenArray.RemoveAll();
	DWORD j=0;
	DWORD PwOf2=0;
	DWORD NumFFTPoints=0;
//	DWORD Ende=0;
	if (g_bIsWaveLoaded) 
	{
		Start=m_BitRate==8?Start:Start-Start%2;
		j=Start;
		PwOf2=(DWORD)(log10(End-Start)/log10(2));
		NumFFTPoints=(DWORD)pow(2,PwOf2);
//		m_FrequenzenArray.SetSize(NumFFTPoints+10);
//			Ende=Start+NumFFTPoints;
//		m_NumFFTPoints=NumFFTPoints;
//		while (j<End) 
//		{
//		FILE* pFile;
//		pFile=fopen("c:\\Dumps\\Musik.dat","w");

		m_ZeitreiheArray.SetSize(End-j);
//		m_ZeitreiheArray.SetSize(NumFFTPoints);
//		for(UINT register x=j;x<End;x=x++)
		
		//If not enough points for defined FFTSize, reduce Array to End-Start Elements
		//If there are more points then defined FFTSize use only FFTSize Number of Points
//		End=j+NumFFTPoints<End?j+NumFFTPoints:End;
		for(UINT register x=j;x<End;x=x++)	
//		for(UINT register x=j;x<j+NumFFTPoints;x=x++)	
		{
			DOUBLE Wert=m_BitRate==8?*((BYTE*)(m_pSoundBuffer)+x):*((short*)(m_pSoundBuffer)+x);
			m_ZeitreiheArray[x-j]=Wert;
//				fprintf (pFile,"%g \n", Wert);
			//			m_ZeitreiheArray.Add(Wert);
		}
//			fclose(pFile);
		g_bIsPutPoints=TRUE;

		if (m_pViewFFT!=NULL||m_pViewSono!=NULL||m_pViewNotenbild!=NULL||m_pViewZeitreihe!=NULL) 
		{
			DoFFT(NumFFTPoints);
		}
//			DoWavelet(NumFFTPoints);
//			DoWaveletPacket(NumFFTPoints);

		if (m_pViewWavelet!=NULL) 
		{
			//WaveletTrafo
			m_PGMKomplettArray.RemoveAll();
			m_pWaveletTrafo->m_arguments.b.min=0.0f;
			m_pWaveletTrafo->m_arguments.b.max=m_ZeitreiheArray.GetSize()/(float)m_intSamples;
			m_pWaveletTrafo->m_arguments.samplerate=m_intSamples;
			m_pWaveletTrafo->Start(m_ZeitreiheArray.GetData(),m_ZeitreiheArray.GetSize(),&m_PGMKomplettArray);
		}

		m_NumBigFFTPoints=NumFFTPoints;
		if (m_pViewAnalyse!=NULL)
		{
			m_pViewAnalyse->m_wndDlgBar.SetDlgItemInt(IDC_PUNKTE_MAX,m_ZeitreiheArray.GetSize());
			CSliderCtrl* SliderPts=(CSliderCtrl*)m_pViewAnalyse->m_wndDlgBar.GetDlgItem(IDC_PUNKTE_SLIDER);
			SliderPts->SetRange( 0, m_ZeitreiheArray.GetSize(), TRUE );
			SliderPts->SetPos(m_ZeitreiheArray.GetSize());
			m_pViewAnalyse->m_wndDlgBar.SetDlgItemInt(IDC_PUNKTE_FELD,m_ZeitreiheArray.GetSize(),FALSE);

			INT EvolvePts=m_ZeitreiheArray.GetSize();	
			m_pViewAnalyse->m_wndDlgBar.SetDlgItemInt(IDC_ITER_MAX,EvolvePts);
			CSliderCtrl* SliderEvolve=(CSliderCtrl*)m_pViewAnalyse->m_wndDlgBar.GetDlgItem(IDC_ITER_SLIDER);
			
			SliderEvolve->SetRange( 0, EvolvePts, TRUE );
			SliderEvolve->SetPos(EvolvePts);
			m_pViewAnalyse->m_wndDlgBar.SetDlgItemInt(IDC_ITER_FELD,EvolvePts,FALSE);


		}
	}
	
	//Alten Cursor zurcksetzen
	EndWaitCursor();
	
	UpdateAllViews(NULL,18);
//	g_bIsPutPoints=FALSE;
	}
}

////////////////////////////////////////////////////////////////////////////////////
//	MenMessage Handler                                                           //
////////////////////////////////////////////////////////////////////////////////////

void CSoundsDoc::OnPlaywave() 
{
	if (!g_bIsBusy) 
	{
	if ((m_PlayCursor>m_dwBufferRegionEnd&&m_dwBufferRegionEnd!=m_dwBufferRegionStart)
			||m_dwBufferRegionStart>m_PlayCursor) 
	{
		DWORD Offset=m_dwBufferRegionStart;
		Offset=m_BitRate==16?(Offset-Offset%2)*2:(Offset);
		m_pSound->GetBuffer(0)->SetCurrentPosition(Offset);
	}

	m_NumBigFFTPoints=0;
	DWORD dwFlags;
	if (g_bLooped) 
		dwFlags=DSBPLAY_LOOPING;
	else
		dwFlags=0;
	HRESULT hr=m_pSound->Play(0,dwFlags);
	if (FAILED(hr)) 
	{
		AfxMessageBox(E_ONPLAYWAVE);
	}

/*
	if (m_NumFFTPoints>4096) 
		m_NumFFTPoints=1024;
*/
	  POSITION pos = GetFirstViewPosition();
		CView* pView=NULL;
		while (pos != NULL)
		{
      pView = GetNextView(pos);
      CRuntimeClass* pRuntimeKlasse=pView->GetRuntimeClass();
			if (pRuntimeKlasse->m_lpszClassName=="CSoundsOverView")
			{
				CSplitterFrame* pFrame=(CSplitterFrame*)pView->GetParentFrame();
// 				BringWindowToTop(pFrame->GetSafeHwnd());
				pView->SetFocus();
				pFrame->SetActiveView((CView*)pFrame->m_wndSplitter.GetPane(1,0));
			}
		}   

	if (m_pViewFFT!=NULL) 
		m_pViewFFT->m_wndDlgBar.SetDlgItemInt(IDC_FFTPOINTS_FELD,m_NumFFTPoints,FALSE);

	
	if (m_pViewFFT3D!=NULL)
	{
		CFFT3DView* pView=(CFFT3DView*)m_pViewFFT3D->GetActiveView();
		pView->OnResetview();
	}

	g_bIsPlayingWave=TRUE;
	g_bIsPutPoints=FALSE;
	UpdateAllViews(NULL,23);
	}
}

void CSoundsDoc::OnStopwave() 
{
  if( m_pSound->IsSoundPlaying() )
  {
    // To pause, just stop the buffer, but don't reset the position
    if( m_pSound )
      m_pSound->Stop();
  }
	g_bIsPlayingWave=FALSE;
//	UpdateAllViews(NULL,11); 
	UpdateAllViews(NULL,50);

}

void CSoundsDoc::OnPlayloop() 
{
	if (!g_bIsPlayingWave) 
	{
		if (g_bLooped)
		{
			g_bLooped=FALSE;
//			ResetEvent(m_hEventIsLooped);
		}
		else
		{
			g_bLooped=TRUE;
//			SetEvent(m_hEventIsLooped);
		}
	}
}

#define RANDOOV 20
#define RANDLOV 10

void CSoundsDoc::OnRewind() 
{
	if (m_pSound) 
	{
		m_pSound->Reset();
		::SetCaretPos(RANDLOV,RANDOOV);
	}
}

void CSoundsDoc::OnResetwave() 
{
	UpdateAllViews(NULL,11);

	g_bIsBreak=FALSE;
	g_bLooped=FALSE;
	g_bIsWaveLoaded=FALSE;
	g_bIsPutPoints=FALSE;
	g_bIsConvertedPlay=FALSE;
	DeleteContents();

	m_NumBigFFTPoints=0;
	
	m_intBits							= 0;
	m_strChannels					= _T("");
	m_strFormat						= _T("");
	m_intSamples					= 0;
	m_strPlayFile.LoadString(IDS_NO_FILE_CHOOSEN);
	m_strRecordFile.LoadString(IDS_NO_FILE_CHOOSEN);

	m_NumFFTPoints				= *theApp.GetIniDokumentFFTPoints();
	free (m_pSoundBuffer);
//	if (g_bIsConvertedPlay)
//		free (m_pSoundBufferConverted);	

	m_SoundBufferSize			=	0;
// 	m_AktualPlaySoundBufferSize = 0;
	m_SoundBufferConvertedSize = 0;
	m_MaxAmplitude				=	0;

	SAFE_DELETE( m_pSound );
	CString Text;
	Text.LoadString(IDS_NO_FILE_CHOOSEN);
	SetTitle(Text);
	UpdateStatusBar();
	UpdateAllViews(NULL,50);
}


VOID CSoundsDoc::OnCaptureDone()
{
	//Bildrate von 25Hz einhalten je nach FFT und Samplinggre
//	INT counter=(INT)floor(m_intSamples/m_NumFFTPoints/25);
//	if (m_counter==counter) 
			//Abbruch mit ESC abfangen wenn nicht im Capturemodus
	MSG msg;
	PeekMessage( &msg, NULL, 0, 0, PM_REMOVE );
	if (msg.message == WM_KEYDOWN && msg.wParam == VK_ESCAPE) 
	{
		g_bIsBreak=TRUE;
	  TranslateMessage(&msg); 
    DispatchMessage(&msg); 
	}

	if (g_bIsBreak) OnDatenAudioeingang();
	else
	{
		m_ZeitreiheArray.RemoveAll();
		m_FrequenzenArray.RemoveAll();
		m_ZeitreiheArray.Copy(*m_CaptureThreadInfo.m_pThreadZeitreiheArray);
		m_strRecordFile=m_CaptureThreadInfo.m_strRecordFile;
		DoFFT(m_NumFFTPoints);

//		m_counter=-1;

/*		
//		CMemFile m_MemFile( 8192 ); // Ready to use - no Open necessary.
//		m_MemFile.Write();
//		BYTE * pBuf = (BYTE *)new char [1024];
//		CMemFile g( pBuf, BufferSize, 8192 );
// same as CMemFile g; g.Attach( pBuf, 1024, 256 );
		CWaveFile* pWaveFile=;//m_CaptureThreadInfo.m_pCaptureWaveFile;

		DWORD   dwFileSize					 = 0;		 // Size of the locked DirectSound buffer
		DWORD   dwWavDataRead        = 0;    // Amount of data read from the wav file 

//  pWaveFile->Open( strFileName, NULL, WAVEFILE_READ );
//	pWaveFile->ResetFile();
//	m_BitRate=pWaveFile->m_pwfx->wBitsPerSample;
		dwFileSize=pWaveFile->GetSize();

		m_pSoundBuffer=(BYTE*)malloc (sizeof(BYTE)*dwFileSize);
	
	  if( FAILED( pWaveFile->Read( m_pSoundBuffer, dwFileSize, &dwWavDataRead ) ) )           
		{
			AfxMessageBox("Read in AbbildArray failed. IN: DOC.");
			free(m_pSoundBuffer);	
		}
	
		m_SoundBufferSize=dwFileSize;
		m_AktualPlaySoundBufferSize=m_SoundBufferSize;

//		m_pSoundBuffer=m_MemFile.Detach();
//		DWORD BufferSize=m_MemFile.GetLength();
*/
/*
		//m_pSoundBuffer neu erstellen
		m_WAVKomplettArray.Append(m_ZeitreiheArray);
	INT counter=(INT)floor(m_intSamples/m_NumFFTPoints);
	if (m_counter==counter) 
	{
		if (m_pSoundBuffer) 
		{
			free(m_pSoundBuffer);
		}	
		DWORD BufferSize=m_WAVKomplettArray.GetSize();
		m_pSoundBuffer=(BYTE*)malloc (sizeof(short)*BufferSize);

		for(UINT register x=0;x<BufferSize;x=x++)	
		{
				*((short*)(m_pSoundBuffer)+x)=m_WAVKomplettArray.GetAt(x);
		}
//		DOUBLE Wert=*((short*)(pbCaptureData2)+x);

//		memcpy(m_pSoundBuffer,m_WAVKomplettArray.GetData(),BufferSize);
		m_SoundBufferSize=BufferSize;
	}
*/		
		UpdateAllViews(NULL,50);
	}
//	m_counter++;
}

VOID CSoundsDoc::OnPlayNotifyDone(DWORD Offset)
{
	DWORD cT=0;
	DWORD SizeToRead=m_NumFFTPoints;
	
	if (m_BitRate==16) 
	{
		Offset=Offset/2;
	}
	m_PlayCursor=Offset;
	//Offset entspricht Offset im Playbuffer, daher bei Konvertierung hochrechnen auf Originalbuffer
	if (g_bIsConvertedPlay) 
	{
		Offset=Offset*(INT)(m_SoundBufferSize/(DOUBLE)m_AktualPlaySoundBufferSize);
	}
	
	if ((Offset+SizeToRead)<=(m_BitRate==8?m_SoundBufferSize:m_SoundBufferSize/2)) 
	{
		m_ZeitreiheArray.RemoveAll();
		m_ZeitreiheArray.SetSize(SizeToRead);
		m_FrequenzenArray.RemoveAll();
		for(UINT register x=Offset;x<Offset+SizeToRead;x=x++)	
		{
			DOUBLE Wert=m_BitRate==8?*((BYTE*)(m_pSoundBuffer)+x):*((short*)(m_pSoundBuffer)+x);
			m_ZeitreiheArray[x-Offset]=Wert;
		}

		DoFFT(m_NumFFTPoints);

		if ((m_PlayCursor>m_dwBufferRegionEnd&&m_dwBufferRegionEnd!=m_dwBufferRegionStart)
			||m_dwBufferRegionStart>m_PlayCursor) 
		{
			if (!g_bLooped)
				OnStopwave();
			else
				m_pSound->GetBuffer(0)->SetCurrentPosition(m_BitRate==16?m_dwBufferRegionStart*2:m_dwBufferRegionStart);
		}

		UpdateAllViews(NULL,12);
	}
}
void CSoundsDoc::ChangeCWTtoFrequencies()
{
	m_FrequenzenArray.RemoveAll();
//	m_FrequenzenArray.SetSize(m_NumFFTPoints/2);
	INT Zeiten=m_pWaveletTrafo->m_arguments.b.n;
	for (int i=0; i<m_NumFFTPoints/2 ;i++)
	{
		DOUBLE Durchschnitt=0;
		for	(int j=0; j<Zeiten; j++)
		{
			Durchschnitt+=m_PGMKomplettArray.GetAt(i*Zeiten+j+2);
		}
		Durchschnitt=Durchschnitt/Zeiten;
		m_FrequenzenArray.Add(Durchschnitt);
	}
}


BOOL CSoundsDoc::CreatePalette(CPalette* pPal)
{
	const int nNumColors = 1536;//1664;
	BOOL bSucc=FALSE;
	LPLOGPALETTE lpPal = (LPLOGPALETTE)new BYTE[sizeof(LOGPALETTE) + sizeof(PALETTEENTRY) *	nNumColors];
	
	if (lpPal != NULL)
	{
		lpPal->palVersion = 0x300;
		lpPal->palNumEntries = nNumColors;
		
		PALETTEENTRY *ppe = lpPal->palPalEntry;
		
/*
		for (int nIndex = 128; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(nIndex);
			ppe->peGreen = (BYTE)(0);
			ppe->peBlue = (BYTE)(0);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
*/
		for (int nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(255);
			ppe->peGreen = (BYTE)(nIndex);
			ppe->peBlue = (BYTE)(0);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
		for (nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(255-nIndex);
			ppe->peGreen = (BYTE)(255);
			ppe->peBlue = (BYTE)(0);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
		for (nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(0);
			ppe->peGreen = (BYTE)(255);
			ppe->peBlue = (BYTE)(nIndex);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
		for (nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(0);
			ppe->peGreen = (BYTE)(255-nIndex);
			ppe->peBlue = (BYTE)(255);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
		for (nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(nIndex);
			ppe->peGreen = (BYTE)(0);
			ppe->peBlue = (BYTE)(255);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
		for (nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(255);
			ppe->peGreen = (BYTE)(nIndex);
			ppe->peBlue = (BYTE)(255);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
		
		
		bSucc = pPal->CreatePalette(lpPal);
		
		delete [](PBYTE)lpPal;
	}
	
	return bSucc;
}




//Button Audioeingang gedrckt
void CSoundsDoc::OnAudioeingang() 
{
	OnDatenAudioeingang();	
}

void CSoundsDoc::OnReadWave() 
{
	OnDatenWavefileeinlesen();	
}


void CSoundsDoc::OnFileMruFile1() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	BOOL nono=TRUE;
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CSoundsDoc::SetObertonPeaks(CArray<DBLPOINT,DBLPOINT>* pPunktarray)
{
	m_Obertonpeaks.RemoveAll();
	m_Obertonpeaks.Copy(*pPunktarray);
}

void CSoundsDoc::OnHelpFinder() 
{
	m_help.SetHelpFile(m_strHelpFile);
	m_help.DisplayTocTab();
	m_help.DisplayTopic("html/Vorwort.html");
}

void CSoundsDoc::OnHelpIndex() 
{
	m_help.SetHelpFile(m_strHelpFile);
	m_help.DisplayTopic("html/Vorwort.html");
	m_help.DisplayIndexTab();
}
	


void CSoundsDoc::OnViewStatusBar() 
{
	CMainFrame* pFrame=(CMainFrame*)AfxGetMainWnd();
	pFrame->OnViewStatusBar();
	UpdateStatusBar();
}

void CSoundsDoc::OnViewToolbarnormal() 
{
	CMainFrame* pFrame=(CMainFrame*)AfxGetMainWnd();
	pFrame->OnViewToolbarnormal();
}


void CSoundsDoc::OnViewToolbarschule() 
{
	CMainFrame* pFrame=(CMainFrame*)AfxGetMainWnd();
	pFrame->OnViewToolbarschule();
}




void CSoundsDoc::OnSaveWave() 
{
	// Setup the OPENFILENAME structure
	CFileDialog WavefileCaptureDlg(FALSE,NULL,NULL,OFN_OVERWRITEPROMPT|OFN_ENABLESIZING|OFN_NOREADONLYRETURN,\
										            "WAV - Windows Waves|*.wav|MP3 - MPEG Layer 3 Audio Files|*.mp3|");
	WavefileCaptureDlg.m_ofn.nFilterIndex=1;
	WavefileCaptureDlg.m_ofn.lpstrDefExt=".wav";
	CString Text;
	Text.LoadString(IDS_SAVE_WAVE);
	WavefileCaptureDlg.m_ofn.lpstrTitle=Text.GetBuffer(Text.GetLength());
	if (WavefileCaptureDlg.DoModal()==IDOK) 
	{
		CString Pfad=WavefileCaptureDlg.GetPathName();
		LPTSTR strFileNameWrite= Pfad.GetBuffer(MAX_PATH);
		// Hardcopy laden
		CString FileNameRead=m_strPlayFile;//theApp.GetModulPath()+"Aufnahme.wav";
		LPTSTR strFileNameRead=FileNameRead.GetBuffer(MAX_PATH);

		CString Extension=WavefileCaptureDlg.GetFileExt();
		Extension.MakeLower();
		if (Extension=="wav") SaveWAV2WAV(strFileNameWrite,strFileNameRead);
		if (Extension=="mp3") SaveWAV2MP3(strFileNameWrite,strFileNameRead);
	}
}

void CSoundsDoc::SaveWAV2WAV(LPTSTR strFileNameWrite,LPTSTR strFileNameRead)
{
	HRESULT   hr;
	CWaveFile* pwaveFileRead;
	CWaveFile* pwaveFileWrite;
	pwaveFileRead=new CWaveFile;
	pwaveFileWrite=new CWaveFile;
	WAVEFORMATEX* pwfx=NULL;
	CString Fehlertext;
		if( FAILED( hr = pwaveFileRead->Open( strFileNameRead, NULL, WAVEFILE_READ ) ) )
		{
			sprintf(Fehlertext.GetBuffer(1000),"%s", strFileNameRead);
			CString Text;
			AfxFormatString1(Text,E_SAVEWAV2WAV,Fehlertext);
			AfxMessageBox(Text,MB_ICONINFORMATION);
		}
		else
		{
			pwfx=pwaveFileRead->GetFormat();
			DWORD SizeRead;
			DWORD dwFileSize=pwaveFileRead->GetSize();
			UINT SizeWrote;
			BYTE* pBuffer;

			pBuffer=(BYTE*)malloc(sizeof(BYTE)*dwFileSize);
	
		  if( FAILED( pwaveFileRead->Read( pBuffer, dwFileSize, &SizeRead ) ) )           
			{
				pwaveFileRead->Close();
				sprintf(Fehlertext.GetBuffer(1000),"%s", strFileNameRead);
				CString Text;
				AfxFormatString1(Text,E_SAVEWAV2WAV_READ,Fehlertext);
				AfxMessageBox(Fehlertext,MB_ICONINFORMATION);
			}
			else
			{
				if( FAILED( hr = pwaveFileWrite->Open( strFileNameWrite, pwfx, WAVEFILE_WRITE ) ) )
				{
			    AfxMessageBox(E_SAVEWAV2WAV_OPEN,MB_ICONINFORMATION);
					pwaveFileRead->Close();
				}
				else if( FAILED( hr = pwaveFileWrite->Write( SizeRead,pBuffer,&SizeWrote ) ) )
				{
					pwaveFileWrite->Close();
					pwaveFileRead->Close();
			    AfxMessageBox(E_SAVEWAV2WAV_WRITE,MB_ICONINFORMATION);
				}
				else
				{
					pwaveFileWrite->Close();
					pwaveFileRead->Close();
				}
			}
		}
 	SAFE_DELETE (pwaveFileWrite);
 	SAFE_DELETE (pwaveFileRead);
}

HRESULT CSoundsDoc::CreateFilterByName(LPCTSTR lpszName,IBaseFilter** ppFilter)
{
	IBindCtx* pCtx;
	HRESULT hr = ::CreateBindCtx(0,&pCtx);
	ULONG ulEaten = 0;
	IMoniker* pmk = NULL;
	
	WCHAR Name[MAX_PATH];
	wsprintfW(Name, L"%hs", lpszName);

		hr = ::MkParseDisplayName(pCtx,Name,&ulEaten,&pmk);
	pCtx->Release();
	if(SUCCEEDED(hr))
	{
		hr = pmk->BindToObject(NULL,NULL,IID_IBaseFilter,(void**)ppFilter);
		pmk->Release();
	}

	return hr;
}

HRESULT CSoundsDoc::AddFilterByName(IGraphBuilder* pGB, LPCTSTR lpszDispName,LPCTSTR lpszName,IBaseFilter** ppFilter)
{
	//Create Filter
	IBaseFilter* spFilter = NULL;
	HRESULT hr = CreateFilterByName(lpszDispName,&spFilter);
	if(SUCCEEDED(hr))
	{
		WCHAR Name[MAX_PATH];
		wsprintfW(Name, L"%hs", lpszName);
		hr = pGB->AddFilter(spFilter,Name);
		if(SUCCEEDED(hr)&&(ppFilter!=NULL))
		{
			*ppFilter = spFilter;
			(*ppFilter)->AddRef();
		}
	}

	return hr;
}

BOOL CSoundsDoc::ConvertMP3toWAV(CString strInputFileName,CString strOutputFileName,HWND MessagehWnd) 
{
	bool bMp3 = FALSE;
	CString strAudioCompressor = c_tszMp3CodecDispName;
	CMp3Converter Converter;
	CString strFrom="-1";
	CString strTo="-1";

	Converter.SetMessagehWnd(MessagehWnd);
	Converter.EnableMp3Compress(bMp3,strAudioCompressor.CompareNoCase(_T("{lame}"))==0?c_tszLameMp3CodecDispName:strAudioCompressor);
	Converter.SetDebugMode(FALSE);
	Converter.SetInputFileName(strInputFileName.GetBuffer(MAX_PATH));
	Converter.SetOutputFileName(strOutputFileName.GetBuffer(MAX_PATH));
	Converter.SetPositions(_ttoi64(strFrom),_ttoi64(strTo));
	Converter.DelSyncSource();
	if (!Converter.Convert()) 
	{
		AfxMessageBox(E_CONVERT);
		return FALSE;
	}
	else
		return TRUE;
}

BOOL CSoundsDoc::SaveWAV2MP3(LPTSTR strFileNameWrite,LPTSTR strFileNameRead)
{
	bool bMp3 = TRUE;
	CString strAudioCompressor = c_tszMp3CodecDispName;
	CMp3Converter Converter;
	CString strFrom="-1";
	CString strTo="-1";

	Converter.SetMessagehWnd(NULL);
	Converter.EnableMp3Compress(bMp3,strAudioCompressor.CompareNoCase(_T("{lame}"))==0?c_tszLameMp3CodecDispName:strAudioCompressor);
	Converter.SetDebugMode(FALSE);
	Converter.SetInputFileName(strFileNameRead);
	Converter.SetOutputFileName(strFileNameWrite);
	Converter.SetPositions(_ttoi64(strFrom),_ttoi64(strTo));
	Converter.DelSyncSource();
	if (!Converter.Convert()) 
	{
		AfxMessageBox(E_CONVERT);
		return FALSE;
	}
	else
		return TRUE;
}

