// SoundsOverView.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "SplitterFrame.h"
#include "SoundsView.h"
#include "SoundsOverView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define RANDO 20
#define RANDL 10
#define RANDR 10
#define RANDU 1

/////////////////////////////////////////////////////////////////////////////
// CSoundsOverView

IMPLEMENT_DYNCREATE(CSoundsOverView, CScrollView)

CSoundsOverView::CSoundsOverView()
{
}

CSoundsOverView::~CSoundsOverView()
{
	DeleteObject(Rahmenstift);
	DestroyCaret();
}


BEGIN_MESSAGE_MAP(CSoundsOverView, CScrollView)
	//{{AFX_MSG_MAP(CSoundsOverView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_HELPINFO()
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Zeichnung CSoundsOverView 

void CSoundsOverView::OnInitialUpdate()
{
	m_Recalc=FALSE;
	CScrollView::OnInitialUpdate();
	CRect rect;
	GetClientRect(rect);
	m_WAVKomplettPtArray.RemoveAll();
	POINT Nullpunkt;
	Nullpunkt.x=0;
	Nullpunkt.y=0;
	m_DrawPosition=RANDL;
	m_Counter=0;
	m_WAVKomplettPtArray.Add(Nullpunkt);
//	m_LastMousePoint=Nullpunkt;
//	m_FirstMousePoint=Nullpunkt;
	m_RegionStart=Nullpunkt;
	m_RegionMove=Nullpunkt;
	m_RegionEnde=Nullpunkt;

	Rahmenstift.CreatePen(PS_SOLID,1,RGB(50,50,50));
	m_ZoomH=1;
	m_ZoomV=1;
	TimerID=0;
	m_pParentFrame=(CSplitterFrame*)GetParentFrame();
 	m_ScrollbreiteInPixel=rect.right-RANDR-RANDL;
	m_WAVKomplettPtArray.SetSize(rect.right-RANDL-RANDR);
	ScrollSetzen();
}


void CSoundsOverView::CreateCaret(bool Flag)
{
	if(Flag==true)
	{
		CRect rect;
		GetClientRect(rect);
		::CreateCaret(GetSafeHwnd(),NULL,0,rect.bottom-RANDU-RANDO);
		::SetCaretPos(RANDL,RANDO);
		ShowCaret();
	}
	else
		DestroyCaret();
}


void CSoundsOverView::OnDraw(CDC* dc)
{
	CMemDC pDC(dc);
	CRect rect;
	GetClientRect(rect);
//	CSize Scrollsize=GetTotalSize();
//	rect.right=Scrollsize.cx*2;
//	rect.bottom=Scrollsize.cy;
//	pDC->FillSolidRect(rect,RGB(255,255,255));
	if (g_bIsCapturing) 
	{
		DrawFromArray(pDC);
	}
	else
	{
		m_DrawPosition=RANDL;
		m_Counter=0;
		m_WAVKomplettPtArray.RemoveAll();
		DrawFromSoundBuffer(pDC);
	}
}

void CSoundsOverView::DrawFromArray(CDC* pDC)
{
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	INT* pBitRate=pDoc->GetBitRate();
	BOOL* pSigned=pDoc->GetSigned();
	CArray<DOUBLE,DOUBLE>* pZeitreiheArray=pDoc->GetZeitreiheArray();

	DOUBLE MaxZeit=pZeitreiheArray->GetSize();
	CArray<POINT,POINT> m_ViewPtArray;
	if (MaxZeit==1) 
	{
		m_ViewPtArray.RemoveAll();
		POINT Nullpunkt;
		Nullpunkt.x=0;
		Nullpunkt.y=0;
		m_ViewPtArray.Add(Nullpunkt);
	}
	
	DOUBLE* pMaxAmplitude=pDoc->GetMaxAmplitude();
	INT Teiler=0;
	if (*pSigned)
		Teiler=2;
	else
		Teiler=1;

	CRect rect;
	GetClientRect(rect);
	CPen KurvenStift;
  KurvenStift.CreatePen(PS_SOLID,1,RGB(255,0,0));
//	pDC->FillSolidRect(rect,m_clrBkg);

	//View Array neu skalieren
	DOUBLE FaktorX=0,FaktorY=0;
	POINT Messpunkt,Anfangspunkt;
  if (MaxZeit>1)
	{
//		m_ViewPtArray.RemoveAll();
		FaktorX=0.001;//(FLOAT)(*pDoc->GetFFTPoints());//((rect.right-rect.left)/150);
	  FaktorY=((rect.bottom-RANDO-RANDU)/(*pMaxAmplitude)/Teiler);
	  int i=0;
		INT Sprung=10;
//		if (FaktorX<1) Sprung=(INT)(1/FaktorX);
//		else Sprung=1;

		while (i<MaxZeit)
    {
	    Messpunkt.x=m_DrawPosition+(LONG)(i*FaktorX);
			LONG sample=(LONG)((*pMaxAmplitude-pZeitreiheArray->GetAt(i))*FaktorY);
			Messpunkt.y=sample+RANDO;
			m_WAVKomplettPtArray.Add(Messpunkt);
			m_Counter++;
			i+=Sprung;
			if (Messpunkt.x>=rect.right-RANDR-2) 
			{
				m_DrawPosition=RANDL;
				m_Counter=0;
				m_WAVKomplettPtArray.RemoveAll();
			}
		}
		m_DrawPosition=Messpunkt.x;
		
		//Zeitreihe zeichnen  
		pDC->SelectObject(&KurvenStift);
		if (m_WAVKomplettPtArray.GetSize()>1) 
		{
			Anfangspunkt=m_WAVKomplettPtArray[0];
			pDC->MoveTo(Anfangspunkt);
			INT i=1;
			while (i < m_WAVKomplettPtArray.GetSize())
			{
		    POINT NextPunkt=m_WAVKomplettPtArray[i];
//			  pDC->LineTo(NextPunkt.x,m_WAVKomplettPtArray[i-1].y);
				pDC->LineTo(NextPunkt);
		   i++;
			}
		}
	}
/*
	//Scrollschienen neu skalieren und gesamte Zeitreihe neu zeichnen
	CSize sizeTotal;	
	sizeTotal=GetTotalSize();
	if (m_DrawPosition>=sizeTotal.cx) 
	{
		sizeTotal.cx=m_DrawPosition+rect.right/2;
		sizeTotal.cy=(rect.bottom-rect.top);
		SetScrollSizes(MM_TEXT,sizeTotal);
		POINT pos;
		pos.x=m_DrawPosition;
		pos.y=0;
		ScrollToPosition(pos);

	  pDC->SelectObject(&KurvenStift);
		Anfangspunkt=m_WAVKomplettPtArray[0];
    pDC->MoveTo(Anfangspunkt);
    int i=1;
    while (i < (m_WAVKomplettPtArray.GetSize()-2))
    {
      POINT NextPunkt=m_WAVKomplettPtArray[i];
      pDC->LineTo(NextPunkt.x,m_WAVKomplettPtArray[i-1].y);
      pDC->LineTo(NextPunkt);
      i++;
    }
	}	
	*/
	ZeichneUmrandung(pDC);
}	



void CSoundsOverView::DrawFromSoundBuffer(CDC* pDC)
{
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CPen KurvenStift;
  KurvenStift.CreatePen(PS_SOLID,1,RGB(255,0,0));
	CRect rect;
	GetClientRect(rect);
  CPen SchwarzerStift;
  SchwarzerStift.CreatePen(PS_SOLID,1,RGB(255,0,0));
  pDC->SelectObject(&SchwarzerStift);
	INT* pBitRate=pDoc->GetBitRate();
	INT* pSampleRate=pDoc->GetSampleRate();
	BOOL* pSigned=pDoc->GetSigned();
	BYTE* pSoundBuffer=pDoc->GetSoundBuffer();
	DWORD* pSoundBufferSize=pDoc->GetSoundBufferSize();
	DOUBLE* pMaxAmplitude=pDoc->GetMaxAmplitude();

	INT Teiler=0;
//	m_ZoomH=2;
	if (*pSigned)
		Teiler=2;
	else
		Teiler=1;

	//Ausgewhlte Punkte mit Redundanz von PtsPerPixelEvaluate zeichnen
	DOUBLE FaktorX=0;
	INT Sprung=1;
	DOUBLE FaktorY=0;
	if ((*pSoundBufferSize>50))
	{
		POINT Messpunkt;
		DOUBLE FaktorPufferSize=0;
		DWORD size;
		size=*pBitRate==16?*pSoundBufferSize/2:*pSoundBufferSize;
		FLOAT PtsPerPixelIsThere=size/((FLOAT)(m_ZoomH*rect.right)-RANDL-RANDR);
		INT PtsPerPixelEvaluate=100;
		Sprung=MAX(1,PtsPerPixelIsThere/PtsPerPixelEvaluate); 
		FaktorX=1/PtsPerPixelIsThere;
    int i=0;
		short sample;
	  pDC->MoveTo(RANDL,(rect.bottom-RANDO-RANDU)/2+RANDO);
		CPoint pt=GetScrollPosition();

		//		for(int register x=0;x<(long)size;x=x+Sprung)	
		for(int register x=MAX(0,(pt.x-RANDL)*PtsPerPixelIsThere);x<(long)MIN((pt.x+rect.right)*PtsPerPixelIsThere,size);x=x+Sprung)	
		{
			sample=*pBitRate==8?((*((BYTE*)pSoundBuffer+x)-128)*((rect.bottom-RANDO-RANDU)*m_ZoomV/2))/128:\
													((*((short*)pSoundBuffer+x))*((rect.bottom-RANDO-RANDU)*m_ZoomV/2))/(65536/2);
			Messpunkt.x=RANDL+(LONG)(x*FaktorX);
			Messpunkt.y=(rect.bottom-RANDO-RANDU)/2-sample+RANDO;
	    pDC->LineTo(Messpunkt);
		}
		m_Recalc=FALSE;
		CSize sizeTotal;
		sizeTotal.cx=rect.right*m_ZoomH;
		sizeTotal.cy=rect.bottom;
		SetScrollSizes(MM_TEXT,sizeTotal);
	}

	//Rahmenauswahl zeichnen
	pDC->SelectObject(&Rahmenstift);
	if (m_RegionEnde.x!=0) 
	{
		CPen pe(PS_NULL,0,COLORREF(0));
		CPen* oldp =pDC->SelectObject (&pe);
		pDC->SetROP2(R2_NOT);
		pDC->Rectangle (m_RegionStart.x,RANDO,m_RegionEnde.x+1,rect.bottom-RANDU+1);
		pDC->SelectObject (oldp);
	}
	ZeichneUmrandung(pDC);
}

void CSoundsOverView::ZeichneUmrandung(CDC* pDC)
{
	//Rnder zeichnen
	CRect rect;
	GetClientRect(rect);
	COLORREF bkg=GetSysColor(COLOR_MENU); 
	CSize Scrollsize=GetTotalSize();
	if (Scrollsize.cx<=rect.right) Scrollsize.cx=rect.right;
	pDC->FillSolidRect(0,0,Scrollsize.cx,RANDO,bkg);
	pDC->FillSolidRect(0,RANDO,RANDL+1,rect.bottom-RANDU+1,bkg);
	pDC->FillSolidRect(Scrollsize.cx-RANDR,RANDO,Scrollsize.cx+1,rect.bottom-RANDU+1,bkg);
	pDC->FillSolidRect(0,rect.bottom-RANDU,Scrollsize.cx+1,rect.bottom+1,bkg);

	//Skala zeichnen
	if (g_bIsWaveLoaded) 
		ZeichneZeiten(pDC);
}

void CSoundsOverView::ScrollSetzen()
{
//		CSize sizeTotal;
		CRect rect;
		GetClientRect(&rect);
		if (m_ScrollbreiteInPixel!=0)
		{
			m_sizeTotal.cx=m_ScrollbreiteInPixel+RANDL+RANDR;//rect.right*m_ZoomH;
		}
		else m_sizeTotal.cx=rect.right;
		m_sizeTotal.cy=rect.bottom;
		SetScrollSizes(MM_TEXT,m_sizeTotal);
		GetClientRect(&rect);
		m_sizeTotal.cy=rect.bottom;
		SetScrollSizes(MM_TEXT,m_sizeTotal);
}
/////////////////////////////////////////////////////////////////////////////
// Diagnose CSoundsOverView

#ifdef _DEBUG
void CSoundsOverView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CSoundsOverView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CSoundsOverView 

void CSoundsOverView::ClearAusschnitt()
{
	//alte Markierung entfernen
	CRect rect;
	GetClientRect(rect);
	CRect Region;
	CPoint Punkt=GetScrollPosition();

	Region.left=m_RegionStart.x-Punkt.x;
	Region.top=RANDO;
	Region.bottom=rect.bottom-RANDU;
	Region.right=m_RegionEnde.x-Punkt.x;
	CDC* pDC=GetDC();
	pDC->InvertRect(&Region);
	ReleaseDC(pDC);

	//Ausschnitte entfernen
	POINT Nullpunkt1;
	Nullpunkt1.x=0;
	Nullpunkt1.y=0;
	m_AusschnittEnde=Nullpunkt1;
	m_AusschnittStart=Nullpunkt1;
	m_RegionStart=Nullpunkt1;
	m_RegionMove=Nullpunkt1;
	m_RegionEnde=Nullpunkt1;

	CSplitterFrame* pSplitterFrame=(CSplitterFrame*)GetParentFrame();
	CSoundsView* pWnd=(CSoundsView*)pSplitterFrame->m_wndSplitter.GetPane(1,0);
	pWnd->m_AusschnittStart=m_AusschnittStart;
	pWnd->m_AusschnittEnde=m_AusschnittEnde;
	pWnd->m_FirstMousePoint=Nullpunkt1;
	pWnd->m_LastMousePoint=Nullpunkt1;
	pWnd->m_MoveMousePoint=Nullpunkt1;

	CSoundsDoc* pDoc=GetDocument();
	pDoc->SetSelectedRegion(0,0);

}

void CSoundsOverView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CPoint Punkt=GetScrollPosition();
	CSize Scrollsize=GetTotalSize();
	CRect rect;
	GetClientRect(&rect);

	//alte Markierung entfernen
	ClearAusschnitt();
/*	CRect Region;
	Region.left=m_RegionStart.x-Punkt.x;
	Region.top=RANDO;
	Region.bottom=rect.bottom-RANDU;
	Region.right=m_RegionEnde.x-Punkt.x;
	CDC* pDC=GetDC();
	pDC->InvertRect(&Region);
	ReleaseDC(pDC);
*/
	RaenderKorrigieren(&point,Punkt,Scrollsize,rect);

	//Waveposition berechnen
	INT Breite=(INT)(Punkt.x+point.x);
	INT Hoehe=(INT)(Punkt.y+point.y);

	m_AusschnittStart.x=Breite-RANDL;
	if (m_AusschnittStart.x<0) m_AusschnittStart.x=0;
	m_AusschnittStart.y=Hoehe;
	CSoundsDoc* pDoc=GetDocument();
	DWORD Position=-1;
	if (g_bIsWaveLoaded)
	{
		DWORD FileSize=pDoc->m_pSound->m_pWaveFile->GetSize();
		Position=(DWORD)((DOUBLE)m_AusschnittStart.x*(DOUBLE)FileSize/(DOUBLE)(Scrollsize.cx-RANDL-RANDR));
		pDoc->m_pSound->GetBuffer(0)->SetCurrentPosition(Position);
	}

	//Markierungsregion merken
	m_RegionStart.x=Breite;
	m_RegionMove.x=Breite;
	//Caret Setzen
	::SetCaretPos(point.x,RANDO);

	//Samplezahl in anderem Splitter auf Null setzen
	m_pParentFrame->m_wndDlgBar.SetDlgItemInt(IDC_ANZAHLPUNKTE,0,FALSE);
//	pDoc->SetSelectedRegion(Position,-1);
}

void CSoundsOverView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CScrollView::OnLButtonUp(nFlags, point);

	//Position berechnen
	CRect rect;
	GetClientRect(&rect);
	CPoint Punkt=GetScrollPosition();
	CSize Scrollsize=GetTotalSize();

	RaenderKorrigieren(&point,Punkt,Scrollsize,rect);

	INT Breite=(INT)(Punkt.x+point.x);
	INT Hoehe=(INT)(Punkt.y+point.y);

	//Waveausschnitt berechnen
	CSize Size=GetTotalSize();
	m_AusschnittEnde.x=Breite-RANDL;//MIN(Breite-RANDL,Size.cx-RANDL);
	m_AusschnittEnde.y=Hoehe;

	CSplitterFrame* pSplitterFrame=(CSplitterFrame*)GetParentFrame();
	CSoundsView* pWnd=(CSoundsView*)pSplitterFrame->m_wndSplitter.GetPane(1,0);

	//Markierung von rechts nach links abfangen
	if (m_AusschnittStart.x>m_AusschnittEnde.x) 
	{
		POINT Tausch;
		Tausch=m_AusschnittEnde;
		m_AusschnittEnde=m_AusschnittStart;
		m_AusschnittStart=Tausch;
	}
	//Ausschnitt an anderes Splitter bergeben
	pWnd->m_AusschnittStart=m_AusschnittStart;
	pWnd->m_AusschnittEnde=m_AusschnittEnde;
	pWnd->m_FirstMousePoint.x=0;
	pWnd->m_FirstMousePoint.y=0;
	pWnd->m_LastMousePoint.x=0;
	pWnd->m_LastMousePoint.y=0;
	pWnd->m_MoveMousePoint.x=0;
	pWnd->Invalidate(TRUE);

	//Markierungsregion setzen
	m_RegionMove.x=Breite;
	m_RegionEnde.x=Breite;

	//Markierung von rechts nach links abfangen
	if (m_RegionStart.x>m_RegionEnde.x) 
	{
		POINT Tausch;
		Tausch=m_RegionEnde;
		m_RegionEnde=m_RegionStart;
		m_RegionMove=m_RegionEnde;
		m_RegionStart=Tausch;
	}
	
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CSize SizeOverview=GetTotalSize();

	//Anfang und Ende im Originialpuffer berechnen in Abhnggkeit von BitRate
	DWORD Soundbuffersize=*pDoc->GetSoundBufferSize();
	DOUBLE BufferSizeInSamples=*pDoc->GetBitRate()==16?Soundbuffersize/2:Soundbuffersize;
	DWORD	Start=(INT)(m_AusschnittStart.x*(BufferSizeInSamples/(SizeOverview.cx-RANDL-RANDR)));
	DWORD	Ende=(INT)(m_AusschnittEnde.x*(BufferSizeInSamples/(SizeOverview.cx-RANDL-RANDR)));

	//Anfang und Ende im Abspielpuffer berechnen in Abhnggkeit von BitRate
	DWORD SoundbuffersizeConverted=*pDoc->GetAktualPlaySoundBufferSize();
	DOUBLE BufferSizeInSamplesConverted=*pDoc->GetBitRate()==16?SoundbuffersizeConverted/2:SoundbuffersizeConverted;
	DWORD	StartConverted=(INT)(m_AusschnittStart.x*(BufferSizeInSamplesConverted/(SizeOverview.cx-RANDL-RANDR)));
	DWORD	EndeConverted=(INT)(m_AusschnittEnde.x*(BufferSizeInSamplesConverted/(SizeOverview.cx-RANDL-RANDR)));

	if (*pDoc->GetBitRate()==16) 
	{
		Ende=Ende-Ende%2;
		Start=Start-Start%2;
	}

	if (Ende-Start>20) 
	{
		if (*theApp.GetIniAllgemeinGrundschulprofil()) 
		{
			pDoc->PutNewWaveCutPointsInArrays(Start,Ende);
		}
		pDoc->SetSelectedRegion(StartConverted,EndeConverted);
	}
	else
		pDoc->SetSelectedRegion(0,0);
}

void CSoundsOverView::RaenderKorrigieren(CPoint* point,CPoint ScrollPunkt,CSize Scrollsize, CRect ClientRect ) 
{
		//In Rand hineinfahren abfangen
		if ((point->x<RANDL)&&(ScrollPunkt.x<RANDL)) 
		{
			point->x=RANDL;
		}
		//Wenn Maus im rechten Rand auf Ende setzen
		if ((point->x>ClientRect.right-RANDR)&&(ScrollPunkt.x>=Scrollsize.cx-ClientRect.right-1)) 
		{
			point->x=ClientRect.right-RANDR;
		}
}

void CSoundsOverView::OnMouseMove(UINT nFlags, CPoint point) 
{
  if (nFlags==MK_LBUTTON)
	{
		CRect rect;
		GetClientRect(&rect);
		CPoint Punkt=GetScrollPosition();
		CSize Scrollsize=GetTotalSize();

		RaenderKorrigieren(&point,Punkt,Scrollsize,rect);
		//Position berechnen
		INT Breite=(INT)(Punkt.x+point.x);
		INT Hoehe=(INT)(Punkt.y+point.y);

		//Region markieren
		CRect Region;
		Region.left=m_RegionMove.x-Punkt.x;
		Region.top=RANDO;
		Region.bottom=rect.bottom-RANDU;
		Region.right=point.x;
		CDC* pDC=GetDC();
 		pDC->InvertRect (&Region);
		ReleaseDC(pDC);
		::SetCaretPos(point.x,RANDO);
		
		//Markierungsregion aktualisieren
		m_RegionMove.x=Breite;
		m_RegionEnde.x=Breite;
	}
}

void CSoundsOverView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (lHint==50)
	{
		CreateCaret(TRUE);
		::SetCaretPos(m_CarPos,RANDO);
		ShowCaret();
		m_Recalc=TRUE;
		Invalidate(TRUE);
		if (g_bIsCapturing) 
		{
			CRect rect;
			GetClientRect(rect);
			rect.left=RANDL;
			rect.top=RANDO;
			rect.right=m_DrawPosition;
			ValidateRect(rect);
		}
		KillTimer(TimerID);
	}
	if (lHint==23) 
		TimerID=SetTimer(45,60,NULL);
	if (lHint==11) 
	{
		KillTimer(TimerID);
		ClearAusschnitt();
	}
}

void CSoundsOverView::OnTimer(UINT nIDEvent) 
{
	if (g_bIsPlayingWave) 
	{
		CSoundsDoc* pDoc = GetDocument();
		CSize Size=GetTotalSize();
		CRect rect;
		GetClientRect(rect);
		INT* pBitRate=pDoc->GetBitRate();
		DWORD* pPlaySoundBufferSize=pDoc->GetAktualPlaySoundBufferSize();
//		DWORD PlayCursor=pDoc->m_pStreamingSound->m_dwPlayProgress%pDoc->m_pStreamingSound->m_pWaveFile->GetSize();
		DWORD PlayCursor,WriteCursor;
		HRESULT hr=pDoc->m_pSound->GetBuffer(0)->GetCurrentPosition(&PlayCursor,&WriteCursor);
		if (FAILED(hr)) 
		{
			AfxMessageBox(E_ONTIMER);
		}
		DWORD NumberOfSamples;
		pDoc->OnPlayNotifyDone(PlayCursor);

		if (*pBitRate==8) 
			NumberOfSamples=*pPlaySoundBufferSize;
		else
			NumberOfSamples=*pPlaySoundBufferSize;///2;

		POINT AktuellePosition=GetScrollPosition();
		m_CarPos=RANDL+(LONG)(((DOUBLE)PlayCursor/(DOUBLE)NumberOfSamples)*(Size.cx-RANDL-RANDR)-AktuellePosition.x);
		if (m_CarPos<RANDL) 
		{
			POINT Nullpunkt;
			Nullpunkt.x=0;
			Nullpunkt.y=0;
			ScrollToPosition(Nullpunkt);
			m_CarPos=RANDL;
		}
/*		if (CarPos>0) 
		{
			POINT NeuePosition;
			NeuePosition.x=AktuellePosition.x+CarPos;
			NeuePosition.y=AktuellePosition.y;
			CarPos-=CarPos;
			ScrollToPosition(NeuePosition);
		}
*/
		if (m_CarPos>rect.right) 
		{
			m_CarPos-=rect.right;
			POINT NeuePosition;
			NeuePosition.x=AktuellePosition.x+rect.right;
			NeuePosition.y=AktuellePosition.y;
			ScrollToPosition(NeuePosition);
		}

		CreateCaret(TRUE);
		::SetCaretPos(m_CarPos,RANDO);
		ShowCaret();

	  if( !pDoc->m_pSound->IsSoundPlaying() )
		{
	    pDoc->m_pSound->Reset();
			g_bIsPlayingWave=FALSE;
		}
	}
//	CScrollView::OnTimer(nIDEvent);
}


#define EINHEITEN_PRO_FENSTER_MIN 5
#define PIXEL_PRO_EINHEITEN_MIN 60
enum MasterEinheit {Minuten,Sekunden,Millisekunden};

void CSoundsOverView::ZeichneZeiten(CDC* pDC)
{
	CSoundsDoc* pDoc = GetDocument();
	CSize Size=GetTotalSize();
	CRect rect;
	GetClientRect(rect);
	COLORREF bkg=GetSysColor(COLOR_MENU); 
	CPen Schwarz(PS_SOLID,0,RGB(0,0,0));
	pDC->SelectObject (&Schwarz);
	CAutoFont font("Century Gothic");
	font.SetDC(pDC->GetSafeHdc());
	font.SetHeight(14);
	font.SetFontColor(RGB(0,0,0));
	CAutoFont font2("Century Gothic");
	font2.SetDC(pDC->GetSafeHdc());
	font2.SetHeight(13);
	font2.SetFontColor(RGB(0,0,0));
	CFont *oldFont=pDC->SelectObject(&font);
	pDC->SetBkColor(bkg);

	DWORD* pSoundBufferSize=pDoc->GetSoundBufferSize();
	if (*pSoundBufferSize>0) 
	{
/*		POINT Messpunkt;
		DOUBLE FaktorPufferSize=0;
		DWORD size;
		size=*pBitRate==16?*pSoundBufferSize/2:*pSoundBufferSize;
		FLOAT PtsPerPixelIsThere=size/((FLOAT)(m_ZoomH*rect.right)-RANDL-RANDR);
		INT PtsPerPixelEvaluate=100;
		Sprung=MAX(1,PtsPerPixelIsThere/PtsPerPixelEvaluate); 
		FaktorX=1/PtsPerPixelIsThere;
    int i=0;
		short sample;
	  pDC->MoveTo(RANDL,(rect.bottom-RANDO-RANDU)/2+RANDO);
		CPoint pt=GetScrollPosition();

		//		for(int register x=0;x<(long)size;x=x+Sprung)	
		for(int register x=MAX(0,(pt.x-RANDL)*PtsPerPixelIsThere);x<(long)MIN((pt.x+rect.right)*PtsPerPixelIsThere,size);x=x+Sprung)	
		{
			sample=*pBitRate==8?((*((BYTE*)pSoundBuffer+x)-128)*((rect.bottom-RANDO-RANDU)*m_ZoomV/2))/128:\
													((*((short*)pSoundBuffer+x))*((rect.bottom-RANDO-RANDU)*m_ZoomV/2))/(65536/2);
			Messpunkt.x=RANDL+(LONG)(x*FaktorX);
			Messpunkt.y=(rect.bottom-RANDO-RANDU)/2-sample+RANDO;
	    pDC->LineTo(Messpunkt);
		}
*/
		
		//Anzahl der gesamten Samples aus Soundpuffergre berechnen
		DWORD size=*pDoc->GetBitRate()==16?*pSoundBufferSize/2:*pSoundBufferSize;

		//Wieviele Sekunden Musik sind in der Datei 
		FLOAT MilliSekunden=MAX(size/(FLOAT)pDoc->m_intSamples*1000,1);

		//Wieviele Bildschirmpixel stehen fr eine Sekunde und eine Minute zur Verfgung ?
		FLOAT RasterMilliSekunden=((m_ZoomH*rect.right)-RANDL-RANDR)/(FLOAT)MilliSekunden;
		FLOAT RasterSekunden=RasterMilliSekunden*1000;
		FLOAT RasterMinuten=RasterSekunden*60;

		//Wieviele Striche sind pro ms ,s ,min im Fenster zu sehen ?
		FLOAT MilliSekundenProClientRect=rect.right/RasterMilliSekunden;
		FLOAT SekundenProClientRect=rect.right/RasterSekunden;
		FLOAT MinutenProClientRect=rect.right/RasterMinuten;
		
		//grte angezeigte Zeiteinheit mit Raster festlegen
		FLOAT							Zeiteinheit;
		FLOAT							Raster;
		INT								Unterteilung;
		MasterEinheit			Einheit;

		if (MinutenProClientRect>EINHEITEN_PRO_FENSTER_MIN) 
		{
			Zeiteinheit=MilliSekunden/1000.0f/60.0f;			//Minuten
			Raster=RasterMinuten;
			Unterteilung=6;
			Einheit=Minuten;
		}
		else  if (SekundenProClientRect>EINHEITEN_PRO_FENSTER_MIN) 
					{
						Zeiteinheit=MilliSekunden/1000.0f;		//Sekunden
						Raster=RasterSekunden;
						Unterteilung=10;
						Einheit=Sekunden;
					}
					else
					{
						Zeiteinheit=MilliSekunden;				//Millisekunden
						Raster=RasterMilliSekunden;
						Unterteilung=10;
						Einheit=Millisekunden;
					}

		//Falls aufeinanderfolgende Marker zu dicht liegen Sprung einfgen
		INT Sprung=1;
		INT SprungMillisekunden=1;

		if (Raster<PIXEL_PRO_EINHEITEN_MIN) 
		{
			Sprung=PIXEL_PRO_EINHEITEN_MIN/Raster;
//			if (Einheit==Millisekunden)
//				Sprung=Sprung-Sprung%50;
			if (Sprung==0) Sprung=1;
			//Wenn Sprnge zwischen Minuten oder Sekunden, dann keine weitere Unterteilung zeichnen
			if (Sprung>1)	Unterteilung=1;
			SprungMillisekunden=MAX(Sprung/10,1);
		}

		//Einheiten zeichnen
		INT IntMinuten=0;
		INT IntSekunden=0;
		INT IntMillisekunden=0;
		CString strMinuten=_T("");
		CString strSekunden=_T("");
		CString strMillisekunden=_T("");

		for (UINT i=0; i<Zeiteinheit; i+=Sprung)
		{
			pDC->MoveTo(i*Raster+RANDL,RANDO-1);
			pDC->LineTo(i*Raster+RANDL,14);

			//Einheiten richtig formatieren, dazu erst berechnen und dann zu String zusammensetzen
			switch(Einheit) 
			{
			case Minuten:
				IntMinuten=i;
				break;
			case Sekunden:
				IntMinuten=(INT)(i/60);
				IntSekunden=(INT)(i)%60;
				break;
			case Millisekunden:
				IntMinuten=(INT)(i/1000/60);
				IntSekunden=(INT)(i/1000);
				IntMillisekunden=(INT)(i)%1000;
				break;
			}
			char buffer[20];
			strMinuten=itoa( IntMinuten, buffer, 10 );
			strMinuten+=_T(":");
			strSekunden=itoa( IntSekunden, buffer, 10 );
			while (strSekunden.GetLength()<2) 
			{
					strSekunden=_T("0")+strSekunden;
			}

			if (IntMillisekunden>0) 
			{
				strSekunden+=_T(".");
				strMillisekunden=itoa( IntMillisekunden, buffer, 10 );
				while (strMillisekunden.GetLength()<3) 
				{
					strMillisekunden=_T("0")+strMillisekunden;
				}
			}
			else strMillisekunden=_T("");

			
			pDC->SelectObject(&font);
			pDC->TextOut(i*Raster-5+RANDL,0,strMinuten+strSekunden+strMillisekunden);


			//Unterraster zeichnen
			if (i<Zeiteinheit-1) 
			{
				if (Sprung==1) 
				{
					for (INT j=1; j<Unterteilung; j++ )
					{
						pDC->MoveTo(i*Raster+j*Raster/Unterteilung+RANDL,RANDO-1);
						pDC->LineTo(i*Raster+j*Raster/Unterteilung+RANDL,17);
					}
				}
				else
				{
					for (INT j=0; j<Sprung-SprungMillisekunden+1; j+=SprungMillisekunden )
					{
						pDC->MoveTo(i*Raster+j*Raster+RANDL,RANDO-1);
						pDC->LineTo(i*Raster+j*Raster+RANDL,17);
					}
				}
			}
		}
	}
}

void CSoundsOverView::OnSize(UINT nType, int cx, int cy) 
{
	CScrollView::OnSize(nType, cx, cy);
	if (m_ScrollbreiteInPixel>0) 
	{
		ClearAusschnitt();
		m_sizeTotal.cx=m_ScrollbreiteInPixel+RANDL+RANDR;//rect.right*m_ZoomH;
	}
	else
		m_sizeTotal.cx=cx;
	m_sizeTotal.cy=cy;
	SetScrollSizes(MM_TEXT,m_sizeTotal);
	
	m_Recalc=TRUE;
	Invalidate(TRUE);
}



BOOL CSoundsOverView::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	CSoundsDoc* pDoc=GetDocument();
	pDoc->m_help.SetHelpFile(pDoc->m_strHelpFile);
	pDoc->m_help.DisplayTopic("html/Hauptfenster.html");
	
	return CScrollView::OnHelpInfo(pHelpInfo);
}


int CSoundsOverView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style|=WS_HSCROLL;
	if (CScrollView::OnCreate(lpCreateStruct) == -1)
		return -1;
	return 0;
}

BOOL CSoundsOverView::OnEraseBkgnd(CDC* pDC) 
{
/*	CRect rect;
	GetClientRect(rect);

	if (g_bIsCapturing) 
	{
//		rect.left=RANDL;
		rect.top=RANDO;
		rect.bottom-=RANDU;
//		rect.right-=RANDR;
		pDC->FillSolidRect(rect,RGB(255,255,255));
	}
	else
	{
		CSize Scrollsize=GetTotalSize();
		if (Scrollsize.cx<=rect.right) Scrollsize.cx=rect.right;
		pDC->FillSolidRect(0,RANDO,Scrollsize.cx,rect.bottom-RANDU,RGB(255,255,255));
	}

//	CBrush br( GetSysColor( COLOR_WINDOW ) ); 
//  FillOutsideRect( pDC, &br );

	return TRUE;
//	return CScrollView::OnEraseBkgnd(pDC);
*/
	return FALSE;
}

