// SplitterFrame.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "SoundsView.h"
#include "SplitterFrame.h"
#include "SoundsOverView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define RANDOOV 20
/////////////////////////////////////////////////////////////////////////////
// CSplitterFrame

IMPLEMENT_DYNCREATE(CSplitterFrame, CMDIChildWnd)

CSplitterFrame::CSplitterFrame()
{
}

CSplitterFrame::~CSplitterFrame()
{
}


BEGIN_MESSAGE_MAP(CSplitterFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CSplitterFrame)
	ON_WM_CREATE()
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_V_OVERVIEW, OnReleasedcaptureSliderVOverview)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_H_OVERVIEW, OnReleasedcaptureSliderHOverview)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_V_VIEW, OnReleasedcaptureSliderVView)
	ON_COMMAND(ID_EDIT_CLEARALL, OnEditClearall)
	ON_EN_CHANGE(IDC_PTSPERPIXEL_FELD, OnChangePtsperpixelFeld)
	ON_BN_CLICKED(IDC_RADIO_HUELLE, OnRadioHuelle)
	ON_BN_CLICKED(IDC_RADIO_SAMPLES, OnRadioSamples)
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CSplitterFrame 

BOOL CSplitterFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
  CDC* pDC = GetDC();
	RECT rect;
	GetClientRect(&rect);	

	// create a splitter with 2 row, 1 columns
	if (!m_wndSplitter.CreateStatic(this, 2, 1))
	{
		TRACE0("Failed to CreateStaticSplitter\n");
		return FALSE;
	}
	
	// add the first splitter pane - the default view in column 0
	if (!m_wndSplitter.CreateView(0, 0,	RUNTIME_CLASS(CSoundsOverView), CSize(rect.right, (INT)(rect.bottom/6.0f)), pContext))
	{
		TRACE0("Failed to create first pane\n");
		return FALSE;
	}

	// add the second splitter pane - an input view in column 1
	if (!m_wndSplitter.CreateView(1, 0,	pContext->m_pNewViewClass, CSize(0, 0), pContext))
	{
		TRACE0("Failed to create second pane\n");
		return FALSE;
	}

	// activate the input view
	SetActiveView((CView*)m_wndSplitter.GetPane(1,0));
return TRUE;
//	return CMDIChildWnd::OnCreateClient(lpcs, pContext);
}

BOOL CSplitterFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
    // Erstellen eines untergeordneten Fensters ohne die Schaltflche Maximieren 
    cs.style |= WS_OVERLAPPEDWINDOW;
//		cs.style |= WS_THICKFRAME;
//		cs.style |= WS_BORDER;
//	  cs.style |= (WS_MINIMIZEBOX|WS_MAXIMIZEBOX);

    // Aufruf der Basisklassenversion
    return CMDIChildWnd::PreCreateWindow(cs); 
		
/*		if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;
//    cs.style = WS_OVERLAPPED|WS_CAPTION|WS_THICKFRAME|WS_MINIMIZEBOX|WS_MAXIMIZEBOX;
		cs.style |= WS_THICKFRAME;
		cs.style |= WS_BORDER;
	  cs.style |= (WS_MINIMIZEBOX|WS_MAXIMIZEBOX);
	return TRUE;
	*/
}

int CSplitterFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndDlgBar.Create(this, IDD_SCALE_RIGHT,CBRS_RIGHT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_SCALE_RIGHT))
	{
		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}

//	if (*theApp.GetIniAllgemeinGrundschulprofil()) m_wndDlgBar.ShowWindow(SW_HIDE);

	CSliderCtrl* SliderVOverviewCtrl=(CSliderCtrl*)m_wndDlgBar.GetDlgItem(IDC_SLIDER_V_OVERVIEW);
	SliderVOverviewCtrl->SetTicFreq( 1 );    // Send TBM_SETTICFREQ
	SliderVOverviewCtrl->SetLineSize( 1 );       // Send TBM_SETLINESIZE
	SliderVOverviewCtrl->SetPageSize( 1 );       // Send TBM_SETPAGESIZE
	SliderVOverviewCtrl->SetRange( 0, 20, TRUE );
	SliderVOverviewCtrl->SetPos(20);

	CSliderCtrl* SliderHOverviewCtrl=(CSliderCtrl*)m_wndDlgBar.GetDlgItem(IDC_SLIDER_H_OVERVIEW);
	SliderHOverviewCtrl->SetTicFreq( 1 );    // Send TBM_SETTICFREQ
	SliderHOverviewCtrl->SetLineSize( 1 );       // Send TBM_SETLINESIZE
	SliderHOverviewCtrl->SetPageSize( 1 );       // Send TBM_SETPAGESIZE
	SliderHOverviewCtrl->SetRange( 0, 20, TRUE );
	SliderHOverviewCtrl->SetPos(0);

	CSliderCtrl* SliderVViewCtrl=(CSliderCtrl*)m_wndDlgBar.GetDlgItem(IDC_SLIDER_V_VIEW);
	SliderVViewCtrl->SetTicFreq( 1 );    
	SliderVViewCtrl->SetLineSize( 1 );       
	SliderVViewCtrl->SetPageSize( 1 );       
	SliderVViewCtrl->SetRange( 0, 20, TRUE );
	SliderVViewCtrl->SetPos(20);       

	CEdit* pEditCtrl=(CEdit*)m_wndDlgBar.GetDlgItem(IDC_ANZAHLPUNKTE);
	pEditCtrl->EnableWindow(FALSE);
	pEditCtrl->SetWindowText("0");

	CSpinButtonCtrl* pPtsPerPixelCtrl=(CSpinButtonCtrl*)m_wndDlgBar.GetDlgItem(IDC_PTSPERPIXEL_SPIN);
 	pPtsPerPixelCtrl->SetRange(1,40);
	pPtsPerPixelCtrl->SetBuddy(m_wndDlgBar.GetDlgItem(IDC_PTSPERPIXEL_FELD));
	pPtsPerPixelCtrl->SetPos(30);

	DoPlacement(TRUE);	//GetIt
	
	return 0;
}


void CSplitterFrame::OnDestroy() 
{
	CMDIChildWnd::OnDestroy();
	DoPlacement(FALSE);	//PutIt
}

void CSplitterFrame::DoPlacement(BOOL bGetit)
{
	CSoundsApp *app=(CSoundsApp *)AfxGetApp();
	WINDOWPLACEMENT wp;
	if (bGetit) 
		wp=app->GetWP(UEBERSICHT);
	else
		this->GetWindowPlacement(&wp);

	app->SwitchWindowplacementAbsolutePercent(!bGetit,&wp);
	
	if (bGetit) 
		this->SetWindowPlacement(&wp);
	else
		app->PutWP(wp,UEBERSICHT);
}


void CSplitterFrame::OnReleasedcaptureSliderVOverview(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CSliderCtrl* SliderVOverviewCtrl=(CSliderCtrl*)m_wndDlgBar.GetDlgItem(IDC_SLIDER_V_OVERVIEW);
	INT Stelle=SliderVOverviewCtrl->GetPos();
	*pResult = 0;
	CSoundsOverView* pWnd1=(CSoundsOverView*)m_wndSplitter.GetPane(0,0);
	pWnd1->m_ZoomV=85-(Stelle+1)*4;
	pWnd1->m_Recalc=TRUE;
	pWnd1->Invalidate(TRUE);
	CSoundsView* pWnd2=(CSoundsView*)m_wndSplitter.GetPane(1,0);
//	pWnd2->m_ZoomV=Stelle+1;
//	pWnd2->Invalidate(TRUE);

}


void CSplitterFrame::OnReleasedcaptureSliderHOverview(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CSliderCtrl* SliderVOverviewCtrl=(CSliderCtrl*)m_wndDlgBar.GetDlgItem(IDC_SLIDER_H_OVERVIEW);
	INT Stelle=SliderVOverviewCtrl->GetPos();
	CSoundsOverView* pWnd1=(CSoundsOverView*)m_wndSplitter.GetPane(0,0);
	pWnd1->m_ZoomH=Stelle*2+1;
	pWnd1->m_Recalc=TRUE;
	pWnd1->ClearAusschnitt();
	pWnd1->Invalidate(TRUE);
//	pWnd1->ScrollSetzen();
//	pWnd1->ScrollSetzen();
	CSoundsView* pWnd2=(CSoundsView*)m_wndSplitter.GetPane(1,0);
	pWnd2->m_ZoomH_Overview=Stelle*2+1;
	pWnd2->Invalidate(TRUE);
	*pResult = 0;
}

void CSplitterFrame::OnReleasedcaptureSliderVView(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CSliderCtrl* SliderVViewCtrl=(CSliderCtrl*)m_wndDlgBar.GetDlgItem(IDC_SLIDER_V_VIEW);
	INT Stelle=SliderVViewCtrl->GetPos();
	CSoundsView* pWnd2=(CSoundsView*)m_wndSplitter.GetPane(1,0);
	pWnd2->m_ZoomV=22-(Stelle+1);
	pWnd2->m_Recalc=TRUE;
	pWnd2->Invalidate(TRUE);
	*pResult = 0;
}

void CSplitterFrame::OnEditClearall() 
{
	theApp.mp_doc->DeleteContents();
	theApp.mp_doc->UpdateAllViews(NULL,50);
}

void CSplitterFrame::OnChangePtsperpixelFeld() 
{
	INT PtsPerPixel=m_wndDlgBar.GetDlgItemInt(IDC_PTSPERPIXEL_FELD);
	CSoundsView* pWnd=(CSoundsView*)m_wndSplitter.GetPane(1,0);
	pWnd->m_PtsPerPixel=PtsPerPixel;
	pWnd->m_Recalc=TRUE;
	pWnd->Invalidate(TRUE);
}


void CSplitterFrame::OnRadioHuelle() 
{
	CSoundsView* pWnd=(CSoundsView*)m_wndSplitter.GetPane(1,0);
	pWnd->m_Recalc=TRUE;
	pWnd->OnRadioHuelle();
	pWnd->Invalidate(TRUE);
}

void CSplitterFrame::OnRadioSamples() 
{
	CSoundsView* pWnd=(CSoundsView*)m_wndSplitter.GetPane(1,0);
	pWnd->m_Recalc=TRUE;
	pWnd->OnRadioSamples();
	pWnd->Invalidate(TRUE);
}


void CSplitterFrame::OnClose() 
{
	// TODO: Code fr die Behandlungsroutine fr Nachrichten hier einfgen und/oder Standard aufrufen
	
	//CMDIChildWnd::OnClose();
}
