/////////////////////////////////////////////////////////////////////////////
// $Header: /cvsroot/mmconvert/mmconvert/MMConvert/Src/Common/TVExcept.cpp,v 1.5 2005/09/08 09:43:18 ping235 Exp $
//
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 ping235.  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//  This file is subject to the terms of the GNU General Public License as
//  published by the Free Software Foundation.  A copy of this license is
//  included with this software distribution in the file COPYING.  If you
//  do not have a copy, you may obtain a copy by writing to the Free
//  Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
// Change Log
//
// Date          Developer             Changes
// $Date: 2005/09/08 09:43:18 $        $Author: ping235 $              $Name:  $
//
/////////////////////////////////////////////////////////////////////////////
// CVS Log
// $Log: TVExcept.cpp,v $
// Revision 1.5  2005/09/08 09:43:18  ping235
// translate MMConvert into english
//
// Revision 1.4  2005/09/05 03:18:40  ping235
// modified TVException::ErrorCode
//
// Revision 1.3  2005/08/23 06:32:31  ping235
// translate exception message into zh_tw
//
// Revision 1.2  2005/08/22 03:38:33  ping235
// modified exception:added context
//
// Revision 1.1.1.1  2005/08/02 05:17:26  ping235
// initial,GUI 1.0.0.0,CMD 1.3.0.1
//
//////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include ".\tvexcept.h"
#include "afxmt.h"
#include "comdef.h"
#include "Sounds.h"

int CTVException::ReportError(UINT nType, UINT nIDHelp,int nLanguage)
{
	CString str = ErrorMessage(nLanguage);
	if(!ErrorDesc().IsEmpty())
		str+=_T("\r\n\r\n")+ErrorDesc();
	if(!Context().IsEmpty())
		str+=_T("\r\n\r\n")+Context();
	return AfxMessageBox(str,nType,nIDHelp);
}

CString CTVException::ErrorMessage(int nLanguage)
{
	if(m_dwErrorCode==E_SYSTEM_ERROR)
	{
		LPVOID lpMsgBuf;
		::FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			m_dwErrorCodeEx,
			WORD(nLanguage),
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			);

		CString strError=CString((TCHAR*)lpMsgBuf);
		LocalFree( lpMsgBuf );

		return strError==_T("")?_T("Unknown System Error"):strError;
	}
	else if(m_dwErrorCode==E_HRESULT_ERROR)
	{
		_com_error er(m_dwErrorCodeEx);
		return er.ErrorMessage();
	}
	else
	{
		switch(m_dwErrorCode)
		{
		case E_VIDEO_INPUT_DEV_NOT_FOUND:
		{
			//0x0804 Chinese (PRC) 
			if(nLanguage==0x0804)
				return _T("ҲƵ׽豸");
			//0x0404 Chinese (Taiwan) 
			else if(nLanguage==0x0404)
				return _T("Ҳҕl׽O䣡");
				//return _T("䤣W]ơI");
			//0x0409 English (United States)
			else
				return _T("Can not find video capture device.");
		}
		break;
		case E_AUDIO_INPUT_DEV_NOT_FOUND:
		{
			//0x0804 Chinese (PRC) 
			if(nLanguage==0x0804)
				return _T("ҲƵ׽豸");
			//0x0404 Chinese (Taiwan) 
			else if(nLanguage==0x0404)
				return _T("Ҳl׽O䣡");
				//return _T("䤣쭵W]ơI");
			//0x0409 English (United States)
			else
				return _T("Can not find audio capture device.");
		}
		break;
		case E_VIDEO_INPUT_DEV_NOT_ASSIGNED:
		{
			//0x0804 Chinese (PRC) 
			if(nLanguage==0x0804)
				return _T("δָƵ׽豸");
			//0x0404 Chinese (Taiwan) 
			else if(nLanguage==0x0404)
				return _T("δָҕl׽O䣡");
				//return _T("wW]ơI");
			//0x0409 English (United States)
			else
				return _T("unspecified video capture device.");
		}
		break;
		case E_AUDIO_INPUT_DEV_NOT_ASSIGNED:
		{
			//0x0804 Chinese (PRC) 
			if(nLanguage==0x0804)
				return _T("δָƵ׽豸");
			//0x0404 Chinese (Taiwan) 
			else if(nLanguage==0x0404)
				return _T("δָl׽O䣡");
				//return _T("wW]ơI");
			//0x0409 English (United States)
			else
				return _T("unspecified audio capture device.");
		}
		break;
		case E_GRAPH_NOT_INITIALIZE:
		{
			//0x0804 Chinese (PRC) 
			if(nLanguage==0x0804)
				return _T("Filter GraphδʼδInitCaptureGraph");
			//0x0404 Chinese (Taiwan) 
			else if(nLanguage==0x0404)
				return _T("Filter Graphδʼδ{InitCaptureGraph");
				//return _T("Filter GraphlơIեInitCaptureGraphơI");
			//0x0409 English (United States)
			else
				return _T("Filter Graph has not been initialized, please call InitCaptureGraph first");
		}
		break;
		case E_FILE_NOT_FOUND:
		{
			//0x0804 Chinese (PRC) 
			if(nLanguage==0x0804)
				return _T("ļڣ");
			//0x0404 Chinese (Taiwan) 
			else if(nLanguage==0x0404)
				return _T("ļڣ");
				//return _T("󤣦sbI");
			//0x0409 English (United States)
			else
				return _T("File not found.");
		}
		break;
		case E_PROFILE_VIDEO_ERROR:
		{
			//0x0804 Chinese (PRC) 
			if(nLanguage==0x0804)
				return _T("ProfileôƵӿ޷ӣ");
			//0x0404 Chinese (Taiwan) 
			else if(nLanguage==0x0404)
				return _T("Profilee`ҕlӿڟoBӣ");
				//return _T("ProfiletmAƵfުkI");
			//0x0409 English (United States)
			else
				return _T("profile error, can not connect video pin.");
		}
		break;
		case E_RENDER_FILE_FAILED:
		{
			//0x0804 Chinese (PRC) 
			if(nLanguage==0x0804)
				return _T("޷Ÿļûаװ");
			//0x0404 Chinese (Taiwan) 
			else if(nLanguage==0x0404)
				return _T("oŽoęnܛ]аba");
				//return _T("Lk񵹩wɡAiSw˸ѽXI");
			//0x0409 English (United States)
			else
				return _T("can not play specified file, maybe relevant codecs has not installed.");
		}
		break;
		default:
		{
			//0x0804 Chinese (PRC) 
			if(nLanguage==0x0804)
				return _T("δ֪");
			//0x0404 Chinese (Taiwan) 
			else if(nLanguage==0x0404)
				return _T("δ֪e`");
				//return _T("~I");
			//0x0409 English (United States)
			else
				return _T("unknown error.");
		}
		break;
		}
	}
}

void HandleTVException(DWORD dwError,CString strErrorDesc,CString strContext)
{
	if(dwError!=0)
	{
		CString Text;
		AfxFormatString2(Text,E_HANDLE_EXCEPTION,strErrorDesc,strContext);
		AfxMessageBox(Text,MB_ICONERROR);
		g_bIsBreak=TRUE;
	}
//		throw CTVException(dwError,0,strErrorDesc,strContext);
}

void HandleHRException(HRESULT hr,CString strErrorDesc,CString strContext)
{
	if(FAILED(hr))
	{
		CString Text;
		AfxFormatString2(Text,E_HANDLE_EXCEPTION,strErrorDesc,strContext);
		AfxMessageBox(Text,MB_ICONERROR);
		g_bIsBreak=TRUE;
	}
//		throw CTVException(CTVException::E_HRESULT_ERROR,hr,strErrorDesc,strContext);
}

void HandleWin32Exception(DWORD dwError,CString strErrorDesc,CString strContext)
{
	if(dwError!=0)
	{
		CString Text;
		AfxFormatString2(Text,E_HANDLE_EXCEPTION,strErrorDesc,strContext);
		AfxMessageBox(Text,MB_ICONERROR);
		g_bIsBreak=TRUE;
	}
//		throw CTVException(CTVException::E_SYSTEM_ERROR,dwError,strErrorDesc,strContext);
}
