/////////////////////////////////////////////////////////////////////////////
// $Header: /cvsroot/mmconvert/mmconvert/MMConvert/Src/Common/TVExcept.h,v 1.4 2005/09/06 08:22:09 ping235 Exp $
//
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 ping235.  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//  This file is subject to the terms of the GNU General Public License as
//  published by the Free Software Foundation.  A copy of this license is
//  included with this software distribution in the file COPYING.  If you
//  do not have a copy, you may obtain a copy by writing to the Free
//  Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
// Change Log
//
// Date          Developer             Changes
// $Date: 2005/09/06 08:22:09 $        $Author: ping235 $              $Name:  $
//
/////////////////////////////////////////////////////////////////////////////
// CVS Log
// $Log: TVExcept.h,v $
// Revision 1.4  2005/09/06 08:22:09  ping235
// added class versioninfo
//
// Revision 1.3  2005/09/05 03:18:40  ping235
// modified TVException::ErrorCode
//
// Revision 1.2  2005/08/22 03:38:33  ping235
// modified exception:added context
//
// Revision 1.1.1.1  2005/08/02 05:17:26  ping235
// initial,GUI 1.0.0.0,CMD 1.3.0.1
//
//////////////////////////////////////////////////////////////////////////////

#pragma once
#include <comdef.h>
#include ".\helper.h"

#define MK_ERRORCODE(ErCodeEx,ErCode) ((ULONGLONG)(((DWORD)(ErCode)) | ((ULONGLONG)((DWORD)(ErCodeEx))) << 32))
#define ERRORCODE(err) ((DWORD)(err))
#define ERRORCODEEX(err) ((DWORD)(((ULONGLONG)(err) >> 32) & 0xFFFFFFFF))

#define TV_SUCCEEDED(err) ((ERRORCODE(err)&0x00020000)==0x00000000)	//Գɹ;淵棬ؼ
#define TV_FAILED(err) ((ERRORCODE(err)&0x00020000)==0x00020000)	//һش󷵻

#define TV_IS_SUCCESS(err) ((ERRORCODE(err)&0x00030000)==0x00000000)	//ȫɹ޾棩
#define TV_IS_WARNING(err) ((ERRORCODE(err)&0x00030000)==0x00010000) //Ծ淵
#define TV_IS_GENERAL_ERROR(err) ((ERRORCODE(err)&0x00030000)==0x00020000) //һ󷵻
#define TV_IS_FATAL_ERROR(err) ((ERRORCODE(err)&0x00030000)==0x00030000) //ش󷵻

class CTVException
{
private:
	long m_dwErrorCode;	//32λȡö
	long m_dwErrorCodeEx;	//32λչ
	CString m_strErrorDesc; //չĴ
	CString m_strContext;	//
	void Init(DWORD dwErrorCode,DWORD dwErrorCodeEx,LPCTSTR lpszErrorDesc,LPCTSTR lpszContext)
	{
		m_dwErrorCode = dwErrorCode;
		m_dwErrorCodeEx = dwErrorCodeEx;
		m_strErrorDesc = lpszErrorDesc;
		m_strContext = lpszContext;
	}

public:
	//
	enum ErrorCode
	{
		//SUCCESS
		S_SUCCESS						=0x00000000,

		//WARNING

		//GERENAL ERROR

		//FATAL ERROR
		E_HRESULT_ERROR					=0x80000001,
		E_SYSTEM_ERROR					=0x80000002,
		E_VIDEO_INPUT_DEV_NOT_FOUND		=0x80000003,
		E_AUDIO_INPUT_DEV_NOT_FOUND		=0x80000004,
		E_VIDEO_INPUT_DEV_NOT_ASSIGNED	=0x80000005,
		E_AUDIO_INPUT_DEV_NOT_ASSIGNED	=0x80000006,
		E_GRAPH_NOT_INITIALIZE			=0x80000007,
		E_FILE_NOT_FOUND				=0x80000008,
		E_PROFILE_VIDEO_ERROR			=0x80000009,
		E_RENDER_FILE_FAILED			=0x8000000A,

		//Unknown Error
		//E_HRESULT_UNKNOWN				=0x80000002,
		//ָʾSetLastErrorʹ󼶱𣬴뱻½ΪTV_SUCCESSTV_HRESULT_ERROR

		//E_SYSTEM_UNKNOWN				=0x80000003
		//ָʾSetLastErrorʹ󼶱𣬴뱻½ΪTV_SUCCESSTV_SYSTEM_ERROR
	};

	//캯
	CTVException(DWORD dwErrorCode,DWORD dwErrorCodeEx,LPCTSTR lpszErrorDesc,LPCTSTR lpszContext=NULL)
	{
		Init(dwErrorCode,dwErrorCodeEx,lpszErrorDesc,lpszContext);
	}
	CTVException(ULONGLONG ullError,LPCTSTR lpszErrorDesc,LPCTSTR lpszContext=NULL)
	{
		Init(ERRORCODE(ullError),ERRORCODEEX(ullError),lpszErrorDesc,lpszContext);
	}
	//
	~CTVException()
	{
	}
public:
	//ȡ,nLanguageΪ
	CString ErrorMessage(int nLanguage=0/*0x0804*/);
	//ش
	CString ErrorDesc(){return m_strErrorDesc;}
	//return context
	CString Context(){return m_strContext;}
	//ȡ룬64λĴ
	ULONGLONG ErrorCode(){return MK_ERRORCODE(m_dwErrorCodeEx,m_dwErrorCode);};
	//ʾnLanguageΪ
	//μAfxMessageBoxĶӦ˵
	int ReportError(UINT nType = MB_OK, UINT nIDHelp = 0,int nLanguage=0x0804);
};

void HandleTVException(DWORD dwError,CString strErrorDesc,CString strContext);
void HandleHRException(HRESULT hr,CString strErrorDesc,CString strContext);
void HandleWin32Exception(DWORD dwError,CString strErrorDesc,CString strContext);

//tv exception
#define HANDLE_TV_EXP(dwError) \
	HandleTVException(dwError,_T(""),CString(__FILE__)+CString(_T(",line "))+IntToStr(__LINE__)+CString(_T(",func ")));
#define HANDLE_TV_EXP_V(dwError,strDesc) \
	HandleTVException(dwError,strDesc,CString(__FILE__)+CString(_T(",line "))+IntToStr(__LINE__)+CString(_T(",func "))); //+CString(__FUNCTION__)
//hresult exception
#define HANDLE_HR_EXP(hr) \
	HandleHRException(hr,_T(""),CString(__FILE__)+CString(_T(",line "))+IntToStr(__LINE__)+CString(_T(",func ")));
#define HANDLE_HR_EXP_V(hr,strDesc) \
	HandleHRException(hr,strDesc,CString(__FILE__)+CString(_T(",line "))+IntToStr(__LINE__)+CString(_T(",func ")));
//win32 exception
#define HANDLE_WIN32_EXP(dwError) \
	HandleWin32Exception(dwError,_T(""),CString(__FILE__)+CString(_T(",line "))+IntToStr(__LINE__)+CString(_T(",func ")));
#define HANDLE_WIN32_EXP_V(dwError,strDesc) \
	HandleWin32Exception(dwError,strDesc,CString(__FILE__)+CString(_T(",line "))+IntToStr(__LINE__)+CString(_T(",func ")));

inline void ThrowComError(HRESULT hr,IUnknown* p)
{
	if (FAILED(hr)) _com_issue_errorex(hr, p, __uuidof(p));
}

void LogInfo(CString strDesc,CString strContext);
#define LOG(strDesc) \
	LogInfo(strDesc,CString(__FILE__)+",line "+IntToStr(__LINE__)+",func "); //+CString(__FUNCTION__)
