//-----------------------------------------------------------------------------
// 
// Desc: Aufruf der WaveletAnalyse 
//       
//-----------------------------------------------------------------------------
#include "filtercoeffs.h"
#include "wavelets.h"

VOID CSoundsDoc::DoWavelet(int FFTPoints)
{
	CArray<DOUBLE,DOUBLE> ZeitreiheGross;
	INT i=0;
	ZeitreiheGross.Copy(m_ZeitreiheArray);
	INT SizeArray=ZeitreiheGross.GetSize();
	if (SizeArray<FFTPoints) 
	{
		while (i<(FFTPoints-SizeArray))
		{
			ZeitreiheGross.Add(0);
			i++;
		}
	}

	//Durchfhren der Transformation
//	WaveletCoeffs WaveletCoeffs;
	m_pWaveletTransformObjekt->forwardTransform(ZeitreiheGross.GetData(),FFTPoints,m_pWaveletCoeffs,NULL);
//	m_pWaveletCoeffs=&WaveletCoeffs;
}

void gen_freqMix( double *vecX, double *vecY, size_t N)
{
  const double PI = 3.1415926535897932384626433832795;
  const double range = 2 * PI;
  const double incr = range / (double)N;

  double point = 0.0;
  int i;
  for (i = 0; i < N; i++) {
    vecX[i] = point;
    vecY[i] = 4 * sin( 64 * point ) + 
              2 * sin( 32 * point ) + 
              1 * sin( 16 * point ) +
            0.5 * sin( 8  * point );
    // printf("%7.4g, %7.4g\n", vecX[i], vecY[i] );
    point = point + incr;
  }
} // gen_freqMix

#include "haar_classicFreq.h"
#include "packfreq.h"
#include "daub.h"
#include "biortho.h"

VOID CSoundsDoc::DoWaveletPacket(int FFTPoints)
{
	CArray<DOUBLE,DOUBLE> ZeitreiheGross;
	INT i=0;
	ZeitreiheGross.Copy(m_ZeitreiheArray);
	INT SizeArray=ZeitreiheGross.GetSize();
	if (SizeArray<FFTPoints) 
	{
		while (i<(FFTPoints-SizeArray))
		{
			ZeitreiheGross.Add(0);
			i++;
		}
	}

	//Durchfhren der Transformation

  mem_pool.init_pool();

  const size_t N = FFTPoints;
//  double vecX[N], vecY[N];
//	double* vecX = new double [N];
//	double* vecY = new double [N];
	
  // gen_chirp( vecX, vecY, N );
  // gen_steps( vecX, vecY, N, 8 );
//  gen_freqMix( vecX, vecY, N );
  // gen_sinCombo( vecX, vecY, N );
  // prVec( vecY, N );
  // prCoords( vecX, vecY, N );

  // The "Haar" classic transform
//		haar_classicFreq<packcontainer> h;
   Daubechies<packcontainer> h;
//   Daubechies16<packcontainer> h;

  // calculate the wavelet packet tree, using the wavelet transform h
  packfreq tree( ZeitreiheGross.GetData(), N, &h );
  // packfreq tree( data, N, &h );
  
  // tree.pr();
  // printf("\n");


	int Level=(int)(log10(FFTPoints)/log10(2))-5;

  tree.getLevel( Level );

	m_WaveletPacketArray.RemoveAll();
	tree.plotMat(N,&m_WaveletPacketArray);

  // free the memory pool
//  block_pool mem_pool;
  mem_pool.free_pool();
//	delete [] vecX;
//	delete [] vecY;

}