// WaveletView.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "WaveletView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWaveletView

IMPLEMENT_DYNCREATE(CWaveletView, CView)

CWaveletView::CWaveletView()
{
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->AppendMenu(MF_STRING|MF_ENABLED,ID_FENSTER_WAVELET,"Waveletanalyse");
	AfxGetMainWnd()->DrawMenuBar();
}

void CWaveletView::IniFileWrite()
{
	CSoundsDoc* pDoc=GetDocument();
	CWaveletTrafo* pWaveletTrafo=pDoc->GetWaveletTrafo();
	m_wavelet=pWaveletTrafo->m_arguments.wavelet;
	m_Freq_min=pWaveletTrafo->m_arguments.a.min;
	m_Freq_max=pWaveletTrafo->m_arguments.a.max;
	m_Freq_n=pWaveletTrafo->m_arguments.a.n;
	m_Zeit_n=pWaveletTrafo->m_arguments.b.n;
	switch(pWaveletTrafo->m_arguments.adiv) 
	{
	case linear:
		m_adiv=0;
		break;
	case reciprocal:
		m_adiv=1;
		break;
	case exponential:
		m_adiv=2;
		break;
	}
	//INIFile Werte schreiben
	*theApp.GetIniWaveletWavelet()=m_wavelet;
	*theApp.GetIniWaveletFreqmin()=m_Freq_min;
	*theApp.GetIniWaveletFreqmax()=m_Freq_max;
	*theApp.GetIniWaveletFreqn()=m_Freq_n;
	*theApp.GetIniWaveletZeitn()=m_Zeit_n;
	*theApp.GetIniWaveletadiv()=m_adiv;
}

void CWaveletView::IniFileRead()
{
	//INIFileWerte einlesen
	m_wavelet=*theApp.GetIniWaveletWavelet();
	m_Freq_min=*theApp.GetIniWaveletFreqmin();
	m_Freq_max=*theApp.GetIniWaveletFreqmax();
	m_Freq_n=*theApp.GetIniWaveletFreqn();
	m_Zeit_n=*theApp.GetIniWaveletZeitn();
	m_adiv=*theApp.GetIniWaveletadiv();
}

CWaveletView::~CWaveletView()
{
	IniFileWrite();
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->RemoveMenu(ID_FENSTER_WAVELET,MF_BYCOMMAND);
	AfxGetMainWnd()->DrawMenuBar();
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->m_pViewWavelet=NULL;
}


BEGIN_MESSAGE_MAP(CWaveletView, CView)
	//{{AFX_MSG_MAP(CWaveletView)
	ON_EN_CHANGE(IDC_FREQ_MAX, OnChangeFreqMax)
	ON_EN_CHANGE(IDC_FREQ_MIN, OnChangeFreqMin)
	ON_EN_CHANGE(IDC_FREQ_N, OnChangeFreqN)
	ON_EN_CHANGE(IDC_ZEIT_N, OnChangeZeitN)
	ON_CBN_SELENDOK(IDC_FREQ_SKALA_COMBO, OnSelendokFreqSkalaCombo)
	ON_CBN_SELENDOK(IDC_WAVELETTYP_COMBO, OnSelendokWavelettypCombo)
	ON_EN_CHANGE(IDC_WAVELET_PARAM, OnChangeWaveletParam)
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_SAVE, OnSave)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Diagnose CWaveletView

#ifdef _DEBUG
void CWaveletView::AssertValid() const
{
	CView::AssertValid();
}

void CWaveletView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG


BOOL CWaveletView::CreatePaletteBlackToWhite(CPalette* pPal)
{
	const int nNumColors = 1792;
	BOOL bSucc=FALSE;
	LPLOGPALETTE lpPal = (LPLOGPALETTE)new BYTE[sizeof(LOGPALETTE) + sizeof(PALETTEENTRY) *	nNumColors];
	
	if (lpPal != NULL)
	{
		lpPal->palVersion = 0x300;
		lpPal->palNumEntries = nNumColors;
		
		PALETTEENTRY *ppe = lpPal->palPalEntry;
		

		for (int nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(nIndex);
			ppe->peGreen = (BYTE)(0);
			ppe->peBlue = (BYTE)(0);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}

		for (nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(255);
			ppe->peGreen = (BYTE)(nIndex);
			ppe->peBlue = (BYTE)(0);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
		for (nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(255-nIndex);
			ppe->peGreen = (BYTE)(255);
			ppe->peBlue = (BYTE)(0);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
		for (nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(0);
			ppe->peGreen = (BYTE)(255);
			ppe->peBlue = (BYTE)(nIndex);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
		for (nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(0);
			ppe->peGreen = (BYTE)(255-nIndex);
			ppe->peBlue = (BYTE)(255);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}

		for (nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(nIndex);
			ppe->peGreen = (BYTE)(0);
			ppe->peBlue = (BYTE)(255);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
		for (nIndex = 0; nIndex < 256; nIndex++)
		{
			ppe->peRed = (BYTE)(255);
			ppe->peGreen = (BYTE)(nIndex);
			ppe->peBlue = (BYTE)(255);
			ppe->peFlags = (BYTE)0;
			ppe++;
		}
		
		bSucc = pPal->CreatePalette(lpPal);
		
		delete [](PBYTE)lpPal;
	}
	
	return bSucc;
}
/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CWaveletView 

void CWaveletView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	m_clrBkg=RGB(0,0,0);
	m_clrText=RGB(255,255,255);
	m_pParentWaveletFrame=(CWaveletFrame*)GetParentFrame();

	IniFileRead();

	CSoundsDoc* pDoc=GetDocument();
	CWaveletTrafo* pWaveletTrafo=pDoc->GetWaveletTrafo();
	pWaveletTrafo->m_arguments.wavelet=m_wavelet;
	pWaveletTrafo->m_arguments.a.min=m_Freq_min;
	pWaveletTrafo->m_arguments.a.max=m_Freq_max;
	pWaveletTrafo->m_arguments.a.n=m_Freq_n;
	pWaveletTrafo->m_arguments.b.n=m_Zeit_n;

	switch(m_adiv) 
	{
	case 0:
		pWaveletTrafo->m_arguments.adiv=linear;
		break;
	case 1:
		pWaveletTrafo->m_arguments.adiv=reciprocal;
		break;
	case 2:
		pWaveletTrafo->m_arguments.adiv=exponential;
		break;
	}

	char *wavelet_arguments = NULL;
	INT WaveletNumber;
	CString WaveletParams;
	if(pWaveletTrafo->is_prefix(m_wavelet,"haar",wavelet_arguments)) {WaveletNumber=0;} else
	if(pWaveletTrafo->is_prefix(m_wavelet,"mexicanhat",wavelet_arguments)) {WaveletNumber=1;} else
	if(pWaveletTrafo->is_prefix(m_wavelet,"sinus",wavelet_arguments)) {WaveletNumber=2;} else
	if(pWaveletTrafo->is_prefix(m_wavelet,"poisson",wavelet_arguments)) {WaveletNumber=3;} else
	if(pWaveletTrafo->is_prefix(m_wavelet,"cauchy",wavelet_arguments)) {WaveletNumber=4;} else
	if(pWaveletTrafo->is_prefix(m_wavelet,"spinning",wavelet_arguments)) {WaveletNumber=5;} else
	if(pWaveletTrafo->is_prefix(m_wavelet,"morlet",wavelet_arguments)) {WaveletNumber=6;} else
	if(pWaveletTrafo->is_prefix(m_wavelet,"bspline",wavelet_arguments)) {WaveletNumber=7;	}

	CSpinButtonCtrl* pSlider;
	pSlider=(CSpinButtonCtrl*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_ZEIT_N_SPIN);
 	pSlider->SetRange(1,999);
	pSlider->SetBuddy(m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_ZEIT_N));
	pSlider->SetPos(m_Zeit_n);
	pSlider=(CSpinButtonCtrl*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_FREQ_N_SPIN);
 	pSlider->SetRange(1,999);
	pSlider->SetBuddy(m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_FREQ_N));
	pSlider->SetPos(m_Freq_n);
	pSlider=(CSpinButtonCtrl*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_FREQ_MIN_SPIN);
 	pSlider->SetRange(1,96000);
	pSlider->SetBuddy(m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_FREQ_MIN));
	pSlider->SetPos((INT)(1.0f/m_Freq_min));
	pSlider=(CSpinButtonCtrl*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_FREQ_MAX_SPIN);
 	pSlider->SetRange(1,96000);
	pSlider->SetBuddy(m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_FREQ_MAX));
	pSlider->SetPos((INT)(1.0f/m_Freq_max));
	CComboBox* pCombo;
	pCombo=(CComboBox*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_WAVELETTYP_COMBO);
	pCombo->SetCurSel(WaveletNumber);
	CEdit* pEdit;
	pEdit=(CEdit*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_WAVELET_PARAM);
	pEdit->SetWindowText(wavelet_arguments);
	OnSelendokWavelettypCombo();
	pCombo=(CComboBox*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_FREQ_SKALA_COMBO);
	pCombo->SetCurSel(m_adiv);
	
	//Farbpalette erstellen
	if (!CreatePaletteBlackToWhite(&m_Pal)) 
		AfxMessageBox(E_WAVELETVIEW_CREATEPALETTE);
}

/////////////////////////////////////////////////////////////////////////////
// Zeichnung CWaveletView 

void CWaveletView::OnDraw(CDC* dc)
{
	CMemDC pDC(dc);
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CRect rect;
	GetClientRect(rect);
	pDC->SelectPalette(&m_Pal, FALSE);
	pDC->RealizePalette();
//	pDC->SetBkMode(TRANSPARENT);
	pDC->FillSolidRect(rect,m_clrBkg);

//Continuous WaveletTrafo
	CArray<FLOAT,FLOAT>* pPGMArray=pDoc->GetPGMArray();

	INT SizeArray=pPGMArray->GetSize();
	if (SizeArray>5) 
	{
		FLOAT EinteilungenFrequenzAchse=pPGMArray->GetAt(0);
		FLOAT EinteilungenZeitAchse=pPGMArray->GetAt(1);

		FLOAT Frequenzhoehe=rect.bottom/EinteilungenFrequenzAchse;
		FLOAT Zeitbreite=rect.right/EinteilungenZeitAchse;
		for (INT j=0; j<EinteilungenFrequenzAchse;j++ ) 
		{
			for ( int i=0; i<EinteilungenZeitAchse; i++) 
			{
				FLOAT fWertPuffer=pPGMArray->GetAt((int)(j*EinteilungenZeitAchse)+i+2);
				CPen Stift;
				COLORREF Farbe=PALETTEINDEX((INT)(fWertPuffer*1792/255));
				Stift.CreatePen(PS_SOLID,1,Farbe);
				pDC->SelectObject(&Stift);
				pDC->Rectangle((INT)(i*Zeitbreite),(INT)(rect.bottom-j*Frequenzhoehe),(INT)((i+1)*Zeitbreite),(INT)(rect.bottom-(j+1)*Frequenzhoehe));
				pDC->FillSolidRect((INT)(i*Zeitbreite),(INT)(rect.bottom-j*Frequenzhoehe),(INT)Zeitbreite,(INT)Frequenzhoehe,Farbe);
			}
		}
	}
	else
	{
		CAutoFont font("Century Gothic");
		font.SetDC(pDC->GetSafeHdc());
		font.SetHeight(15);
		font.SetFontColor(m_clrText);

		CFont *oldFont=pDC->SelectObject(&font);
		pDC->SetBkMode(TRANSPARENT);
		pDC->SetTextColor(font.GetFontColor());
		CString strHint;
		strHint.LoadString(IDS_NEEDMOREPOINTS_WAVELET);
		pDC->DrawText(strHint,rect,DT_TOP|DT_CENTER|DT_WORDBREAK);

	}


	//Waveletimplementation von Florian (Wavelet Packet Tree)
/*
	WaveletCoeffs* pWaveletCoeffs=pDoc->GetWaveletCoeffs();
	INT Levels=pWaveletCoeffs->getLevelCount();
	if (Levels!=0) 
	{
		DOUBLE MaxAmp=0,MinAmp=0;
		for (INT j=0; j<=Levels-1;j++ ) 
		{
			INT count=0;
			double* dblWertPuffer=(double*)pWaveletCoeffs->getDetails(j,&count);
			for ( int i=0; i<count; i++) 
			{
				if (dblWertPuffer[i]>MaxAmp) MaxAmp=dblWertPuffer[i];
				else if (dblWertPuffer[i]<MinAmp) MinAmp=dblWertPuffer[i];
			}
		}

		FLOAT Levelhoehe=rect.bottom/(float)(Levels);
		for (j=0; j<=Levels-1;j++ ) 
		{
			INT count=0;
			double* dblWertPuffer=(double*)pWaveletCoeffs->getDetails(j,&count);
			FLOAT Levelbreite=rect.right/(float)(count);
			for ( int i=0; i<count; i++) 
			{
				CPen Stift;
				COLORREF Farbe=PALETTEINDEX((INT)(((INT)(-MinAmp)+dblWertPuffer[i])*1792/(-MinAmp+MaxAmp)));
				Stift.CreatePen(PS_SOLID,1,Farbe);
				pDC->SelectObject(&Stift);
				pDC->Rectangle((INT)(i*Levelbreite),(INT)(j*Levelhoehe),(INT)((i+1)*Levelbreite),(INT)((j+1)*Levelhoehe));
				pDC->FillSolidRect((INT)(i*Levelbreite),(INT)(j*Levelhoehe),(INT)Levelbreite,(INT)Levelhoehe,Farbe);
			}
		}
	}

*/

	//Wavelet Packet Transform nach Bearcave
/*
	CArray<DOUBLE,DOUBLE>* pWaveletCoeffs=pDoc->GetWaveletPacketArray();
	if (pWaveletCoeffs->GetSize()>10) 
	{
		INT Zeiten=pWaveletCoeffs->GetAt(0);
		INT Frequenzen=pWaveletCoeffs->GetAt(1);
		DOUBLE MaxAmp=0,MinAmp=0;
		for (INT j=0; j<Frequenzen;j++ ) 
		{
			for ( int i=0; i<Zeiten; i++) 
			{
				float fWertPuffer=pWaveletCoeffs->GetAt(j*32+i+2);
				if (fWertPuffer>MaxAmp) MaxAmp=fWertPuffer;
				else if (fWertPuffer<MinAmp) MinAmp=fWertPuffer;
			}
		}

		FLOAT Levelhoehe=rect.bottom/(float)(Frequenzen);
		FLOAT Levelbreite=rect.right/(float)(Zeiten);
		for (j=0; j<Frequenzen;j++ ) 
		{
			for ( int i=0; i<Zeiten; i++) 
			{
				float fWertPuffer=pWaveletCoeffs->GetAt(j*32+i+2);
				CPen Stift;
				COLORREF Farbe=PALETTEINDEX((INT)(((INT)(-MinAmp)+fWertPuffer)*1792/(-MinAmp+MaxAmp)));
				Stift.CreatePen(PS_SOLID,1,Farbe);
				pDC->SelectObject(&Stift);
				pDC->Rectangle((INT)(i*Levelbreite),(INT)(j*Levelhoehe),(INT)((i+1)*Levelbreite),(INT)((j+1)*Levelhoehe));
				pDC->FillSolidRect((INT)(i*Levelbreite),(INT)(j*Levelhoehe),(INT)Levelbreite,(INT)Levelhoehe,Farbe);
			}
		}
	}
*/
}


void CWaveletView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (g_bIsPutPoints)
	{
		Invalidate(TRUE);
	}
	if (lHint==0)
	{
		Invalidate(TRUE);
	}
	if (lHint==11)
	{
		Invalidate(TRUE);
	}
}

void CWaveletView::OnChangeFreqMax() 
{
	CSoundsDoc* pDoc=GetDocument();
	CWaveletTrafo* pTrafo=pDoc->GetWaveletTrafo();
	CString Wert;
	char* pstr;
	m_pParentWaveletFrame->m_wndDlgBar.GetDlgItemText(IDC_FREQ_MAX,Wert);
	Wert.Replace(".","");
	DOUBLE dWert=strtod(Wert.GetBuffer(100),&pstr);
	pTrafo->m_arguments.a.max=1.0f/dWert;
//	pTrafo->SetArguments();
}

void CWaveletView::OnChangeFreqMin() 
{
	CSoundsDoc* pDoc=GetDocument();
	CWaveletTrafo* pTrafo=pDoc->GetWaveletTrafo();
	CString Wert;
	char* pstr;
	m_pParentWaveletFrame->m_wndDlgBar.GetDlgItemText(IDC_FREQ_MIN,Wert);
	Wert.Replace(".","");
	DOUBLE dWert=strtod(Wert.GetBuffer(100),&pstr);
	pTrafo->m_arguments.a.min=1.0f/dWert;
//	pTrafo->SetArguments();
}

void CWaveletView::OnChangeFreqN() 
{
	CSoundsDoc* pDoc=GetDocument();
	CWaveletTrafo* pTrafo=pDoc->GetWaveletTrafo();
	pTrafo->m_arguments.a.n=m_pParentWaveletFrame->m_wndDlgBar.GetDlgItemInt(IDC_FREQ_N);
//	pTrafo->SetArguments();
}

void CWaveletView::OnChangeZeitN() 
{
	CSoundsDoc* pDoc=GetDocument();
	CWaveletTrafo* pTrafo=pDoc->GetWaveletTrafo();
	pTrafo->m_arguments.b.n=m_pParentWaveletFrame->m_wndDlgBar.GetDlgItemInt(IDC_ZEIT_N);
//	pTrafo->SetArguments();
}

void CWaveletView::OnSelendokFreqSkalaCombo() 
{
	CSoundsDoc* pDoc=GetDocument();
	CWaveletTrafo* pTrafo=pDoc->GetWaveletTrafo();
	CComboBox* pCombo=(CComboBox*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_FREQ_SKALA_COMBO);
	INT SkalaNr=pCombo->GetCurSel();
	switch(SkalaNr) {
	case 0:
		pTrafo->m_arguments.adiv=linear;
		break;
	case 1:
		pTrafo->m_arguments.adiv=reciprocal;
		break;
	case 2:
		pTrafo->m_arguments.adiv=exponential;
		break;
	} 
//	pTrafo->SetArguments();
}

void CWaveletView::OnSelendokWavelettypCombo() 
{
	CSoundsDoc* pDoc=GetDocument();
	CWaveletTrafo* pTrafo=pDoc->GetWaveletTrafo();
	CComboBox* pCombo=(CComboBox*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_WAVELETTYP_COMBO);
	CEdit* pEdit=(CEdit*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_WAVELET_PARAM);
	CEdit* pEdit2=(CEdit*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_PARAM_STATIC);
	CEdit* pEdit3=(CEdit*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_PARAM_DESC);
	INT WaveletNr=pCombo->GetCurSel();
	CString strWavelet,Parameter;
	CString Text;
	switch(WaveletNr) {
	case 0:
		strWavelet="haar";
		pEdit->ShowWindow(SW_HIDE);
		pEdit2->ShowWindow(SW_HIDE);
		Text.LoadString(IDS_WAVELET_HAAR);
		pEdit3->SetWindowText(Text);
		m_Komplett=strWavelet;
		break;
	case 1:
		strWavelet="mexicanhat";
		pEdit->ShowWindow(SW_HIDE);
		pEdit2->ShowWindow(SW_HIDE);
		Text.LoadString(IDS_WAVELET_MEXICANHAT);
		pEdit3->SetWindowText(Text);
		m_Komplett=strWavelet;
		break;
	case 2:
		strWavelet="sinus";
		pEdit->ShowWindow(SW_HIDE);
		pEdit2->ShowWindow(SW_HIDE);
		Text.LoadString(IDS_WAVELET_SINUS);
		pEdit3->SetWindowText(Text);
		m_Komplett=strWavelet;
		break;
	case 3:
		strWavelet="poisson";
		pEdit->ShowWindow(SW_HIDE);
		pEdit2->ShowWindow(SW_HIDE);
		Text.LoadString(IDS_WAVELET_POISSON);
		pEdit3->SetWindowText(Text);
		m_Komplett=strWavelet;
		break;
	case 4:
		strWavelet="cauchy";
		pEdit->ShowWindow(SW_SHOW);
		pEdit->SetWindowText("2");
		pEdit2->ShowWindow(SW_SHOW);
		Text.LoadString(IDS_WAVELET_CAUCHY);
		pEdit3->SetWindowText(Text);
		pEdit->GetWindowText(Parameter);
		m_Komplett=strWavelet+","+Parameter;
		break;
	case 5:
		strWavelet="spinning";
		pEdit->ShowWindow(SW_SHOW);
		pEdit->SetWindowText("2,2");
		pEdit2->ShowWindow(SW_SHOW);
		Text.LoadString(IDS_WAVELET_SPINNING);
		pEdit3->SetWindowText(Text);
		pEdit->GetWindowText(Parameter);
		m_Komplett=strWavelet+","+Parameter;
		break;
	case 6:
		strWavelet="morlet";
		pEdit->ShowWindow(SW_SHOW);
		pEdit->SetWindowText("2");
		pEdit2->ShowWindow(SW_SHOW);
		Text.LoadString(IDS_WAVELET_MORLET);
		pEdit3->SetWindowText(Text);
		pEdit->GetWindowText(Parameter);
		m_Komplett=strWavelet+","+Parameter;
		break;
	case 7:
		strWavelet="bspline";
		pEdit->ShowWindow(SW_SHOW);
		pEdit->SetWindowText("10,10");
		pEdit2->ShowWindow(SW_SHOW);
		Text.LoadString(IDS_WAVELET_BSPLINE);
		pEdit3->SetWindowText(Text);
		pEdit->GetWindowText(Parameter);
		m_Komplett=strWavelet+","+Parameter;
		break;
	} 
	pTrafo->m_arguments.wavelet=m_Komplett;
}

void CWaveletView::OnChangeWaveletParam() 
{
	CSoundsDoc* pDoc=GetDocument();
	CWaveletTrafo* pTrafo=pDoc->GetWaveletTrafo();
	CComboBox* pCombo=(CComboBox*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_WAVELETTYP_COMBO);
	CEdit* pEdit=(CEdit*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_WAVELET_PARAM);
	CEdit* pEdit2=(CEdit*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_PARAM_STATIC);
	CEdit* pEdit3=(CEdit*)m_pParentWaveletFrame->m_wndDlgBar.GetDlgItem(IDC_PARAM_DESC);
	INT WaveletNr=pCombo->GetCurSel();
	CString strWavelet,Parameter;
	pEdit->GetWindowText(Parameter);
	switch(WaveletNr) {
	case 0:
		strWavelet="haar";
		m_Komplett=strWavelet;
		break;
	case 1:
		strWavelet="mexicanhat";
		m_Komplett=strWavelet;
		break;
	case 2:
		strWavelet="sinus";
		m_Komplett=strWavelet;
		break;
	case 3:
		strWavelet="poisson";
		m_Komplett=strWavelet;
		break;
	case 4:
		strWavelet="cauchy";
		m_Komplett=strWavelet+","+Parameter;
		break;
	case 5:
		strWavelet="spinning";
		m_Komplett=strWavelet+","+Parameter;
		break;
	case 6:
		strWavelet="morlet";
		m_Komplett=strWavelet+","+Parameter;
		break;
	case 7:
		strWavelet="bspline";
		m_Komplett=strWavelet+","+Parameter;
		break;
	} 
	pTrafo->m_arguments.wavelet=m_Komplett;
//	pTrafo->SetArguments();
}


BOOL CWaveletView::OnEraseBkgnd(CDC* pDC) 
{
		return FALSE;
//	return CView::OnEraseBkgnd(pDC);
}

CRect CWaveletView::DetermineRect(CDC* RefDC)
{
	// Determine the picture frame dimensions. 
	// iWidthMM is the display width in millimeters. 
	// iHeightMM is the display height in millimeters. 
	// iWidthPels is the display width in pixels. 
	// iHeightPels is the display height in pixels 
 
	INT iWidthMM = GetDeviceCaps(RefDC->GetSafeHdc(), HORZSIZE); 
	INT iHeightMM = GetDeviceCaps(RefDC->GetSafeHdc(), VERTSIZE); 
	INT iWidthPels = GetDeviceCaps(RefDC->GetSafeHdc(), HORZRES); 
	INT iHeightPels = GetDeviceCaps(RefDC->GetSafeHdc(), VERTRES); 
 
	// Retrieve the coordinates of the client rectangle, in pixels. 
	CRect rect;
	GetClientRect(rect); 
 
	// Convert client coordinates to .01-mm units. 
	// Use iWidthMM, iWidthPels, iHeightMM, and 
	// iHeightPels to determine the number of 
	// .01-millimeter units per pixel in the x- 
	//  and y-directions. 
 
	rect.left = (rect.left * iWidthMM * 100)/iWidthPels; 
	rect.top = (rect.top * iHeightMM * 100)/iHeightPels; 
	rect.right = (rect.right * iWidthMM * 100)/iWidthPels; 
	rect.bottom = (rect.bottom * iHeightMM * 100)/iHeightPels; 

	return rect;
}

void CWaveletView::OnSave() 
{
	// Obtain a handle to a reference device context. 
	CDC* RefDC = GetDC(); 
 
	CRect rect=DetermineRect(RefDC);
	// Load the filename Dialog
	CFileDialog ViewFileDlg(FALSE,NULL,NULL,OFN_OVERWRITEPROMPT|OFN_NOREADONLYRETURN|OFN_ENABLESIZING,\
              "WMF - Enhanced Metafile|*.wmf|");
  ViewFileDlg.m_ofn.nFilterIndex=1;
	ViewFileDlg.m_ofn.lpstrDefExt=".wmf";
	ViewFileDlg.m_ofn.lpstrTitle="Speichert diese Waveletansicht...";
  if (ViewFileDlg.DoModal()==IDOK) 
	{
		// Create the metafile device context. 
		CString Pfad=ViewFileDlg.GetPathName();
		LPTSTR strFileName=Pfad.GetBuffer(MAX_PATH);
		CMetaFileDC MetaFileDC;
		MetaFileDC.CreateEnhanced(RefDC,strFileName,rect,"SOUNDS Soundanalyse\0Wavelet Abbild\0\0");

		//The self-defined palette could not be read by the MetafileDC (reason unknown)
		//so we have to BitBlt instead of OnDraw(&MetaFileDC);
		GetClientRect(rect);
		MetaFileDC.BitBlt(0,0,rect.right,rect.bottom,RefDC,0,0,SRCCOPY);
		HENHMETAFILE pMetaFile=MetaFileDC.CloseEnhanced();
		DeleteEnhMetaFile(pMetaFile);
	}
	// Release the reference device context. 
	ReleaseDC(RefDC); 
}

void CWaveletView::OnEditCopy() 
{
	// Obtain a handle to a reference device context. 
	CDC* RefDC = GetDC(); 
 
	CRect rect=DetermineRect(RefDC);

	CMetaFileDC MetaFileDC;
	MetaFileDC.CreateEnhanced(RefDC,NULL,rect,"SOUNDS Soundanalyse\0Wavelet Abbild\0\0");

	//The self-defined palette could not be read by the MetafileDC (reason unknown)
	//so we have to BitBlt instead of OnDraw(&MetaFileDC);
	GetClientRect(rect);
	MetaFileDC.BitBlt(0,0,rect.right,rect.bottom,RefDC,0,0,SRCCOPY);

	HENHMETAFILE pMetaFile=MetaFileDC.CloseEnhanced();
	
	//copy to clipboard
	// Open the clipboard...
	if(!OpenClipboard()) 
	{
    AfxMessageBox(IDS_OPEN_CLIPBOARD_FAIL);
    return;
	}
	EmptyClipboard();
	::SetClipboardData(CF_ENHMETAFILE,pMetaFile);
	CloseClipboard();

	DeleteEnhMetaFile(pMetaFile);
}
