#if !defined(AFX_FFTVIEW_H__FFFC2569_A7CE_4AFF_8412_A8FB4BD9A8C4__INCLUDED_)
#define AFX_FFTVIEW_H__FFFC2569_A7CE_4AFF_8412_A8FB4BD9A8C4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FFTView.h : Header-Datei
//
//#include "Generator.h"
/////////////////////////////////////////////////////////////////////////////
// Ansicht CFFTView 

class CFFTView : public CView
{
	DECLARE_DYNCREATE(CFFTView)
protected:
	CFFTView();           // Dynamische Erstellung verwendet geschtzten Konstruktor

// Attributes
protected:
	CArray<POINT,POINT> m_ViewPtFreqArray;
	CArray<POINT,POINT> m_LastViewPtFreqArray;
	COLORREF						m_clrBkg;
	COLORREF						m_clrText;
	COLORREF						m_clrSpline;
	INT									m_BottomCutHz;
	INT									m_TopCutkHz;
	INT									m_BottomCutAmp;
	INT									m_TopCutAmp;

	INT									m_FrequenzbereichFFT;
	DOUBLE							m_BildProzentVonBottomCutHz;
	INT									m_FrequenzbreiteFFTAnsicht;
	
	CSpinButtonCtrl*		m_pBottumCutCtrl;
	CSpinButtonCtrl*		m_pTopCutCtrl;
	CSpinButtonCtrl*		m_pBottumCutAmpCtrl;
	CSpinButtonCtrl*		m_pTopCutAmpCtrl;
	CButton*						m_pRadioAmpLin;
	CButton*						m_pRadioAmpLog;
	CButton*						m_pRadioFreqLin;
	CButton*						m_pRadioFreqLog;
	CButton*						m_pRadioBalken;
	CButton*						m_pRadioLinien;
	CButton*						m_pRadioSaulen;
	CButton*						m_pCheckSpline;
	CEdit*							m_pFFTPointsFeld;
	CFFTFrame*					m_pParentFFTFrame;

	BOOL								m_bIsAmpLinear;
	BOOL								m_bIsFreqLinear;
	INT									m_bDarstellung;
	BOOL								m_bIsSpline;
	BOOL								m_bIsDelay;
	BOOL								m_bIsSumme;
	BOOL								m_Redraw;
	BOOL								m_bIsCrossVisible;
	BOOL								m_bGrid;
	
	int									m_MoveIndex;
	CArray<POINT,POINT> m_ControlPoints;
	CArray<POINT,POINT> m_CtrlControlPoints;
	CArray<POINT,POINT> m_CurvePoints;
	INT									m_SplineTyp;
	INT									m_ZoomV;
	DOUBLE							m_MausFrequenz;
	CArray<DOUBLE,DOUBLE> m_FrequenzenArrayLast;
	int									m_Delay;
	INT									m_MinAbstandMaxima;
	INT									m_MinAbstandNachbarMin;
	INT									m_FrequenzenArrayLaenge;

	// Implementation
public:
  virtual ~CFFTView();
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
  inline CSoundsDoc* GetDocument() { return (CSoundsDoc*)m_pDocument; }
		void		IniFileWrite();
		void		IniFileRead();

protected:
	void ZeichneFrequenzen(CDC* pDC);
	void ZeichneFrequenzWert(CPoint point); 
	void ZeichneDBSkala(CDC* pDC);
	void ZeichneTasten(CDC* pDC);
	void DrawCross(POINT point, COLORREF rgbColor, int extent,CDC* pDC);
	double Distance(const POINT& p1, const POINT& p2);
	int IsInsideControlPoint(POINT& point);

public:
	inline INT* GetTopCutkHz() { return &m_TopCutkHz; }


// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CFFTView)
	protected:
	virtual void OnDraw(CDC* pDC);      // berschrieben zum Zeichnen dieser Ansicht
	virtual void OnInitialUpdate();     // Zum ersten Mal nach der Konstruktion
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementierung
protected:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generierte Nachrichtenzuordnungsfunktionen
	//{{AFX_MSG(CFFTView)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnChangeBottomcutFeld();
	afx_msg void OnChangeTopcutFeld();
	afx_msg void OnScaleAmpLin();
	afx_msg void OnScaleAmpLog();
	afx_msg void OnScaleFreqLin();
	afx_msg void OnScaleFreqLog();
	afx_msg void OnBalken();
	afx_msg void OnLinien();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnCheckSplineB();
	afx_msg void OnCheckSplineC();
	afx_msg void OnCheckSplineBeta();
	afx_msg void OnSave();
	afx_msg void OnEditClearall();
	afx_msg void OnEditCopy();
	afx_msg void OnChangeTopcutampFeld();
	afx_msg void OnChangeBottomcutampFeld();
	afx_msg void OnChangeDelayFeld();
	afx_msg void OnCheckDelay();
	afx_msg void OnCheckSumme();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnChangeAbstandFeld();
	afx_msg void OnCheckPeakkreuz();
	afx_msg void OnSaulen();
	afx_msg void OnChangeAbstandFeld2();
	afx_msg void OnCheckGrid();
	afx_msg void OnExportdata();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_FFTVIEW_H__FFFC2569_A7CE_4AFF_8412_A8FB4BD9A8C4__INCLUDED_
