// filtercoeffs.h

/*
 * Functions for retrieving filter coefficients for wavelets
 * and their description.
 */
#ifndef _FILTERCOEFFS_H_
#define _FILTERCOEFFS_H_

#include <stdlib.h>

#ifdef _DEBUG
//#include "../core/errhandler.h"
#endif

#define MAXIMUM_FILTER_LENGTH 50

typedef struct tWaveletFilterCoeffs {
	char* name;
	bool orthogonal;
	float* lowPassFlipped, *highPassFlipped;
	float* lowPassInverseFlipped, *highPassInverseFlipped;
	int lowPassForwardLength; // = highPassInverseLength
	int highPassForwardLength; // = lowPassInverseLength
	float* sharedHighpass;
} WaveletFilterCoeffs;

/*
 * retrieve the entire set of WaveletFilterCoeffs structs.
 */
extern WaveletFilterCoeffs waveletFilterCoeffs[];

/*
 * The number of elements in the waveletFilterCoeffs array.
 */
extern int getWaveletFilterCoeffsCount();

/*
 * Initializes the filter coefficients. Must be called once
 * before using the filter coefficients.
 */
extern void initWaveletFilterCoeffs();

#endif